
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
** Copyright (c) 2010, Monash University
** All rights reserved.
** Redistribution and use in source and binary forms, with or without modification, GL_COMPILE);
** are permitted provided that the following conditions are met:
**
**       * Redistributions of source code must retain the above copyright notice, GL_COMPILE);
**          this list of conditions and the following disclaimer.
**       * Redistributions in binary form must reproduce the above copyright
**         notice, this list of conditions and the following disclaimer in the
**         documentation and/or other materials provided with the distribution.
**       * Neither the name of the Monash University nor the names of its contributors
**         may be used to endorse or promote products derived from this software
**         without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, GL_COMPILE);
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
** LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
** OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
**
** Contact:
*%  Owen Kaluza - Owen.Kaluza(at)monash.edu
*%
*% Development Team :
*%  http://www.underworldproject.org/aboutus.html
**
**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*** 3D display lists for first 95 characters from the OFL licensed font at:
http://openfontlibrary.org/media/files/narrowhouse/382/FreeUniversal-Regular.ttf

Charset: ASCII 32-127
 !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~■

***/

#include  "FontSans.h"

float font_charwidths[] = {9.000000, 11.046875, 13.531250, 22.359375, 16.765625, 27.828125, 22.968750, 11.046875, 10.781250, 10.781250, 19.687500, 30.000000, 8.265625, 9.578125, 8.265625, 11.890625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 16.765625, 8.265625, 8.265625, 30.000000, 30.000000, 30.000000, 15.500000, 30.000000, 22.500000, 20.187500, 20.390625, 21.593750, 18.187500, 17.078125, 22.828125, 21.265625, 7.828125, 17.046875, 19.921875, 15.875000, 26.921875, 21.687500, 23.203125, 18.656250, 23.531250, 18.875000, 19.828125, 18.375000, 22.093750, 19.593750, 29.156250, 21.093750, 19.953125, 18.453125, 11.890625, 11.890625, 11.890625, 30.000000, 15.000000, 6.890625, 16.546875, 17.703125, 15.609375, 17.718750, 16.703125, 9.875000, 17.703125, 17.171875, 6.890625, 8.578125, 14.937500, 6.890625, 26.859375, 17.203125, 17.750000, 17.953125, 17.953125, 10.875000, 15.093750, 10.484375, 17.171875, 16.031250, 24.406250, 16.406250, 16.031250, 14.031250, 14.625000, 10.343750, 14.625000, 16.000000, 21.0 };

#ifdef _WIN32
#pragma optimize("", off)
#endif
GLuint GenerateFontCharacters()
{
  GLuint charLists = glGenLists(GLYPHS);
  int c = -1;

  glNewList(++c + charLists, GL_COMPILE);
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.125000f,21.656250f);
  glVertex2f(3.921875f,21.656250f);
  glVertex2f(4.625000f,5.062500f);
  glVertex2f(6.421875f,5.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.921875f,2.843750f);
  glVertex2f(3.921875f,0.000000f);
  glVertex2f(6.937500f,0.000000f);
  glVertex2f(6.937500f,2.843750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.453125f,21.656250f);
  glVertex2f(8.296875f,21.656250f);
  glVertex2f(8.968750f,13.015625f);
  glVertex2f(10.781250f,13.015625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.281250f,21.656250f);
  glVertex2f(2.109375f,21.656250f);
  glVertex2f(2.781250f,13.015625f);
  glVertex2f(4.593750f,13.015625f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(18.343750f,7.171875f);
  glVertex2f(14.734375f,9.234375f);
  glVertex2f(14.093750f,7.171875f);
  glVertex2f(14.437500f,15.375000f);
  glVertex2f(13.796875f,13.328125f);
  glVertex2f(10.484375f,15.375000f);
  glVertex2f(9.875000f,13.328125f);
  glVertex2f(10.203125f,21.656250f);
  glVertex2f(8.578125f,9.234375f);
  glVertex2f(8.296875f,15.375000f);
  glVertex2f(7.968750f,7.171875f);
  glVertex2f(7.640625f,13.328125f);
  glVertex2f(6.390625f,9.234375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.390625f,9.234375f);
  glVertex2f(2.140625f,9.234375f);
  glVertex2f(5.765625f,7.171875f);
  glVertex2f(5.828125f,0.000000f);
  glVertex2f(7.968750f,7.171875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.437500f,15.375000f);
  glVertex2f(14.734375f,9.234375f);
  glVertex2f(16.343750f,21.656250f);
  glVertex2f(16.000000f,13.328125f);
  glVertex2f(16.640625f,15.375000f);
  glVertex2f(20.250000f,13.328125f);
  glVertex2f(20.890625f,15.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.546875f,9.234375f);
  glVertex2f(8.578125f,9.234375f);
  glVertex2f(11.890625f,7.171875f);
  glVertex2f(11.984375f,0.000000f);
  glVertex2f(14.093750f,7.171875f);
  glVertex2f(13.796875f,13.328125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.046875f,15.375000f);
  glVertex2f(3.421875f,13.328125f);
  glVertex2f(7.640625f,13.328125f);
  glVertex2f(8.296875f,15.375000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(12.453125f,21.656250f);
  glVertex2f(10.203125f,21.656250f);
  glVertex2f(10.484375f,15.375000f);
  glVertex2f(11.984375f,0.000000f);
  glVertex2f(11.890625f,7.171875f);
  glVertex2f(9.750000f,0.000000f);
  glVertex2f(8.578125f,9.234375f);
  glVertex2f(7.968750f,7.171875f);
  glVertex2f(11.890625f,7.171875f);
  glVertex2f(18.578125f,21.656250f);
  glVertex2f(16.343750f,21.656250f);
  glVertex2f(16.640625f,15.375000f);
  glVertex2f(14.734375f,9.234375f);
  glVertex2f(18.343750f,7.171875f);
  glVertex2f(18.953125f,9.234375f);
  glVertex2f(5.828125f,0.000000f);
  glVertex2f(5.765625f,7.171875f);
  glVertex2f(3.609375f,0.000000f);
  glVertex2f(5.765625f,7.171875f);
  glVertex2f(2.140625f,9.234375f);
  glVertex2f(1.500000f,7.171875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.889062f,9.873438f);
  glVertex2f(7.115625f,9.815625f);
  glVertex2f(7.255000f,12.718750f);
  glVertex2f(7.376563f,9.748438f);
  glVertex2f(7.671875f,12.593750f);
  glVertex2f(7.671875f,9.671875f);
  glVertex2f(9.203125f,-3.109375f);
  glVertex2f(7.671875f,2.203125f);
  glVertex2f(7.671875f,-0.406250f);
  glVertex2f(6.424062f,-0.334688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.671875f,2.203125f);
  glVertex2f(6.378125f,2.365625f);
  glVertex2f(6.424062f,-0.334688f);
  glVertex2f(5.371875f,2.853125f);
  glVertex2f(5.305625f,-0.120000f);
  glVertex2f(4.653125f,3.665625f);
  glVertex2f(4.316562f,0.237813f);
  glVertex2f(4.221875f,4.803125f);
  glVertex2f(4.078125f,6.265625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.078125f,6.265625f);
  glVertex2f(1.062500f,6.265625f);
  glVertex2f(1.129063f,5.080313f);
  glVertex2f(1.328750f,3.999375f);
  glVertex2f(1.661562f,3.022813f);
  glVertex2f(2.127500f,2.150625f);
  glVertex2f(2.726563f,1.382813f);
  glVertex2f(3.456875f,0.738750f);
  glVertex2f(4.316562f,0.237813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.866875f,12.831250f);
  glVertex2f(6.507500f,12.931250f);
  glVertex2f(6.539063f,9.960938f);
  glVertex2f(6.696875f,9.921875f);
  glVertex2f(6.889062f,9.873438f);
  glVertex2f(7.255000f,12.718750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.773438f,13.828125f);
  glVertex2f(4.804375f,10.474063f);
  glVertex2f(4.940000f,13.618750f);
  glVertex2f(5.007500f,10.403750f);
  glVertex2f(5.133438f,13.440625f);
  glVertex2f(5.239375f,10.329062f);
  glVertex2f(5.353750f,13.293750f);
  glVertex2f(5.500000f,10.250000f);
  glVertex2f(5.600937f,13.178125f);
  glVertex2f(5.761562f,10.173437f);
  glVertex2f(5.875000f,13.093750f);
  glVertex2f(5.996250f,10.106250f);
  glVertex2f(6.176875f,13.018750f);
  glVertex2f(6.204062f,10.048437f);
  glVertex2f(6.507500f,12.931250f);
  glVertex2f(6.385000f,10.000000f);
  glVertex2f(6.539063f,9.960938f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.451875f,14.722500f);
  glVertex2f(4.484375f,10.601563f);
  glVertex2f(4.528438f,14.375625f);
  glVertex2f(4.630000f,10.540000f);
  glVertex2f(4.635625f,14.077500f);
  glVertex2f(4.804375f,10.474063f);
  glVertex2f(4.773438f,13.828125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.824375f,10.934063f);
  glVertex2f(4.014688f,10.833125f);
  glVertex2f(4.536875f,20.845312f);
  glVertex2f(4.188125f,10.744062f);
  glVertex2f(4.390625f,16.226563f);
  glVertex2f(4.344687f,10.666875f);
  glVertex2f(4.390625f,15.562500f);
  glVertex2f(4.484375f,10.601563f);
  glVertex2f(4.405938f,15.118125f);
  glVertex2f(4.451875f,14.722500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.671875f,21.421875f);
  glVertex2f(6.519375f,21.357813f);
  glVertex2f(6.651875f,18.737499f);
  glVertex2f(6.887187f,18.770313f);
  glVertex2f(7.135625f,18.793751f);
  glVertex2f(7.397188f,18.807812f);
  glVertex2f(7.671875f,18.812500f);
  glVertex2f(9.203125f,-3.109375f);
  glVertex2f(7.671875f,23.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.519375f,21.357813f);
  glVertex2f(5.474375f,21.165625f);
  glVertex2f(5.539063f,18.460938f);
  glVertex2f(5.687188f,18.507813f);
  glVertex2f(5.850313f,18.554688f);
  glVertex2f(6.028438f,18.601563f);
  glVertex2f(6.221562f,18.648438f);
  glVertex2f(6.429688f,18.695313f);
  glVertex2f(6.651875f,18.737499f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.474375f,21.165625f);
  glVertex2f(4.536875f,20.845312f);
  glVertex2f(4.542188f,17.325312f);
  glVertex2f(4.578125f,17.429375f);
  glVertex2f(4.617188f,17.507813f);
  glVertex2f(4.663125f,17.580313f);
  glVertex2f(4.719687f,17.666563f);
  glVertex2f(4.786875f,17.766563f);
  glVertex2f(4.864687f,17.880312f);
  glVertex2f(4.953125f,18.007813f);
  glVertex2f(5.051562f,18.133438f);
  glVertex2f(5.159375f,18.241562f);
  glVertex2f(5.276563f,18.332188f);
  glVertex2f(5.403125f,18.405312f);
  glVertex2f(5.539063f,18.460938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.536875f,20.845312f);
  glVertex2f(4.390625f,16.226563f);
  glVertex2f(4.393125f,16.299376f);
  glVertex2f(4.400625f,16.399063f);
  glVertex2f(4.413125f,16.525625f);
  glVertex2f(4.430625f,16.679062f);
  glVertex2f(4.453125f,16.859375f);
  glVertex2f(4.479688f,17.040312f);
  glVertex2f(4.509375f,17.195625f);
  glVertex2f(4.542188f,17.325312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.390625f,16.226563f);
  glVertex2f(4.390625f,15.562500f);
  glVertex2f(4.390625f,15.754063f);
  glVertex2f(4.390625f,15.916250f);
  glVertex2f(4.390625f,16.049063f);
  glVertex2f(4.390625f,16.152500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.706875f,20.396875f);
  glVertex2f(2.984375f,19.820313f);
  glVertex2f(3.068750f,11.394688f);
  glVertex2f(3.229687f,11.280625f);
  glVertex2f(3.412500f,11.164687f);
  glVertex2f(3.617188f,11.046875f);
  glVertex2f(3.824375f,10.934063f);
  glVertex2f(4.536875f,20.845312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.984375f,19.820313f);
  glVertex2f(2.382500f,19.141874f);
  glVertex2f(2.468437f,12.001562f);
  glVertex2f(2.588750f,11.860937f);
  glVertex2f(2.703438f,11.732813f);
  glVertex2f(2.812500f,11.617188f);
  glVertex2f(2.929688f,11.506875f);
  glVertex2f(3.068750f,11.394688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.382500f,19.141874f);
  glVertex2f(1.914375f,18.387812f);
  glVertex2f(1.969687f,12.670313f);
  glVertex2f(2.083437f,12.493750f);
  glVertex2f(2.210938f,12.320313f);
  glVertex2f(2.342500f,12.154688f);
  glVertex2f(2.468437f,12.001562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.914375f,18.387812f);
  glVertex2f(1.580000f,17.558125f);
  glVertex2f(1.587188f,13.618750f);
  glVertex2f(1.647187f,13.412500f);
  glVertex2f(1.710938f,13.218750f);
  glVertex2f(1.783437f,13.032812f);
  glVertex2f(1.869687f,12.850000f);
  glVertex2f(1.969687f,12.670313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.580000f,17.558125f);
  glVertex2f(1.379375f,16.652813f);
  glVertex2f(1.387500f,14.566875f);
  glVertex2f(1.429688f,14.312500f);
  glVertex2f(1.478438f,14.068750f);
  glVertex2f(1.530938f,13.837500f);
  glVertex2f(1.587188f,13.618750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.379375f,16.652813f);
  glVertex2f(1.312500f,15.671875f);
  glVertex2f(1.317188f,15.382500f);
  glVertex2f(1.331250f,15.101875f);
  glVertex2f(1.354687f,14.830000f);
  glVertex2f(1.387500f,14.566875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.203125f,23.843750f);
  glVertex2f(7.671875f,23.843750f);
  glVertex2f(9.203125f,-3.109375f);
  glVertex2f(9.203125f,-0.375000f);
  glVertex2f(9.203125f,2.234375f);
  glVertex2f(9.203125f,9.515625f);
  glVertex2f(9.203125f,12.250000f);
  glVertex2f(9.203125f,18.812500f);
  glVertex2f(9.203125f,21.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.859375f,15.734375f);
  glVertex2f(14.803750f,16.677500f);
  glVertex2f(14.636875f,17.556875f);
  glVertex2f(14.358750f,18.372499f);
  glVertex2f(13.969375f,19.124374f);
  glVertex2f(13.468750f,19.812500f);
  glVertex2f(12.853125f,20.403126f);
  glVertex2f(12.118750f,20.862499f);
  glVertex2f(11.812500f,15.734375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.118750f,20.862499f);
  glVertex2f(11.265625f,21.190624f);
  glVertex2f(11.462500f,17.839375f);
  glVertex2f(11.615625f,17.443438f);
  glVertex2f(11.725000f,16.960625f);
  glVertex2f(11.790625f,16.390938f);
  glVertex2f(11.812500f,15.734375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.265625f,21.190624f);
  glVertex2f(10.293750f,21.387501f);
  glVertex2f(10.673125f,18.573437f);
  glVertex2f(11.008125f,18.387501f);
  glVertex2f(11.265625f,18.148438f);
  glVertex2f(11.462500f,17.839375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.293750f,21.387501f);
  glVertex2f(9.203125f,21.453125f);
  glVertex2f(9.770625f,18.785938f);
  glVertex2f(10.260625f,18.706249f);
  glVertex2f(10.673125f,18.573437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.756250f,11.214687f);
  glVertex2f(12.406250f,11.398438f);
  glVertex2f(12.429063f,7.412813f);
  glVertex2f(12.488125f,7.202813f);
  glVertex2f(12.539063f,6.976563f);
  glVertex2f(12.581250f,6.733750f);
  glVertex2f(12.614062f,6.474062f);
  glVertex2f(12.637500f,6.197500f);
  glVertex2f(12.651563f,5.904062f);
  glVertex2f(12.656250f,5.593750f);
  glVertex2f(13.133125f,0.690000f);
  glVertex2f(13.093750f,11.019688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.406250f,11.398438f);
  glVertex2f(12.052188f,11.562813f);
  glVertex2f(12.112187f,8.093437f);
  glVertex2f(12.203125f,7.945313f);
  glVertex2f(12.286563f,7.784062f);
  glVertex2f(12.361875f,7.606563f);
  glVertex2f(12.429063f,7.412813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.052188f,11.562813f);
  glVertex2f(11.702500f,11.699688f);
  glVertex2f(11.798125f,8.477813f);
  glVertex2f(11.909687f,8.359688f);
  glVertex2f(12.014375f,8.231563f);
  glVertex2f(12.112187f,8.093437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.702500f,11.699688f);
  glVertex2f(11.357187f,11.809063f);
  glVertex2f(11.423437f,8.774688f);
  glVertex2f(11.554688f,8.684688f);
  glVertex2f(11.679688f,8.585938f);
  glVertex2f(11.798125f,8.477813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.836250f,9.050938f);
  glVertex2f(10.992188f,8.992188f);
  glVertex2f(11.016250f,11.890938f);
  glVertex2f(11.142187f,8.928437f);
  glVertex2f(11.357187f,11.809063f);
  glVertex2f(11.285937f,8.855938f);
  glVertex2f(11.423437f,8.774688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.679688f,11.945313f);
  glVertex2f(10.353125f,11.990000f);
  glVertex2f(10.507500f,9.164687f);
  glVertex2f(10.674687f,9.108438f);
  glVertex2f(10.836250f,9.050938f);
  glVertex2f(11.016250f,11.890938f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.786250f,9.375937f);
  glVertex2f(9.973125f,9.325625f);
  glVertex2f(10.042188f,12.042812f);
  glVertex2f(10.156250f,9.273438f);
  glVertex2f(10.353125f,11.990000f);
  glVertex2f(10.334687f,9.219687f);
  glVertex2f(10.507500f,9.164687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.203125f,12.250000f);
  glVertex2f(9.401250f,9.470938f);
  glVertex2f(9.467188f,12.172812f);
  glVertex2f(9.595625f,9.424375f);
  glVertex2f(9.746875f,12.103750f);
  glVertex2f(9.786250f,9.375937f);
  glVertex2f(10.042188f,12.042812f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.661250f,4.653750f);
  glVertex2f(15.734375f,5.859375f);
  glVertex2f(15.715000f,6.474375f);
  glVertex2f(15.656875f,7.056875f);
  glVertex2f(15.560000f,7.606875f);
  glVertex2f(15.441875f,3.586875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.560000f,7.606875f);
  glVertex2f(15.424375f,8.124375f);
  glVertex2f(15.441875f,3.586875f);
  glVertex2f(15.250000f,8.609375f);
  glVertex2f(15.076250f,2.658750f);
  glVertex2f(15.046250f,9.054688f);
  glVertex2f(14.822500f,9.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.578750f,9.804688f);
  glVertex2f(14.315000f,10.109375f);
  glVertex2f(14.564375f,1.869375f);
  glVertex2f(15.076250f,2.658750f);
  glVertex2f(14.822500f,9.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.031250f,10.367188f);
  glVertex2f(13.731250f,10.595938f);
  glVertex2f(13.906250f,1.218750f);
  glVertex2f(14.564375f,1.869375f);
  glVertex2f(14.315000f,10.109375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.418750f,10.813437f);
  glVertex2f(13.093750f,11.019688f);
  glVertex2f(13.133125f,0.690000f);
  glVertex2f(13.906250f,1.218750f);
  glVertex2f(13.731250f,10.595938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.133125f,0.690000f);
  glVertex2f(12.656250f,5.593750f);
  glVertex2f(12.623438f,4.889375f);
  glVertex2f(12.525000f,4.276250f);
  glVertex2f(12.360937f,3.754375f);
  glVertex2f(12.276250f,0.266250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.276250f,0.266250f);
  glVertex2f(12.360937f,3.754375f);
  glVertex2f(12.131250f,3.323750f);
  glVertex2f(11.835938f,2.984375f);
  glVertex2f(11.468125f,2.719375f);
  glVertex2f(11.335625f,-0.052500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.468125f,2.719375f);
  glVertex2f(11.020938f,2.511875f);
  glVertex2f(11.335625f,-0.052500f);
  glVertex2f(10.494375f,2.361875f);
  glVertex2f(10.311250f,-0.266250f);
  glVertex2f(9.888437f,2.269375f);
  glVertex2f(9.203125f,2.234375f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(10.311250f,-0.266250f);
  glVertex2f(9.203125f,2.234375f);
  glVertex2f(9.203125f,-0.375000f);
  glVertex2f(9.401250f,9.470938f);
  glVertex2f(9.203125f,12.250000f);
  glVertex2f(9.203125f,9.515625f);
  glVertex2f(9.770625f,18.785938f);
  glVertex2f(9.203125f,21.453125f);
  glVertex2f(9.203125f,18.812500f);
  glVertex2f(9.203125f,-3.109375f);
  glVertex2f(7.671875f,-0.406250f);
  glVertex2f(7.671875f,-3.109375f);
  glVertex2f(7.671875f,12.593750f);
  glVertex2f(9.203125f,-3.109375f);
  glVertex2f(7.671875f,18.812500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(19.421875f,22.093750f);
  glVertex2f(6.625000f,-0.406250f);
  glVertex2f(8.703125f,-0.406250f);
  glVertex2f(21.468750f,22.093750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(26.343750f,5.656250f);
  glVertex2f(26.283438f,6.716562f);
  glVertex2f(26.283438f,4.584375f);
  glVertex2f(26.102501f,7.672500f);
  glVertex2f(26.102501f,3.618750f);
  glVertex2f(25.800938f,8.524062f);
  glVertex2f(25.800938f,2.759375f);
  glVertex2f(25.378750f,9.271250f);
  glVertex2f(25.378750f,2.006250f);
  glVertex2f(24.835938f,9.914063f);
  glVertex2f(24.835938f,1.359375f);
  glVertex2f(24.199375f,10.445625f);
  glVertex2f(24.199375f,0.825000f);
  glVertex2f(23.765625f,5.656250f);
  glVertex2f(23.741562f,4.974375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(24.199375f,10.445625f);
  glVertex2f(23.495937f,10.859062f);
  glVertex2f(23.549063f,7.518125f);
  glVertex2f(23.669374f,6.958750f);
  glVertex2f(23.741562f,6.338125f);
  glVertex2f(23.765625f,5.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(23.495937f,10.859062f);
  glVertex2f(22.725624f,11.154375f);
  glVertex2f(22.884062f,8.818750f);
  glVertex2f(23.164063f,8.453125f);
  glVertex2f(23.380625f,8.016250f);
  glVertex2f(23.549063f,7.518125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(20.381563f,9.428125f);
  glVertex2f(20.976563f,9.468750f);
  glVertex2f(20.984375f,11.390625f);
  glVertex2f(21.571562f,9.428125f);
  glVertex2f(21.888437f,11.331562f);
  glVertex2f(22.087812f,9.306250f);
  glVertex2f(22.725624f,11.154375f);
  glVertex2f(22.525312f,9.103125f);
  glVertex2f(22.884062f,8.818750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.080626f,11.331562f);
  glVertex2f(19.244375f,11.154375f);
  glVertex2f(19.427813f,9.103125f);
  glVertex2f(19.865313f,9.306250f);
  glVertex2f(20.381563f,9.428125f);
  glVertex2f(20.984375f,11.390625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(19.244375f,11.154375f);
  glVertex2f(18.475624f,10.859062f);
  glVertex2f(18.572500f,8.016250f);
  glVertex2f(18.789063f,8.453125f);
  glVertex2f(19.069063f,8.818750f);
  glVertex2f(19.427813f,9.103125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.475624f,10.859062f);
  glVertex2f(17.774376f,10.445625f);
  glVertex2f(18.211563f,6.338125f);
  glVertex2f(18.283751f,6.958750f);
  glVertex2f(18.404062f,7.518125f);
  glVertex2f(18.572500f,8.016250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.774376f,10.445625f);
  glVertex2f(17.140625f,9.914063f);
  glVertex2f(17.774374f,0.825000f);
  glVertex2f(18.475624f,0.409375f);
  glVertex2f(18.211563f,4.974375f);
  glVertex2f(18.187500f,5.656250f);
  glVertex2f(18.211563f,6.338125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(23.741562f,4.974375f);
  glVertex2f(23.669374f,4.353750f);
  glVertex2f(24.199375f,0.825000f);
  glVertex2f(23.549063f,3.794375f);
  glVertex2f(23.495937f,0.409375f);
  glVertex2f(23.380625f,3.296250f);
  glVertex2f(23.164063f,2.859375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(22.884062f,2.493750f);
  glVertex2f(22.525312f,2.209375f);
  glVertex2f(22.725624f,0.112500f);
  glVertex2f(23.495937f,0.409375f);
  glVertex2f(23.164063f,2.859375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(20.976563f,1.843750f);
  glVertex2f(20.984375f,-0.125000f);
  glVertex2f(21.571562f,1.884375f);
  glVertex2f(21.888437f,-0.065625f);
  glVertex2f(22.087812f,2.006250f);
  glVertex2f(22.725624f,0.112500f);
  glVertex2f(22.525312f,2.209375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.381563f,1.884375f);
  glVertex2f(19.865313f,2.006250f);
  glVertex2f(20.080626f,-0.065625f);
  glVertex2f(20.984375f,-0.125000f);
  glVertex2f(20.976563f,1.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(19.427813f,2.209375f);
  glVertex2f(19.069063f,2.493750f);
  glVertex2f(19.244375f,0.112500f);
  glVertex2f(20.080626f,-0.065625f);
  glVertex2f(19.865313f,2.006250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.069063f,2.493750f);
  glVertex2f(18.789063f,2.859375f);
  glVertex2f(19.244375f,0.112500f);
  glVertex2f(18.572500f,3.296250f);
  glVertex2f(18.475624f,0.409375f);
  glVertex2f(18.404062f,3.794375f);
  glVertex2f(18.283751f,4.353750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.640625f,5.656250f);
  glVertex2f(15.700625f,4.584375f);
  glVertex2f(15.700625f,6.716563f);
  glVertex2f(15.880625f,3.618750f);
  glVertex2f(15.880625f,7.672500f);
  glVertex2f(16.180626f,2.759375f);
  glVertex2f(16.180626f,8.524062f);
  glVertex2f(16.600624f,2.006250f);
  glVertex2f(16.600624f,9.271250f);
  glVertex2f(17.140625f,1.359375f);
  glVertex2f(17.140625f,9.914063f);
  glVertex2f(17.774374f,0.825000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.218750f,16.031250f);
  glVertex2f(12.158438f,17.091562f);
  glVertex2f(12.158438f,14.970000f);
  glVertex2f(11.977500f,18.047501f);
  glVertex2f(11.977500f,14.011250f);
  glVertex2f(11.675938f,18.899063f);
  glVertex2f(11.675938f,13.155000f);
  glVertex2f(11.253750f,19.646250f);
  glVertex2f(11.253750f,12.401250f);
  glVertex2f(10.710938f,20.289063f);
  glVertex2f(10.710938f,11.750000f);
  glVertex2f(10.073125f,20.820625f);
  glVertex2f(10.073125f,11.210000f);
  glVertex2f(9.640625f,16.023438f);
  glVertex2f(9.616563f,15.350312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.073125f,20.820625f);
  glVertex2f(9.365937f,21.234062f);
  glVertex2f(9.424063f,17.868437f);
  glVertex2f(9.544375f,17.312187f);
  glVertex2f(9.616563f,16.697187f);
  glVertex2f(9.640625f,16.023438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.365937f,21.234062f);
  glVertex2f(8.589375f,21.529375f);
  glVertex2f(8.758125f,19.173124f);
  glVertex2f(9.039063f,18.804688f);
  glVertex2f(9.255625f,18.365938f);
  glVertex2f(9.424063f,17.868437f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.235938f,19.787188f);
  glVertex2f(6.828125f,19.828125f);
  glVertex2f(6.828125f,21.765625f);
  glVertex2f(7.431562f,19.787188f);
  glVertex2f(7.743437f,21.706562f);
  glVertex2f(7.954375f,19.664375f);
  glVertex2f(8.589375f,21.529375f);
  glVertex2f(8.396563f,19.459688f);
  glVertex2f(8.758125f,19.173124f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.935313f,21.706562f);
  glVertex2f(5.106875f,21.529375f);
  glVertex2f(5.285937f,19.459688f);
  glVertex2f(5.721875f,19.664375f);
  glVertex2f(6.235938f,19.787188f);
  glVertex2f(6.828125f,21.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.106875f,21.529375f);
  glVertex2f(4.342813f,21.234062f);
  glVertex2f(4.431875f,18.365938f);
  glVertex2f(4.648438f,18.804688f);
  glVertex2f(4.928125f,19.173124f);
  glVertex2f(5.285937f,19.459688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.342813f,21.234062f);
  glVertex2f(3.643125f,20.820625f);
  glVertex2f(4.070938f,16.697187f);
  glVertex2f(4.143125f,17.312187f);
  glVertex2f(4.263437f,17.868437f);
  glVertex2f(4.431875f,18.365938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.643125f,20.820625f);
  glVertex2f(3.007813f,20.289063f);
  glVertex2f(3.643125f,11.210000f);
  glVertex2f(4.342813f,10.790000f);
  glVertex2f(4.070938f,15.350312f);
  glVertex2f(4.046875f,16.023438f);
  glVertex2f(4.070938f,16.697187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.616563f,15.350312f);
  glVertex2f(9.544375f,14.737187f);
  glVertex2f(10.073125f,11.210000f);
  glVertex2f(9.424063f,14.184063f);
  glVertex2f(9.365937f,10.790000f);
  glVertex2f(9.255625f,13.690937f);
  glVertex2f(9.039063f,13.257813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.758125f,12.895000f);
  glVertex2f(8.396563f,12.612813f);
  glVertex2f(8.589375f,10.490000f);
  glVertex2f(9.365937f,10.790000f);
  glVertex2f(9.039063f,13.257813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.954375f,12.411250f);
  glVertex2f(7.431562f,12.290313f);
  glVertex2f(7.743437f,10.310000f);
  glVertex2f(8.589375f,10.490000f);
  glVertex2f(8.396563f,12.612813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.721875f,12.411250f);
  glVertex2f(5.935312f,10.310000f);
  glVertex2f(6.235938f,12.290313f);
  glVertex2f(6.828125f,10.250000f);
  glVertex2f(6.828125f,12.250000f);
  glVertex2f(7.743437f,10.310000f);
  glVertex2f(7.431562f,12.290313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.285937f,12.612812f);
  glVertex2f(4.928125f,12.895000f);
  glVertex2f(5.106875f,10.490000f);
  glVertex2f(5.935312f,10.310000f);
  glVertex2f(5.721875f,12.411250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.928125f,12.895000f);
  glVertex2f(4.648438f,13.257813f);
  glVertex2f(5.106875f,10.490000f);
  glVertex2f(4.431875f,13.690937f);
  glVertex2f(4.342813f,10.790000f);
  glVertex2f(4.263438f,14.184062f);
  glVertex2f(4.143125f,14.737187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.500000f,16.031250f);
  glVertex2f(1.560313f,14.970000f);
  glVertex2f(1.560313f,17.091562f);
  glVertex2f(1.741250f,14.011250f);
  glVertex2f(1.741250f,18.047501f);
  glVertex2f(2.042813f,13.155000f);
  glVertex2f(2.042813f,18.899063f);
  glVertex2f(2.465000f,12.401250f);
  glVertex2f(2.465000f,19.646250f);
  glVertex2f(3.007813f,11.750000f);
  glVertex2f(3.007813f,20.289063f);
  glVertex2f(3.643125f,11.210000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.070938f,15.350312f);
  glVertex2f(4.342813f,10.790000f);
  glVertex2f(4.143125f,14.737187f);
  glVertex2f(18.211563f,4.974375f);
  glVertex2f(18.475624f,0.409375f);
  glVertex2f(18.283751f,4.353750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(19.546875f,12.656250f);
  glVertex2f(16.343750f,12.656250f);
  glVertex2f(16.438749f,11.837500f);
  glVertex2f(16.511250f,11.093750f);
  glVertex2f(16.561251f,10.425000f);
  glVertex2f(16.588751f,9.831250f);
  glVertex2f(16.593750f,9.312500f);
  glVertex2f(16.660625f,1.635000f);
  glVertex2f(17.139376f,1.168125f);
  glVertex2f(17.906250f,4.390625f);
  glVertex2f(18.202812f,5.010313f);
  glVertex2f(18.467501f,5.644375f);
  glVertex2f(18.700312f,6.292812f);
  glVertex2f(18.901251f,6.955625f);
  glVertex2f(19.070313f,7.632813f);
  glVertex2f(19.209999f,8.283438f);
  glVertex2f(19.322813f,8.866563f);
  glVertex2f(19.408751f,9.382188f);
  glVertex2f(19.467812f,9.830313f);
  glVertex2f(19.500000f,10.210938f);
  glVertex2f(19.516874f,10.586250f);
  glVertex2f(19.530001f,11.018437f);
  glVertex2f(19.539375f,11.507500f);
  glVertex2f(19.545000f,12.053437f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.391251f,2.853125f);
  glVertex2f(18.828751f,3.403125f);
  glVertex2f(18.515625f,0.000000f);
  glVertex2f(18.333750f,3.915625f);
  glVertex2f(18.066875f,0.350625f);
  glVertex2f(17.906250f,4.390625f);
  glVertex2f(17.608126f,0.740000f);
  glVertex2f(17.139376f,1.168125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.021250f,2.265625f);
  glVertex2f(19.391251f,2.853125f);
  glVertex2f(18.515625f,0.000000f);
  glVertex2f(22.531250f,0.000000f);
  glVertex2f(20.718750f,1.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.660625f,1.635000f);
  glVertex2f(16.593750f,9.312500f);
  glVertex2f(16.566250f,8.805625f);
  glVertex2f(16.496250f,8.247500f);
  glVertex2f(16.383751f,7.638125f);
  glVertex2f(16.228750f,6.977500f);
  glVertex2f(16.171875f,2.140625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.889688f,1.926875f);
  glVertex2f(16.000626f,2.008125f);
  glVertex2f(16.031250f,6.265625f);
  glVertex2f(16.094688f,2.079375f);
  glVertex2f(16.228750f,6.977500f);
  glVertex2f(16.171875f,2.140625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.031250f,6.265625f);
  glVertex2f(15.398438f,6.889688f);
  glVertex2f(15.441875f,1.616562f);
  glVertex2f(15.617188f,1.734375f);
  glVertex2f(15.761875f,1.835625f);
  glVertex2f(15.889688f,1.926875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.904375f,0.699687f);
  glVertex2f(14.296875f,0.914063f);
  glVertex2f(14.625000f,3.953125f);
  glVertex2f(14.649688f,1.124375f);
  glVertex2f(14.775000f,7.511875f);
  glVertex2f(14.958125f,1.311563f);
  glVertex2f(15.398438f,6.889688f);
  glVertex2f(15.222187f,1.475625f);
  glVertex2f(15.441875f,1.616562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.775000f,7.511875f);
  glVertex2f(14.160937f,8.132188f);
  glVertex2f(14.625000f,3.953125f);
  glVertex2f(13.556250f,8.750625f);
  glVertex2f(13.332500f,5.111875f);
  glVertex2f(12.960938f,9.367188f);
  glVertex2f(12.383750f,9.978125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.017500f,6.388125f);
  glVertex2f(13.332500f,5.111875f);
  glVertex2f(12.383750f,9.978125f);
  glVertex2f(11.833438f,10.579687f);
  glVertex2f(11.310000f,11.171875f);
  glVertex2f(10.813437f,11.754687f);
  glVertex2f(10.680000f,7.781875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.343750f,12.328125f);
  glVertex2f(10.684688f,12.516875f);
  glVertex2f(10.422812f,14.691563f);
  glVertex2f(9.971250f,14.443125f);
  glVertex2f(10.680000f,7.781875f);
  glVertex2f(10.813437f,11.754687f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.455313f,14.186563f);
  glVertex2f(8.875000f,13.921875f);
  glVertex2f(9.320000f,9.293125f);
  glVertex2f(10.680000f,7.781875f);
  glVertex2f(9.971250f,14.443125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.431250f,16.239374f);
  glVertex2f(7.449375f,10.764375f);
  glVertex2f(7.775000f,15.514375f);
  glVertex2f(7.937500f,10.921875f);
  glVertex2f(8.256250f,14.741875f);
  glVertex2f(9.320000f,9.293125f);
  glVertex2f(8.875000f,13.921875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.431250f,16.239374f);
  glVertex2f(7.225000f,16.916876f);
  glVertex2f(7.449375f,10.764375f);
  glVertex2f(7.156250f,17.546875f);
  glVertex2f(6.985000f,10.516875f);
  glVertex2f(7.208125f,21.677500f);
  glVertex2f(6.548125f,21.353750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.749375f,3.311875f);
  glVertex2f(12.772500f,2.813125f);
  glVertex2f(13.014375f,0.315937f);
  glVertex2f(13.476875f,0.500313f);
  glVertex2f(13.904375f,0.699687f);
  glVertex2f(14.625000f,3.953125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.869375f,-0.242812f);
  glVertex2f(11.430625f,-0.140000f);
  glVertex2f(11.694375f,2.456875f);
  glVertex2f(11.984375f,-0.007813f);
  glVertex2f(12.772500f,2.813125f);
  glVertex2f(12.516875f,0.146562f);
  glVertex2f(13.014375f,0.315937f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.515000f,2.243125f);
  glVertex2f(9.234375f,2.171875f);
  glVertex2f(9.724375f,-0.360312f);
  glVertex2f(10.300625f,-0.316250f);
  glVertex2f(10.869375f,-0.242812f);
  glVertex2f(11.694375f,2.456875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.724375f,-0.360312f);
  glVertex2f(9.234375f,2.171875f);
  glVertex2f(9.140625f,-0.375000f);
  glVertex2f(8.523750f,2.228125f);
  glVertex2f(7.946875f,-0.301875f);
  glVertex2f(7.854375f,2.396875f);
  glVertex2f(7.226250f,2.678125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.828125f,-0.082500f);
  glVertex2f(7.946875f,-0.301875f);
  glVertex2f(7.226250f,2.678125f);
  glVertex2f(6.639375f,3.071875f);
  glVertex2f(6.093750f,3.578125f);
  glVertex2f(5.784375f,0.283125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.784375f,0.283125f);
  glVertex2f(6.093750f,3.578125f);
  glVertex2f(5.621250f,4.136875f);
  glVertex2f(5.253750f,4.688125f);
  glVertex2f(4.991250f,5.231875f);
  glVertex2f(4.833750f,5.768125f);
  glVertex2f(4.815625f,0.795000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.815625f,0.795000f);
  glVertex2f(4.833750f,5.768125f);
  glVertex2f(4.781250f,6.296875f);
  glVertex2f(4.528438f,11.521250f);
  glVertex2f(4.243438f,11.313125f);
  glVertex2f(3.949687f,11.078750f);
  glVertex2f(3.921875f,1.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.949687f,11.078750f);
  glVertex2f(3.647187f,10.818125f);
  glVertex2f(3.921875f,1.453125f);
  glVertex2f(3.335938f,10.531250f);
  glVertex2f(3.151250f,2.228750f);
  glVertex2f(3.036562f,10.218125f);
  glVertex2f(2.769687f,9.878750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.551875f,3.093125f);
  glVertex2f(3.151250f,2.228750f);
  glVertex2f(2.769687f,9.878750f);
  glVertex2f(2.535312f,9.513125f);
  glVertex2f(2.333437f,9.121250f);
  glVertex2f(2.164063f,8.703125f);
  glVertex2f(2.123750f,4.046250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.164063f,8.703125f);
  glVertex2f(2.026250f,8.258750f);
  glVertex2f(2.123750f,4.046250f);
  glVertex2f(1.919062f,7.788125f);
  glVertex2f(1.866875f,5.088125f);
  glVertex2f(1.842500f,7.291250f);
  glVertex2f(1.796563f,6.768125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.816250f,16.577499f);
  glVertex2f(14.910313f,16.905312f);
  glVertex2f(14.970312f,18.658125f);
  glVertex2f(14.977500f,17.241249f);
  glVertex2f(15.031250f,17.937500f);
  glVertex2f(15.017813f,17.585312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.787500f,19.320000f);
  glVertex2f(14.482813f,19.923124f);
  glVertex2f(14.559063f,15.953750f);
  glVertex2f(14.695313f,16.257813f);
  glVertex2f(14.816250f,16.577499f);
  glVertex2f(14.970312f,18.658125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.482813f,19.923124f);
  glVertex2f(14.056250f,20.467501f);
  glVertex2f(14.127812f,15.180312f);
  glVertex2f(14.275312f,15.415000f);
  glVertex2f(14.419063f,15.672812f);
  glVertex2f(14.559063f,15.953750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.056250f,20.467501f);
  glVertex2f(13.507813f,20.953125f);
  glVertex2f(13.602813f,14.552500f);
  glVertex2f(13.806562f,14.764688f);
  glVertex2f(13.976563f,14.968750f);
  glVertex2f(14.127812f,15.180312f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.588125f,17.675625f);
  glVertex2f(12.789063f,13.867188f);
  glVertex2f(12.863125f,21.363750f);
  glVertex2f(13.094063f,14.103750f);
  glVertex2f(13.507813f,20.953125f);
  glVertex2f(13.365313f,14.332188f);
  glVertex2f(13.602813f,14.552500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.752500f,19.228125f);
  glVertex2f(12.101563f,18.890625f);
  glVertex2f(12.147813f,21.683125f);
  glVertex2f(12.374375f,18.505625f);
  glVertex2f(12.863125f,21.363750f);
  glVertex2f(12.536563f,18.100626f);
  glVertex2f(12.588125f,17.675625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.361875f,21.911249f);
  glVertex2f(10.505313f,22.048124f);
  glVertex2f(10.928750f,19.678125f);
  glVertex2f(11.361563f,19.490625f);
  glVertex2f(11.752500f,19.228125f);
  glVertex2f(12.147813f,21.683125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.910000f,19.723125f);
  glVertex2f(9.393125f,19.801874f);
  glVertex2f(9.578125f,22.093750f);
  glVertex2f(9.937500f,19.828125f);
  glVertex2f(10.505313f,22.048124f);
  glVertex2f(10.454062f,19.790625f);
  glVertex2f(10.928750f,19.678125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.723125f,22.047501f);
  glVertex2f(7.933125f,21.908751f);
  glVertex2f(8.127500f,19.408125f);
  glVertex2f(8.488125f,19.591875f);
  glVertex2f(8.910000f,19.723125f);
  glVertex2f(9.578125f,22.093750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.933125f,21.908751f);
  glVertex2f(7.208125f,21.677500f);
  glVertex2f(7.263750f,18.271875f);
  glVertex2f(7.398125f,18.596874f);
  glVertex2f(7.586250f,18.896875f);
  glVertex2f(7.828125f,19.171875f);
  glVertex2f(8.127500f,19.408125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.208125f,21.677500f);
  glVertex2f(7.156250f,17.546875f);
  glVertex2f(7.183125f,17.921875f);
  glVertex2f(7.263750f,18.271875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.985000f,10.516875f);
  glVertex2f(6.548125f,21.353750f);
  glVertex2f(6.544375f,10.179375f);
  glVertex2f(6.531250f,12.625000f);
  glVertex2f(6.127500f,9.751875f);
  glVertex2f(6.127188f,12.428125f);
  glVertex2f(5.752500f,12.237500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.699687f,13.638437f);
  glVertex2f(5.945000f,13.333750f);
  glVertex2f(5.953125f,20.937500f);
  glVertex2f(6.222188f,12.995937f);
  glVertex2f(6.548125f,21.353750f);
  glVertex2f(6.531250f,12.625000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.138750f,14.394062f);
  glVertex2f(5.304688f,14.148438f);
  glVertex2f(5.433750f,20.451876f);
  glVertex2f(5.486250f,13.910000f);
  glVertex2f(5.953125f,20.937500f);
  glVertex2f(5.699687f,13.638437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.000625f,19.920000f);
  glVertex2f(4.653750f,19.341875f);
  glVertex2f(4.805000f,15.027813f);
  glVertex2f(4.972188f,14.687187f);
  glVertex2f(5.138750f,14.394062f);
  glVertex2f(5.433750f,20.451876f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.226250f,16.754063f);
  glVertex2f(4.323750f,16.306875f);
  glVertex2f(4.393125f,18.717501f);
  glVertex2f(4.468750f,15.851563f);
  glVertex2f(4.653750f,19.341875f);
  glVertex2f(4.637187f,15.415937f);
  glVertex2f(4.805000f,15.027813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.218750f,18.046875f);
  glVertex2f(4.173750f,17.624062f);
  glVertex2f(4.176250f,17.193125f);
  glVertex2f(4.226250f,16.754063f);
  glVertex2f(4.393125f,18.717501f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.448750f,12.948125f);
  glVertex2f(11.617188f,13.046875f);
  glVertex2f(11.677813f,15.694062f);
  glVertex2f(11.781563f,13.149688f);
  glVertex2f(11.923125f,16.014376f);
  glVertex2f(11.980937f,13.283125f);
  glVertex2f(12.150312f,16.371563f);
  glVertex2f(12.215313f,13.447187f);
  glVertex2f(12.359375f,16.765625f);
  glVertex2f(12.484688f,13.641875f);
  glVertex2f(12.529062f,17.230625f);
  glVertex2f(12.789063f,13.867188f);
  glVertex2f(12.588125f,17.675625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.422812f,14.691563f);
  glVertex2f(10.684688f,12.516875f);
  glVertex2f(10.810000f,14.931875f);
  glVertex2f(10.982500f,12.683125f);
  glVertex2f(11.132813f,15.164063f);
  glVertex2f(11.237187f,12.826875f);
  glVertex2f(11.414375f,15.410625f);
  glVertex2f(11.448750f,12.948125f);
  glVertex2f(11.677813f,15.694062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.124375f,8.089375f);
  glVertex2f(5.391250f,8.666875f);
  glVertex2f(5.407187f,12.053125f);
  glVertex2f(5.734375f,9.234375f);
  glVertex2f(5.752500f,12.237500f);
  glVertex2f(6.127500f,9.751875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.091250f,11.875000f);
  glVertex2f(4.804688f,11.703125f);
  glVertex2f(4.819375f,6.904375f);
  glVertex2f(4.933750f,7.501875f);
  glVertex2f(5.124375f,8.089375f);
  glVertex2f(5.407187f,12.053125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.804688f,11.703125f);
  glVertex2f(4.528438f,11.521250f);
  glVertex2f(4.781250f,6.296875f);
  glVertex2f(4.819375f,6.904375f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(1.866875f,5.088125f);
  glVertex2f(1.796563f,6.768125f);
  glVertex2f(1.781250f,6.218750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.125000f,21.656250f);
  glVertex2f(3.921875f,21.656250f);
  glVertex2f(4.625000f,13.015625f);
  glVertex2f(6.421875f,13.015625f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.125000f,-3.953125f);
  glVertex2f(8.031250f,-3.953125f);
  glVertex2f(7.142500f,-1.183125f);
  glVertex2f(6.451250f,1.501875f);
  glVertex2f(5.957500f,4.101875f);
  glVertex2f(5.661250f,6.616875f);
  glVertex2f(4.898750f,19.601875f);
  glVertex2f(4.898750f,-1.463125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.661250f,6.616875f);
  glVertex2f(5.562500f,9.046875f);
  glVertex2f(4.898750f,19.601875f);
  glVertex2f(5.661250f,11.528749f);
  glVertex2f(6.125000f,22.093750f);
  glVertex2f(5.957500f,14.074375f);
  glVertex2f(6.451250f,16.683750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.718750f,9.046875f);
  glVertex2f(2.855000f,6.336875f);
  glVertex2f(2.855000f,11.773750f);
  glVertex2f(3.263750f,3.681875f);
  glVertex2f(3.263750f,14.441875f);
  glVertex2f(3.945000f,1.081875f);
  glVertex2f(3.945000f,17.051250f);
  glVertex2f(4.898750f,-1.463125f);
  glVertex2f(4.898750f,19.601875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.125000f,22.093750f);
  glVertex2f(6.451250f,16.683750f);
  glVertex2f(7.142500f,19.356874f);
  glVertex2f(8.031250f,22.093750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.062500f,9.046875f);
  glVertex2f(7.927500f,11.763750f);
  glVertex2f(7.522500f,14.426875f);
  glVertex2f(6.847500f,17.036249f);
  glVertex2f(5.902500f,19.591875f);
  glVertex2f(4.687500f,22.093750f);
  glVertex2f(2.750000f,22.093750f);
  glVertex2f(3.638750f,19.356874f);
  glVertex2f(4.330000f,16.683750f);
  glVertex2f(4.823750f,14.074375f);
  glVertex2f(5.120000f,11.528750f);
  glVertex2f(5.218750f,9.046875f);
  glVertex2f(5.120000f,6.616875f);
  glVertex2f(4.823750f,4.101875f);
  glVertex2f(4.330000f,1.501875f);
  glVertex2f(3.638750f,-1.183125f);
  glVertex2f(2.750000f,-3.953125f);
  glVertex2f(4.687500f,-3.953125f);
  glVertex2f(5.902500f,-1.453125f);
  glVertex2f(6.847500f,1.096875f);
  glVertex2f(7.522500f,3.696875f);
  glVertex2f(7.927500f,6.346875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.953125f,11.250000f);
  glVertex2f(10.921875f,15.265625f);
  glVertex2f(11.781250f,10.046875f);
  glVertex2f(9.875000f,17.281250f);
  glVertex2f(9.875000f,14.468750f);
  glVertex2f(8.796875f,16.468750f);
  glVertex2f(8.796875f,15.265625f);
  glVertex2f(3.843750f,17.109375f);
  glVertex2f(3.843750f,14.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.937500f,21.656250f);
  glVertex2f(5.765625f,20.484375f);
  glVertex2f(8.796875f,16.468750f);
  glVertex2f(9.875000f,17.281250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.921875f,16.468750f);
  glVertex2f(13.953125f,20.484375f);
  glVertex2f(11.781250f,21.656250f);
  glVertex2f(9.875000f,17.281250f);
  glVertex2f(10.921875f,15.265625f);
  glVertex2f(15.875000f,14.656250f);
  glVertex2f(15.875000f,17.109375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.796875f,15.265625f);
  glVertex2f(5.765625f,11.250000f);
  glVertex2f(7.937500f,10.046875f);
  glVertex2f(9.875000f,14.468750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.937500f,17.984375f);
  glVertex2f(14.062500f,17.984375f);
  glVertex2f(15.937500f,0.000000f);
  glVertex2f(14.062500f,9.937500f);
  glVertex2f(14.062500f,8.062500f);
  glVertex2f(6.000000f,9.937500f);
  glVertex2f(6.000000f,8.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.937500f,8.062500f);
  glVertex2f(24.000000f,8.062500f);
  glVertex2f(15.937500f,9.937500f);
  glVertex2f(15.937500f,17.984375f);
  glVertex2f(15.937500f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(15.937500f,9.937500f);
  glVertex2f(24.000000f,8.062500f);
  glVertex2f(24.000000f,9.937500f);
  glVertex2f(15.937500f,0.000000f);
  glVertex2f(14.062500f,8.062500f);
  glVertex2f(14.062500f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.828125f,3.687500f);
  glVertex2f(3.250000f,3.687500f);
  glVertex2f(1.437500f,-3.812500f);
  glVertex2f(3.546875f,-3.812500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.406250f,6.093750f);
  glVertex2f(8.406250f,8.562500f);
  glVertex2f(1.203125f,8.562500f);
  glVertex2f(1.203125f,6.093750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.187500f,0.000000f);
  glVertex2f(6.187500f,3.687500f);
  glVertex2f(2.937500f,3.687500f);
  glVertex2f(2.937500f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.515625f,22.093750f);
  glVertex2f(8.468750f,22.093750f);
  glVertex2f(1.375000f,-1.546875f);
  glVertex2f(3.453125f,-1.546875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.430938f,20.845938f);
  glVertex2f(11.984688f,21.150938f);
  glVertex2f(12.079062f,15.602500f);
  glVertex2f(12.163125f,15.085000f);
  glVertex2f(12.226563f,14.562500f);
  glVertex2f(12.274375f,14.010000f);
  glVertex2f(12.311563f,13.402500f);
  glVertex2f(12.338125f,12.740000f);
  glVertex2f(12.354062f,12.022500f);
  glVertex2f(12.359375f,11.250000f);
  glVertex2f(12.484375f,1.007813f);
  glVertex2f(12.830937f,20.514687f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.984688f,21.150938f);
  glVertex2f(11.492188f,21.429688f);
  glVertex2f(11.529688f,17.599062f);
  glVertex2f(11.703125f,17.125000f);
  glVertex2f(11.849063f,16.622499f);
  glVertex2f(11.974375f,16.115000f);
  glVertex2f(12.079062f,15.602500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.492188f,18.976563f);
  glVertex2f(10.803125f,18.709999f);
  glVertex2f(10.956563f,21.668751f);
  glVertex2f(11.079687f,18.391563f);
  glVertex2f(11.492188f,21.429688f);
  glVertex2f(11.321875f,18.021250f);
  glVertex2f(11.529688f,17.599062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.347500f,19.481874f);
  glVertex2f(9.764688f,19.361563f);
  glVertex2f(9.765312f,21.987499f);
  glVertex2f(10.146250f,19.193125f);
  glVertex2f(10.380938f,21.854687f);
  glVertex2f(10.492188f,18.976563f);
  glVertex2f(10.956563f,21.668751f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.065312f,19.566875f);
  glVertex2f(8.406250f,19.578125f);
  glVertex2f(8.414063f,22.093750f);
  glVertex2f(8.894688f,19.554062f);
  glVertex2f(9.109688f,22.067188f);
  glVertex2f(9.347500f,19.481874f);
  glVertex2f(9.765312f,21.987499f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.151250f,19.398125f);
  glVertex2f(7.437812f,19.476875f);
  glVertex2f(7.717813f,22.067188f);
  glVertex2f(7.742500f,19.533125f);
  glVertex2f(8.414063f,22.093750f);
  glVertex2f(8.065312f,19.566875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.060313f,21.987499f);
  glVertex2f(6.441563f,21.854687f);
  glVertex2f(6.631875f,19.172813f);
  glVertex2f(6.882813f,19.296875f);
  glVertex2f(7.151250f,19.398125f);
  glVertex2f(7.717813f,22.067188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.441563f,21.854687f);
  glVertex2f(5.861563f,21.668751f);
  glVertex2f(5.980312f,18.661875f);
  glVertex2f(6.180625f,18.855312f);
  glVertex2f(6.397812f,19.025625f);
  glVertex2f(6.631875f,19.172813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.861563f,21.668751f);
  glVertex2f(5.320313f,21.429688f);
  glVertex2f(5.330937f,17.718750f);
  glVertex2f(5.473125f,17.970312f);
  glVertex2f(5.628438f,18.212500f);
  glVertex2f(5.796875f,18.445313f);
  glVertex2f(5.980312f,18.661875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.320313f,21.429688f);
  glVertex2f(4.821875f,21.150938f);
  glVertex2f(4.887187f,16.584999f);
  glVertex2f(4.981563f,16.899376f);
  glVertex2f(5.085938f,17.187500f);
  glVertex2f(5.201875f,17.457813f);
  glVertex2f(5.330937f,17.718750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.821875f,21.150938f);
  glVertex2f(4.370313f,20.845938f);
  glVertex2f(4.468750f,13.507813f);
  glVertex2f(4.491562f,13.894375f);
  glVertex2f(4.522500f,14.285313f);
  glVertex2f(4.561563f,14.680625f);
  glVertex2f(4.608750f,15.080313f);
  glVertex2f(4.664063f,15.484375f);
  glVertex2f(4.728437f,15.877500f);
  glVertex2f(4.802813f,16.244375f);
  glVertex2f(4.887187f,16.584999f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.500000f,11.257813f);
  glVertex2f(1.504688f,10.567500f);
  glVertex2f(1.504688f,11.945000f);
  glVertex2f(1.518750f,9.902813f);
  glVertex2f(1.518750f,12.600312f);
  glVertex2f(1.542187f,9.263750f);
  glVertex2f(1.542187f,13.223750f);
  glVertex2f(1.575000f,8.650312f);
  glVertex2f(1.575000f,13.815312f);
  glVertex2f(1.617188f,8.062500f);
  glVertex2f(1.617188f,14.375000f);
  glVertex2f(1.676250f,7.478750f);
  glVertex2f(1.676250f,14.925312f);
  glVertex2f(1.759688f,6.877500f);
  glVertex2f(1.759688f,15.488750f);
  glVertex2f(1.867500f,6.258750f);
  glVertex2f(1.867500f,16.065313f);
  glVertex2f(1.999688f,5.622500f);
  glVertex2f(1.999688f,16.655001f);
  glVertex2f(2.156250f,4.968750f);
  glVertex2f(2.156250f,17.257813f);
  glVertex2f(2.336875f,4.327813f);
  glVertex2f(2.336875f,17.845938f);
  glVertex2f(2.541250f,3.730000f);
  glVertex2f(2.541250f,18.391563f);
  glVertex2f(2.769375f,3.175313f);
  glVertex2f(2.769375f,18.894688f);
  glVertex2f(3.021250f,2.663750f);
  glVertex2f(3.021250f,19.355312f);
  glVertex2f(3.296875f,2.195313f);
  glVertex2f(3.296875f,19.773438f);
  glVertex2f(3.607812f,1.763438f);
  glVertex2f(3.607812f,20.157188f);
  glVertex2f(3.965625f,1.361562f);
  glVertex2f(3.965625f,20.514687f);
  glVertex2f(4.370313f,0.989688f);
  glVertex2f(4.370313f,20.845938f);
  glVertex2f(4.421875f,11.250000f);
  glVertex2f(4.423750f,11.755313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.370313f,20.845938f);
  glVertex2f(4.423750f,11.755313f);
  glVertex2f(4.429375f,12.233750f);
  glVertex2f(4.438750f,12.685312f);
  glVertex2f(4.451875f,13.110000f);
  glVertex2f(4.468750f,13.507813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.225625f,9.410000f);
  glVertex2f(15.243125f,9.844687f);
  glVertex2f(15.246875f,12.606250f);
  glVertex2f(15.255625f,10.296250f);
  glVertex2f(15.260938f,11.945313f);
  glVertex2f(15.263125f,10.764688f);
  glVertex2f(15.265625f,11.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.033125f,7.214687f);
  glVertex2f(15.088750f,7.685312f);
  glVertex2f(15.089687f,14.930312f);
  glVertex2f(15.135625f,8.138437f);
  glVertex2f(15.148438f,14.382813f);
  glVertex2f(15.173750f,8.574062f);
  glVertex2f(15.190625f,13.825000f);
  glVertex2f(15.203125f,8.992188f);
  glVertex2f(15.223437f,13.232813f);
  glVertex2f(15.225625f,9.410000f);
  glVertex2f(15.246875f,12.606250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.811250f,5.776563f);
  glVertex2f(14.895000f,6.240625f);
  glVertex2f(14.900937f,16.066563f);
  glVertex2f(14.968750f,6.726563f);
  glVertex2f(15.007188f,15.491563f);
  glVertex2f(15.033125f,7.214687f);
  glVertex2f(15.089687f,14.930312f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.500000f,4.515625f);
  glVertex2f(14.613750f,4.914063f);
  glVertex2f(14.617188f,17.257813f);
  glVertex2f(14.717500f,5.334375f);
  glVertex2f(14.770938f,16.655312f);
  glVertex2f(14.811250f,5.776563f);
  glVertex2f(14.900937f,16.066563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.067813f,3.358750f);
  glVertex2f(14.228750f,3.743125f);
  glVertex2f(14.238438f,18.391562f);
  glVertex2f(14.372812f,4.128750f);
  glVertex2f(14.439688f,17.845938f);
  glVertex2f(14.500000f,4.515625f);
  glVertex2f(14.617188f,17.257813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.257813f,1.882500f);
  glVertex2f(13.484375f,2.225312f);
  glVertex2f(13.492188f,19.773438f);
  glVertex2f(13.695313f,2.593750f);
  glVertex2f(13.764688f,19.355312f);
  glVertex2f(13.890000f,2.975625f);
  glVertex2f(14.013437f,18.894688f);
  glVertex2f(14.067813f,3.358750f);
  glVertex2f(14.238438f,18.391562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.484375f,1.007813f);
  glVertex2f(12.757813f,1.273750f);
  glVertex2f(12.830937f,20.514687f);
  glVertex2f(13.015625f,1.565313f);
  glVertex2f(13.184688f,20.157188f);
  glVertex2f(13.257813f,1.882500f);
  glVertex2f(13.492188f,19.773438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.484375f,1.007813f);
  glVertex2f(12.359375f,11.250000f);
  glVertex2f(12.354062f,10.467500f);
  glVertex2f(12.338125f,9.732500f);
  glVertex2f(12.311563f,9.045000f);
  glVertex2f(12.274375f,8.405000f);
  glVertex2f(12.226563f,7.812500f);
  glVertex2f(12.189688f,0.764375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.189688f,0.764375f);
  glVertex2f(12.226563f,7.812500f);
  glVertex2f(12.163750f,7.244375f);
  glVertex2f(12.081562f,6.677500f);
  glVertex2f(11.980000f,6.111875f);
  glVertex2f(11.868125f,0.540312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.868125f,0.540312f);
  glVertex2f(11.980000f,6.111875f);
  glVertex2f(11.859062f,5.547500f);
  glVertex2f(11.718750f,4.984375f);
  glVertex2f(11.550312f,4.448750f);
  glVertex2f(11.519688f,0.335625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.345000f,3.966875f);
  glVertex2f(11.102813f,3.538750f);
  glVertex2f(11.144375f,0.150312f);
  glVertex2f(11.519688f,0.335625f);
  glVertex2f(11.550312f,4.448750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.900312f,2.138750f);
  glVertex2f(8.914687f,-0.390625f);
  glVertex2f(9.352813f,2.226875f);
  glVertex2f(9.402500f,-0.343750f);
  glVertex2f(9.771563f,2.373750f);
  glVertex2f(9.869687f,-0.265625f);
  glVertex2f(10.156563f,2.579375f);
  glVertex2f(10.316250f,-0.156250f);
  glVertex2f(10.507813f,2.843750f);
  glVertex2f(10.742188f,-0.015625f);
  glVertex2f(10.823750f,3.164375f);
  glVertex2f(11.144375f,0.150312f);
  glVertex2f(11.102813f,3.538750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.050938f,2.373750f);
  glVertex2f(7.057500f,-0.287500f);
  glVertex2f(7.472813f,2.226875f);
  glVertex2f(7.712812f,-0.376563f);
  glVertex2f(7.927187f,2.138750f);
  glVertex2f(8.406250f,-0.406250f);
  glVertex2f(8.414063f,2.109375f);
  glVertex2f(8.914687f,-0.390625f);
  glVertex2f(8.900312f,2.138750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.661562f,2.579375f);
  glVertex2f(6.304688f,2.843750f);
  glVertex2f(6.440312f,-0.139062f);
  glVertex2f(7.057500f,-0.287500f);
  glVertex2f(7.050938f,2.373750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.982812f,3.164375f);
  glVertex2f(5.698438f,3.538750f);
  glVertex2f(5.861250f,0.068750f);
  glVertex2f(6.440312f,-0.139062f);
  glVertex2f(6.304688f,2.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.451562f,3.966875f);
  glVertex2f(5.242188f,4.448750f);
  glVertex2f(5.320313f,0.335938f);
  glVertex2f(5.861250f,0.068750f);
  glVertex2f(5.698438f,3.538750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.242188f,4.448750f);
  glVertex2f(5.070313f,4.984375f);
  glVertex2f(5.320313f,0.335938f);
  glVertex2f(4.927187f,5.547500f);
  glVertex2f(4.821875f,0.647812f);
  glVertex2f(4.804062f,6.111875f);
  glVertex2f(4.700937f,6.677500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.821875f,0.647812f);
  glVertex2f(4.700937f,6.677500f);
  glVertex2f(4.617813f,7.244375f);
  glVertex2f(4.554688f,7.812500f);
  glVertex2f(4.506875f,8.405000f);
  glVertex2f(4.469687f,9.045000f);
  glVertex2f(4.370313f,0.989688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.370313f,0.989688f);
  glVertex2f(4.469687f,9.045000f);
  glVertex2f(4.443125f,9.732500f);
  glVertex2f(4.427187f,10.467500f);
  glVertex2f(4.421875f,11.250000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.578125f,18.046875f);
  glVertex2f(8.578125f,0.000000f);
  glVertex2f(11.375000f,0.000000f);
  glVertex2f(11.375000f,21.656250f);
  glVertex2f(8.375000f,21.656250f);
  glVertex2f(8.356250f,21.648125f);
  glVertex2f(8.300000f,21.598749f);
  glVertex2f(8.206250f,21.508125f);
  glVertex2f(8.075000f,21.376249f);
  glVertex2f(7.906250f,21.203125f);
  glVertex2f(7.860625f,17.572500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.860625f,17.572500f);
  glVertex2f(7.906250f,21.203125f);
  glVertex2f(7.692500f,20.991249f);
  glVertex2f(7.426250f,20.743126f);
  glVertex2f(7.107500f,20.458750f);
  glVertex2f(7.033125f,17.086876f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.107500f,20.458750f);
  glVertex2f(6.736250f,20.138124f);
  glVertex2f(7.033125f,17.086876f);
  glVertex2f(6.312500f,19.781250f);
  glVertex2f(6.095625f,16.590000f);
  glVertex2f(5.855625f,19.411875f);
  glVertex2f(5.385000f,19.053751f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.048125f,16.081875f);
  glVertex2f(6.095625f,16.590000f);
  glVertex2f(5.385000f,19.053751f);
  glVertex2f(4.900625f,18.706875f);
  glVertex2f(4.402500f,18.371250f);
  glVertex2f(3.890625f,18.046875f);
  glVertex2f(3.890625f,15.562500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.156250f,2.343750f);
  glVertex2f(5.271875f,2.472500f);
  glVertex2f(5.853437f,7.254063f);
  glVertex2f(4.642500f,5.902500f);
  glVertex2f(3.305938f,4.411562f);
  glVertex2f(1.843750f,2.781250f);
  glVertex2f(14.906250f,0.000000f);
  glVertex2f(14.906250f,2.343750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.789063f,14.914063f);
  glVertex2f(14.831250f,15.153125f);
  glVertex2f(14.839687f,17.096563f);
  glVertex2f(14.864062f,15.401563f);
  glVertex2f(14.906250f,16.203125f);
  glVertex2f(14.887500f,15.659375f);
  glVertex2f(14.901563f,15.926562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.511562f,13.931562f);
  glVertex2f(14.597813f,14.185625f);
  glVertex2f(14.640000f,17.951876f);
  glVertex2f(14.672812f,14.434063f);
  glVertex2f(14.839687f,17.096563f);
  glVertex2f(14.736563f,14.676875f);
  glVertex2f(14.789063f,14.914063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.176562f,13.139375f);
  glVertex2f(14.303125f,13.407500f);
  glVertex2f(14.307187f,18.769062f);
  glVertex2f(14.414063f,13.671875f);
  glVertex2f(14.640000f,17.951876f);
  glVertex2f(14.511562f,13.931562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.512188f,12.023438f);
  glVertex2f(13.703125f,12.312500f);
  glVertex2f(13.841250f,19.548124f);
  glVertex2f(13.876562f,12.591875f);
  glVertex2f(14.307187f,18.769062f);
  glVertex2f(14.034375f,12.867500f);
  glVertex2f(14.176562f,13.139375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.823125f,11.062500f);
  glVertex2f(13.072187f,11.398438f);
  glVertex2f(13.242188f,20.289063f);
  glVertex2f(13.301875f,11.718750f);
  glVertex2f(13.841250f,19.548124f);
  glVertex2f(13.512188f,12.023438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.959687f,9.967188f);
  glVertex2f(12.266875f,10.345312f);
  glVertex2f(12.524375f,20.938749f);
  glVertex2f(12.554688f,10.710938f);
  glVertex2f(13.242188f,20.289063f);
  glVertex2f(12.823125f,11.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.800625f,17.194374f);
  glVertex2f(11.891562f,16.536875f);
  glVertex2f(12.524375f,20.938749f);
  glVertex2f(11.921875f,15.796875f);
  glVertex2f(11.959687f,9.967188f);
  glVertex2f(11.886250f,15.371250f);
  glVertex2f(11.779375f,14.919375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.702188f,21.444063f);
  glVertex2f(10.775625f,21.805000f);
  glVertex2f(10.819375f,19.003750f);
  glVertex2f(11.164063f,18.671875f);
  glVertex2f(11.436875f,18.261875f);
  glVertex2f(11.649062f,17.769375f);
  glVertex2f(11.800625f,17.194374f);
  glVertex2f(12.524375f,20.938749f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.009687f,19.557501f);
  glVertex2f(8.609375f,19.593750f);
  glVertex2f(8.609375f,22.093750f);
  glVertex2f(9.286563f,19.556875f);
  glVertex2f(9.744687f,22.021563f);
  glVertex2f(9.880625f,19.446251f);
  glVertex2f(10.775625f,21.805000f);
  glVertex2f(10.391562f,19.261875f);
  glVertex2f(10.819375f,19.003750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.609375f,22.093750f);
  glVertex2f(6.441875f,21.841875f);
  glVertex2f(6.589375f,19.013750f);
  glVertex2f(6.999688f,19.267500f);
  glVertex2f(7.473125f,19.448750f);
  glVertex2f(8.009687f,19.557501f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.441875f,21.841875f);
  glVertex2f(4.714375f,21.086250f);
  glVertex2f(5.334688f,16.547501f);
  glVertex2f(5.495000f,17.211874f);
  glVertex2f(5.699687f,17.790001f);
  glVertex2f(5.948750f,18.281876f);
  glVertex2f(6.242188f,18.687500f);
  glVertex2f(6.589375f,19.013750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.218750f,15.796875f);
  glVertex2f(5.334688f,16.547501f);
  glVertex2f(4.714375f,21.086250f);
  glVertex2f(3.426875f,19.826876f);
  glVertex2f(2.579375f,18.063749f);
  glVertex2f(2.171875f,15.796875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.633125f,9.576563f);
  glVertex2f(11.959687f,9.967188f);
  glVertex2f(11.779375f,14.919375f);
  glVertex2f(11.601250f,14.441250f);
  glVertex2f(11.351875f,13.936875f);
  glVertex2f(11.287188f,9.173437f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.123125f,7.857812f);
  glVertex2f(10.534687f,8.321875f);
  glVertex2f(10.620937f,12.816563f);
  glVertex2f(10.921875f,8.757813f);
  glVertex2f(11.031250f,13.406250f);
  glVertex2f(11.287188f,9.173437f);
  glVertex2f(11.351875f,13.936875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.742188f,6.296875f);
  glVertex2f(9.226875f,6.845313f);
  glVertex2f(9.475938f,11.361563f);
  glVertex2f(9.687187f,7.365625f);
  glVertex2f(10.102500f,12.135000f);
  glVertex2f(10.123125f,7.857812f);
  glVertex2f(10.620937f,12.816563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.130625f,4.502500f);
  glVertex2f(7.694687f,5.124375f);
  glVertex2f(7.898438f,9.539063f);
  glVertex2f(8.231875f,5.722500f);
  glVertex2f(8.741250f,10.496250f);
  glVertex2f(8.742188f,6.296875f);
  glVertex2f(9.475938f,11.361563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.938750f,8.466250f);
  glVertex2f(5.853437f,7.254063f);
  glVertex2f(5.921875f,3.187500f);
  glVertex2f(6.539688f,3.856875f);
  glVertex2f(7.130625f,4.502500f);
  glVertex2f(7.898438f,9.539063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.853437f,7.254063f);
  glVertex2f(5.271875f,2.472500f);
  glVertex2f(5.406250f,2.621250f);
  glVertex2f(5.559375f,2.790000f);
  glVertex2f(5.731250f,2.978750f);
  glVertex2f(5.921875f,3.187500f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(14.906250f,0.000000f);
  glVertex2f(1.843750f,2.781250f);
  glVertex2f(1.843750f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.156250f,10.210938f);
  glVertex2f(12.960625f,10.345938f);
  glVertex2f(13.375000f,1.367188f);
  glVertex2f(12.748750f,10.482187f);
  glVertex2f(12.531875f,0.728750f);
  glVertex2f(12.520625f,10.619687f);
  glVertex2f(12.390625f,5.531250f);
  glVertex2f(12.276250f,10.758437f);
  glVertex2f(12.148125f,7.198125f);
  glVertex2f(12.015625f,10.898438f);
  glVertex2f(11.765625f,11.030000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.553125f,11.143437f);
  glVertex2f(11.378125f,11.238750f);
  glVertex2f(11.420625f,8.486250f);
  glVertex2f(12.148125f,7.198125f);
  glVertex2f(11.765625f,11.030000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.420625f,8.486250f);
  glVertex2f(11.378125f,11.238750f);
  glVertex2f(11.240625f,11.315937f);
  glVertex2f(11.140625f,11.375000f);
  glVertex2f(10.593750f,13.453125f);
  glVertex2f(10.208125f,9.395625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.140625f,11.375000f);
  glVertex2f(11.336250f,11.478437f);
  glVertex2f(11.523750f,14.418125f);
  glVertex2f(11.116875f,13.888125f);
  glVertex2f(10.593750f,13.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.593750f,13.453125f);
  glVertex2f(9.958125f,13.104375f);
  glVertex2f(10.208125f,9.395625f);
  glVertex2f(9.213750f,12.833125f);
  glVertex2f(8.510625f,9.926250f);
  glVertex2f(8.360625f,12.639375f);
  glVertex2f(7.398750f,12.523125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.328125f,12.484375f);
  glVertex2f(6.328125f,10.078125f);
  glVertex2f(8.510625f,9.926250f);
  glVertex2f(7.398750f,12.523125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.326250f,6.668125f);
  glVertex2f(15.265312f,7.072813f);
  glVertex2f(15.295000f,4.769688f);
  glVertex2f(15.375000f,5.796875f);
  glVertex2f(15.362812f,6.242813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.265312f,7.072813f);
  glVertex2f(15.180000f,7.456875f);
  glVertex2f(15.295000f,4.769688f);
  glVertex2f(15.070313f,7.820313f);
  glVertex2f(15.055000f,3.813125f);
  glVertex2f(14.937813f,8.161563f);
  glVertex2f(14.784062f,8.479062f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.655000f,2.927187f);
  glVertex2f(15.055000f,3.813125f);
  glVertex2f(14.784062f,8.479062f);
  glVertex2f(14.609062f,8.772813f);
  glVertex2f(14.412812f,9.042812f);
  glVertex2f(14.195313f,9.289063f);
  glVertex2f(14.095000f,2.111875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.095000f,2.111875f);
  glVertex2f(14.195313f,9.289063f);
  glVertex2f(13.971250f,9.513437f);
  glVertex2f(13.755313f,9.717813f);
  glVertex2f(13.547500f,9.902187f);
  glVertex2f(13.375000f,1.367188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.347813f,10.066563f);
  glVertex2f(13.156250f,10.210938f);
  glVertex2f(13.375000f,1.367188f);
  glVertex2f(13.547500f,9.902187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.531875f,0.728750f);
  glVertex2f(12.390625f,5.531250f);
  glVertex2f(12.340938f,4.975313f);
  glVertex2f(12.191875f,4.445000f);
  glVertex2f(11.943438f,3.940313f);
  glVertex2f(11.602500f,0.232187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.602500f,0.232187f);
  glVertex2f(11.943438f,3.940313f);
  glVertex2f(11.595625f,3.461250f);
  glVertex2f(11.148438f,3.007813f);
  glVertex2f(10.640000f,2.611250f);
  glVertex2f(10.586875f,-0.122500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.640000f,2.611250f);
  glVertex2f(10.108438f,2.302813f);
  glVertex2f(10.586875f,-0.122500f);
  glVertex2f(9.553750f,2.082500f);
  glVertex2f(9.485000f,-0.335313f);
  glVertex2f(8.975938f,1.950312f);
  glVertex2f(8.375000f,1.906250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.485000f,-0.335313f);
  glVertex2f(8.375000f,1.906250f);
  glVertex2f(8.296875f,-0.406250f);
  glVertex2f(7.118125f,2.058750f);
  glVertex2f(7.000312f,-0.333750f);
  glVertex2f(6.110000f,2.516250f);
  glVertex2f(5.835625f,-0.116250f);
  glVertex2f(5.350625f,3.278750f);
  glVertex2f(4.840000f,4.346250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.132813f,1.406250f);
  glVertex2f(3.901875f,0.753750f);
  glVertex2f(4.578125f,5.718750f);
  glVertex2f(4.802813f,0.246250f);
  glVertex2f(4.840000f,4.346250f);
  glVertex2f(5.835625f,-0.116250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.578125f,5.718750f);
  glVertex2f(1.375000f,5.718750f);
  glVertex2f(1.445313f,4.746250f);
  glVertex2f(1.656250f,3.828750f);
  glVertex2f(2.007813f,2.966250f);
  glVertex2f(2.500000f,2.158750f);
  glVertex2f(3.132813f,1.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.761250f,14.835000f);
  glVertex2f(14.879375f,15.204062f);
  glVertex2f(14.955625f,17.328751f);
  glVertex2f(14.963750f,15.583750f);
  glVertex2f(15.031250f,16.375000f);
  glVertex2f(15.014375f,15.974063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.728750f,18.215000f);
  glVertex2f(14.350625f,19.033751f);
  glVertex2f(14.432813f,14.138125f);
  glVertex2f(14.609375f,14.476563f);
  glVertex2f(14.761250f,14.835000f);
  glVertex2f(14.955625f,17.328751f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.570313f,13.078125f);
  glVertex2f(13.809375f,13.299063f);
  glVertex2f(13.821250f,19.785000f);
  glVertex2f(14.032812f,13.549375f);
  glVertex2f(14.350625f,19.033751f);
  glVertex2f(14.240625f,13.829062f);
  glVertex2f(14.432813f,14.138125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.810000f,12.473437f);
  glVertex2f(13.067813f,12.671875f);
  glVertex2f(13.140625f,20.468750f);
  glVertex2f(13.321250f,12.873438f);
  glVertex2f(13.821250f,19.785000f);
  glVertex2f(13.570313f,13.078125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.810000f,12.473437f);
  glVertex2f(13.140625f,20.468750f);
  glVertex2f(12.547812f,12.278125f);
  glVertex2f(12.339375f,21.053749f);
  glVertex2f(12.281250f,12.085938f);
  glVertex2f(12.046875f,16.578125f);
  glVertex2f(12.020625f,11.905000f);
  glVertex2f(11.988750f,15.763125f);
  glVertex2f(11.814375f,15.043125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.339375f,21.053749f);
  glVertex2f(11.448125f,21.508749f);
  glVertex2f(11.619375f,18.278749f);
  glVertex2f(11.856875f,17.788124f);
  glVertex2f(11.999375f,17.221251f);
  glVertex2f(12.046875f,16.578125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.879375f,19.511250f);
  glVertex2f(10.376875f,19.301250f);
  glVertex2f(10.466875f,21.833750f);
  glVertex2f(10.859375f,19.031250f);
  glVertex2f(11.448125f,21.508749f);
  glVertex2f(11.286875f,18.693125f);
  glVertex2f(11.619375f,18.278749f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.395625f,22.028749f);
  glVertex2f(8.234375f,22.093750f);
  glVertex2f(8.296875f,19.781250f);
  glVertex2f(8.839375f,19.751249f);
  glVertex2f(9.366875f,19.661249f);
  glVertex2f(9.879375f,19.511250f);
  glVertex2f(10.466875f,21.833750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.859375f,16.031250f);
  glVertex2f(5.206875f,17.381250f);
  glVertex2f(5.333750f,21.528437f);
  glVertex2f(5.724375f,18.431250f);
  glVertex2f(6.211875f,21.842501f);
  glVertex2f(6.411875f,19.181250f);
  glVertex2f(7.178750f,22.030937f);
  glVertex2f(7.269375f,19.631250f);
  glVertex2f(8.234375f,22.093750f);
  glVertex2f(8.296875f,19.781250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.859375f,16.031250f);
  glVertex2f(5.333750f,21.528437f);
  glVertex2f(4.544375f,21.088751f);
  glVertex2f(3.843750f,20.523438f);
  glVertex2f(3.237500f,19.841249f);
  glVertex2f(2.731250f,19.050938f);
  glVertex2f(2.325000f,18.152500f);
  glVertex2f(2.018750f,17.145937f);
  glVertex2f(1.812500f,16.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.814375f,15.043125f);
  glVertex2f(11.523750f,14.418125f);
  glVertex2f(11.548125f,11.601250f);
  glVertex2f(11.776250f,11.743438f);
  glVertex2f(12.020625f,11.905000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(11.523750f,14.418125f);
  glVertex2f(11.336250f,11.478437f);
  glVertex2f(11.548125f,11.601250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.906250f,21.656250f);
  glVertex2f(0.906250f,8.437500f);
  glVertex2f(3.312500f,7.765625f);
  glVertex2f(10.406250f,5.281250f);
  glVertex2f(10.406250f,7.765625f);
  glVertex2f(13.218750f,0.000000f);
  glVertex2f(10.406250f,18.375000f);
  glVertex2f(13.218750f,21.656250f);
  glVertex2f(9.906250f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.218750f,5.281250f);
  glVertex2f(15.875000f,5.281250f);
  glVertex2f(13.218750f,7.765625f);
  glVertex2f(13.218750f,21.656250f);
  glVertex2f(13.218750f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(13.218750f,0.000000f);
  glVertex2f(10.406250f,5.281250f);
  glVertex2f(10.406250f,0.000000f);
  glVertex2f(13.218750f,7.765625f);
  glVertex2f(15.875000f,5.281250f);
  glVertex2f(15.875000f,7.765625f);
  glVertex2f(9.906250f,21.656250f);
  glVertex2f(3.312500f,7.765625f);
  glVertex2f(10.406250f,18.375000f);
  glVertex2f(10.406250f,5.281250f);
  glVertex2f(0.906250f,8.437500f);
  glVertex2f(0.906250f,5.281250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.250000f,19.156250f);
  glVertex2f(13.796875f,19.156250f);
  glVertex2f(13.796875f,21.656250f);
  glVertex2f(2.312500f,21.656250f);
  glVertex2f(4.625000f,9.046875f);
  glVertex2f(4.890625f,12.359375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.171875f,7.125000f);
  glVertex2f(15.098125f,8.306875f);
  glVertex2f(15.100625f,5.976250f);
  glVertex2f(14.901875f,9.415000f);
  glVertex2f(14.861875f,4.880000f);
  glVertex2f(14.583125f,10.449375f);
  glVertex2f(14.455625f,3.836250f);
  glVertex2f(14.141875f,11.410000f);
  glVertex2f(13.881875f,2.845000f);
  glVertex2f(13.578125f,12.296875f);
  glVertex2f(13.140625f,1.906250f);
  glVertex2f(12.905625f,13.061875f);
  glVertex2f(12.303125f,1.085000f);
  glVertex2f(12.156250f,7.062500f);
  glVertex2f(12.110625f,6.154063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.138125f,13.656875f);
  glVertex2f(11.275625f,14.081875f);
  glVertex2f(11.588750f,10.342500f);
  glVertex2f(12.014375f,8.907500f);
  glVertex2f(12.156250f,7.062500f);
  glVertex2f(12.905625f,13.061875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.588750f,10.342500f);
  glVertex2f(11.275625f,14.081875f);
  glVertex2f(10.879375f,11.367500f);
  glVertex2f(10.318125f,14.336875f);
  glVertex2f(9.886250f,11.982500f);
  glVertex2f(9.265625f,14.421875f);
  glVertex2f(8.852813f,14.412812f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.609375f,12.187500f);
  glVertex2f(9.886250f,11.982500f);
  glVertex2f(8.852813f,14.412812f);
  glVertex2f(8.464375f,14.385625f);
  glVertex2f(8.100312f,14.340313f);
  glVertex2f(7.760625f,14.276875f);
  glVertex2f(7.615000f,12.061875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.615000f,12.061875f);
  glVertex2f(7.760625f,14.276875f);
  glVertex2f(7.445313f,14.195313f);
  glVertex2f(7.160000f,14.105000f);
  glVertex2f(6.910313f,14.015312f);
  glVertex2f(6.719375f,11.685000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.719375f,11.685000f);
  glVertex2f(6.910313f,14.015312f);
  glVertex2f(6.696250f,13.926250f);
  glVertex2f(6.517813f,13.837812f);
  glVertex2f(6.375000f,13.750000f);
  glVertex2f(6.242500f,13.650937f);
  glVertex2f(6.095000f,13.528750f);
  glVertex2f(5.932500f,13.383437f);
  glVertex2f(5.922500f,11.056875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.922500f,11.056875f);
  glVertex2f(5.932500f,13.383437f);
  glVertex2f(5.755000f,13.215000f);
  glVertex2f(5.562500f,13.023438f);
  glVertex2f(5.375625f,12.834375f);
  glVertex2f(5.224375f,10.177500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.224375f,10.177500f);
  glVertex2f(5.375625f,12.834375f);
  glVertex2f(5.215000f,12.673437f);
  glVertex2f(5.080625f,12.540625f);
  glVertex2f(4.972500f,12.435938f);
  glVertex2f(4.890625f,12.359375f);
  glVertex2f(4.625000f,9.046875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.110625f,6.154063f);
  glVertex2f(11.973750f,5.328750f);
  glVertex2f(12.303125f,1.085000f);
  glVertex2f(11.745625f,4.586563f);
  glVertex2f(11.440625f,0.446250f);
  glVertex2f(11.426250f,3.927500f);
  glVertex2f(11.015625f,3.351563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.553124f,-0.010000f);
  glVertex2f(11.440625f,0.446250f);
  glVertex2f(11.015625f,3.351563f);
  glVertex2f(10.545000f,2.870625f);
  glVertex2f(10.045625f,2.496562f);
  glVertex2f(9.640625f,-0.283750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.045625f,2.496562f);
  glVertex2f(9.517500f,2.229375f);
  glVertex2f(9.640625f,-0.283750f);
  glVertex2f(8.960625f,2.069062f);
  glVertex2f(8.703125f,-0.375000f);
  glVertex2f(8.375000f,2.015625f);
  glVertex2f(7.744688f,2.048438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.423750f,-0.315313f);
  glVertex2f(8.703125f,-0.375000f);
  glVertex2f(7.744688f,2.048438f);
  glVertex2f(7.166250f,2.146875f);
  glVertex2f(6.639688f,2.310937f);
  glVertex2f(6.260625f,-0.136250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.260625f,-0.136250f);
  glVertex2f(6.639688f,2.310937f);
  glVertex2f(6.165000f,2.540625f);
  glVertex2f(5.742188f,2.835938f);
  glVertex2f(5.385000f,3.196250f);
  glVertex2f(5.213750f,0.162188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.213750f,0.162188f);
  glVertex2f(5.385000f,3.196250f);
  glVertex2f(5.107188f,3.620937f);
  glVertex2f(4.908750f,4.110000f);
  glVertex2f(4.789688f,4.663437f);
  glVertex2f(4.283125f,0.580000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.750000f,5.281250f);
  glVertex2f(1.578125f,5.281250f);
  glVertex2f(1.653750f,4.259687f);
  glVertex2f(1.880625f,3.332500f);
  glVertex2f(2.258750f,2.499687f);
  glVertex2f(2.788125f,1.761250f);
  glVertex2f(3.468750f,1.117188f);
  glVertex2f(4.283125f,0.580000f);
  glVertex2f(4.789688f,4.663437f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.625000f,9.046875f);
  glVertex2f(2.312500f,21.656250f);
  glVertex2f(1.937500f,9.046875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.765625f,16.500000f);
  glVertex2f(14.709375f,17.163124f);
  glVertex2f(14.590625f,17.802500f);
  glVertex2f(14.409375f,18.418125f);
  glVertex2f(14.165625f,19.010000f);
  glVertex2f(13.859375f,19.578125f);
  glVertex2f(13.548125f,20.053749f);
  glVertex2f(13.201875f,20.480625f);
  glVertex2f(12.820625f,20.858749f);
  glVertex2f(12.404375f,21.188126f);
  glVertex2f(11.953125f,21.468750f);
  glVertex2f(11.890625f,16.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.953125f,21.468750f);
  glVertex2f(11.394375f,21.718750f);
  glVertex2f(11.580625f,18.094999f);
  glVertex2f(11.735000f,17.720625f);
  glVertex2f(11.838125f,17.330000f);
  glVertex2f(11.890000f,16.923124f);
  glVertex2f(11.890625f,16.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.394375f,21.718750f);
  glVertex2f(10.793125f,21.906250f);
  glVertex2f(10.977500f,18.940624f);
  glVertex2f(11.185000f,18.709375f);
  glVertex2f(11.375000f,18.453125f);
  glVertex2f(11.580625f,18.094999f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.793125f,21.906250f);
  glVertex2f(10.149375f,22.031250f);
  glVertex2f(10.250000f,19.484375f);
  glVertex2f(10.510000f,19.328125f);
  glVertex2f(10.752500f,19.146875f);
  glVertex2f(10.977500f,18.940624f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.015000f,19.794374f);
  glVertex2f(9.344375f,19.771250f);
  glVertex2f(9.463125f,22.093750f);
  glVertex2f(9.660000f,19.711876f);
  glVertex2f(10.149375f,22.031250f);
  glVertex2f(9.961875f,19.616249f);
  glVertex2f(10.250000f,19.484375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.734375f,22.093750f);
  glVertex2f(8.209375f,22.053749f);
  glVertex2f(8.264375f,19.719376f);
  glVertex2f(8.671875f,19.781250f);
  glVertex2f(9.015000f,19.794374f);
  glVertex2f(9.463125f,22.093750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.734375f,18.984375f);
  glVertex2f(7.101875f,19.241249f);
  glVertex2f(7.196875f,21.883751f);
  glVertex2f(7.479375f,19.449375f);
  glVertex2f(7.696875f,21.983749f);
  glVertex2f(7.866875f,19.608749f);
  glVertex2f(8.209375f,22.053749f);
  glVertex2f(8.264375f,19.719376f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.875625f,18.123751f);
  glVertex2f(6.144375f,18.439375f);
  glVertex2f(6.234375f,21.593750f);
  glVertex2f(6.430625f,18.726250f);
  glVertex2f(6.709375f,21.753750f);
  glVertex2f(6.734375f,18.984375f);
  glVertex2f(7.196875f,21.883751f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.748125f,21.391251f);
  glVertex2f(5.289375f,21.158751f);
  glVertex2f(5.390625f,17.406250f);
  glVertex2f(5.624375f,17.779375f);
  glVertex2f(5.875625f,18.123751f);
  glVertex2f(6.234375f,21.593750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.625625f,15.064375f);
  glVertex2f(4.825625f,15.948750f);
  glVertex2f(4.858125f,20.896250f);
  glVertex2f(5.080625f,16.729376f);
  glVertex2f(5.289375f,21.158751f);
  glVertex2f(5.390625f,17.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.373750f,12.529375f);
  glVertex2f(4.390625f,12.984375f);
  glVertex2f(4.454375f,20.603750f);
  glVertex2f(4.480625f,14.076250f);
  glVertex2f(4.858125f,20.896250f);
  glVertex2f(4.625625f,15.064375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.454375f,20.603750f);
  glVertex2f(4.078125f,20.281250f);
  glVertex2f(4.345625f,11.104375f);
  glVertex2f(4.351250f,11.589375f);
  glVertex2f(4.360625f,12.064375f);
  glVertex2f(4.373750f,12.529375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.345625f,11.104375f);
  glVertex2f(4.078125f,20.281250f);
  glVertex2f(4.343750f,10.609375f);
  glVertex2f(4.453125f,0.906250f);
  glVertex2f(4.540625f,10.909375f);
  glVertex2f(4.733750f,5.854375f);
  glVertex2f(4.718750f,6.468750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.359375f,6.468750f);
  glVertex2f(15.342500f,7.085000f);
  glVertex2f(15.338125f,5.825625f);
  glVertex2f(15.291875f,7.683750f);
  glVertex2f(15.274375f,5.208750f);
  glVertex2f(15.207500f,8.265000f);
  glVertex2f(15.168125f,4.618125f);
  glVertex2f(15.089375f,8.828750f);
  glVertex2f(15.019375f,4.053750f);
  glVertex2f(14.937500f,9.375000f);
  glVertex2f(14.828125f,3.515625f);
  glVertex2f(14.690000f,10.066250f);
  glVertex2f(14.494375f,2.787500f);
  glVertex2f(14.385000f,10.690000f);
  glVertex2f(14.080625f,2.128125f);
  glVertex2f(14.022500f,11.246250f);
  glVertex2f(13.602500f,11.735000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.080625f,2.128125f);
  glVertex2f(13.602500f,11.735000f);
  glVertex2f(13.586875f,1.537500f);
  glVertex2f(13.125000f,12.156250f);
  glVertex2f(13.013125f,1.015625f);
  glVertex2f(12.785625f,12.393750f);
  glVertex2f(12.417500f,12.606250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.359375f,0.562500f);
  glVertex2f(13.013125f,1.015625f);
  glVertex2f(12.417500f,12.606250f);
  glVertex2f(12.312500f,6.468750f);
  glVertex2f(12.296875f,5.854375f);
  glVertex2f(12.250000f,5.298750f);
  glVertex2f(12.171875f,4.801875f);
  glVertex2f(12.062500f,4.363750f);
  glVertex2f(11.921875f,3.984375f);
  glVertex2f(11.736875f,3.592500f);
  glVertex2f(11.685625f,0.203750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.417500f,12.606250f);
  glVertex2f(12.020625f,12.793750f);
  glVertex2f(12.062500f,8.608750f);
  glVertex2f(12.171875f,8.160000f);
  glVertex2f(12.250000f,7.653750f);
  glVertex2f(12.296875f,7.090000f);
  glVertex2f(12.312500f,6.468750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.243125f,10.029375f);
  glVertex2f(11.511875f,9.720000f);
  glVertex2f(11.595000f,12.956250f);
  glVertex2f(11.738125f,9.376875f);
  glVertex2f(12.020625f,12.793750f);
  glVertex2f(11.921875f,9.000000f);
  glVertex2f(12.062500f,8.608750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.978125f,11.056875f);
  glVertex2f(9.406250f,10.993125f);
  glVertex2f(9.410625f,13.368750f);
  glVertex2f(9.815625f,10.886875f);
  glVertex2f(9.848750f,13.328125f);
  glVertex2f(10.206250f,10.738125f);
  glVertex2f(10.283125f,13.268750f);
  glVertex2f(10.578125f,10.546875f);
  glVertex2f(10.713750f,13.190625f);
  glVertex2f(10.931875f,10.305000f);
  glVertex2f(11.140625f,13.093750f);
  glVertex2f(11.243125f,10.029375f);
  glVertex2f(11.595000f,12.956250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.796875f,13.015625f);
  glVertex2f(6.846250f,10.738125f);
  glVertex2f(7.163750f,13.160625f);
  glVertex2f(7.241250f,10.886875f);
  glVertex2f(7.564375f,13.270625f);
  glVertex2f(7.653750f,10.993125f);
  glVertex2f(7.998750f,13.345625f);
  glVertex2f(8.083750f,11.056875f);
  glVertex2f(8.466875f,13.385625f);
  glVertex2f(8.531250f,11.078125f);
  glVertex2f(8.968750f,13.390625f);
  glVertex2f(8.978125f,11.056875f);
  glVertex2f(9.410625f,13.368750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.958750f,8.608750f);
  glVertex2f(5.093750f,9.000000f);
  glVertex2f(5.168750f,11.734375f);
  glVertex2f(5.283750f,9.376875f);
  glVertex2f(5.390625f,11.984375f);
  glVertex2f(5.516250f,9.720000f);
  glVertex2f(5.661875f,12.240625f);
  glVertex2f(5.791250f,10.029375f);
  glVertex2f(5.938125f,12.471875f);
  glVertex2f(6.108750f,10.305000f);
  glVertex2f(6.219375f,12.678125f);
  glVertex2f(6.468750f,10.546875f);
  glVertex2f(6.505625f,12.859375f);
  glVertex2f(6.846250f,10.738125f);
  glVertex2f(6.796875f,13.015625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.953125f,11.471875f);
  glVertex2f(4.743750f,11.196875f);
  glVertex2f(4.778750f,7.653750f);
  glVertex2f(4.853750f,8.160000f);
  glVertex2f(4.958750f,8.608750f);
  glVertex2f(5.168750f,11.734375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.743750f,11.196875f);
  glVertex2f(4.540625f,10.909375f);
  glVertex2f(4.718750f,6.468750f);
  glVertex2f(4.733750f,7.090000f);
  glVertex2f(4.778750f,7.653750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.736875f,3.592500f);
  glVertex2f(11.506875f,3.241875f);
  glVertex2f(11.685625f,0.203750f);
  glVertex2f(11.231875f,2.932500f);
  glVertex2f(10.976875f,-0.072500f);
  glVertex2f(10.911875f,2.664375f);
  glVertex2f(10.546875f,2.437500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.233125f,-0.266250f);
  glVertex2f(10.976875f,-0.072500f);
  glVertex2f(10.546875f,2.437500f);
  glVertex2f(10.186250f,2.246250f);
  glVertex2f(9.804375f,2.097500f);
  glVertex2f(9.454375f,-0.377500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.804375f,2.097500f);
  glVertex2f(9.401250f,1.991250f);
  glVertex2f(9.454375f,-0.377500f);
  glVertex2f(8.976875f,1.927500f);
  glVertex2f(8.640625f,-0.406250f);
  glVertex2f(8.531250f,1.906250f);
  glVertex2f(8.083750f,1.927500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.723125f,-0.343750f);
  glVertex2f(8.640625f,-0.406250f);
  glVertex2f(8.083750f,1.927500f);
  glVertex2f(7.653750f,1.991250f);
  glVertex2f(7.241250f,2.097500f);
  glVertex2f(6.846250f,2.246250f);
  glVertex2f(6.845625f,-0.181250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.846250f,2.246250f);
  glVertex2f(6.468750f,2.437500f);
  glVertex2f(6.845625f,-0.181250f);
  glVertex2f(6.113750f,2.664375f);
  glVertex2f(6.008125f,0.081250f);
  glVertex2f(5.798750f,2.932500f);
  glVertex2f(5.523750f,3.241875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.288750f,3.592500f);
  glVertex2f(5.093750f,3.984375f);
  glVertex2f(5.210625f,0.443750f);
  glVertex2f(6.008125f,0.081250f);
  glVertex2f(5.523750f,3.241875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.210625f,0.443750f);
  glVertex2f(5.093750f,3.984375f);
  glVertex2f(4.958750f,4.363750f);
  glVertex2f(4.853750f,4.801875f);
  glVertex2f(4.778750f,5.298750f);
  glVertex2f(4.453125f,0.906250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.747500f,1.471875f);
  glVertex2f(4.453125f,0.906250f);
  glVertex2f(4.078125f,20.281250f);
  glVertex2f(3.729375f,19.934999f);
  glVertex2f(3.408125f,19.558750f);
  glVertex2f(3.130625f,2.106250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.130625f,2.106250f);
  glVertex2f(3.408125f,19.558750f);
  glVertex2f(3.114375f,19.152500f);
  glVertex2f(2.848125f,18.716249f);
  glVertex2f(2.609375f,18.250000f);
  glVertex2f(2.602500f,2.809375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.609375f,18.250000f);
  glVertex2f(2.441250f,17.828751f);
  glVertex2f(2.602500f,2.809375f);
  glVertex2f(2.286875f,17.377501f);
  glVertex2f(2.163125f,3.581250f);
  glVertex2f(2.146250f,16.896250f);
  glVertex2f(2.019375f,16.385000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.906250f,15.843750f);
  glVertex2f(1.811250f,15.171250f);
  glVertex2f(1.812500f,4.421875f);
  glVertex2f(2.163125f,3.581250f);
  glVertex2f(2.019375f,16.385000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.406250f,10.281250f);
  glVertex2f(1.425313f,6.075625f);
  glVertex2f(1.511250f,11.833750f);
  glVertex2f(1.523750f,5.494375f);
  glVertex2f(1.613750f,13.166250f);
  glVertex2f(1.652812f,4.943125f);
  glVertex2f(1.713750f,14.278750f);
  glVertex2f(1.812500f,4.421875f);
  glVertex2f(1.811250f,15.171250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.307812f,8.588125f);
  glVertex2f(1.320313f,7.328125f);
  glVertex2f(1.325000f,9.178750f);
  glVertex2f(1.357500f,6.686875f);
  glVertex2f(1.357813f,9.743125f);
  glVertex2f(1.425313f,6.075625f);
  glVertex2f(1.406250f,10.281250f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(1.320313f,7.328125f);
  glVertex2f(1.307812f,8.588125f);
  glVertex2f(1.306250f,7.971250f);
  glVertex2f(4.733750f,5.854375f);
  glVertex2f(4.453125f,0.906250f);
  glVertex2f(4.778750f,5.298750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.359375f,19.250000f);
  glVertex2f(4.718750f,0.000000f);
  glVertex2f(8.000000f,0.000000f);
  glVertex2f(15.062500f,18.656250f);
  glVertex2f(15.062500f,21.656250f);
  glVertex2f(1.703125f,21.656250f);
  glVertex2f(1.703125f,19.250000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.747188f,12.948125f);
  glVertex2f(6.257500f,13.223750f);
  glVertex2f(6.361875f,9.870625f);
  glVertex2f(5.804688f,13.578125f);
  glVertex2f(5.797500f,9.551250f);
  glVertex2f(5.413750f,13.996875f);
  glVertex2f(5.390625f,11.484375f);
  glVertex2f(5.302813f,11.526875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.960625f,11.714375f);
  glVertex2f(5.087812f,11.641875f);
  glVertex2f(5.109687f,14.465625f);
  glVertex2f(5.201875f,11.579375f);
  glVertex2f(5.413750f,13.996875f);
  glVertex2f(5.302813f,11.526875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.892500f,14.984375f);
  glVertex2f(4.762187f,15.553125f);
  glVertex2f(4.820313f,11.796875f);
  glVertex2f(4.960625f,11.714375f);
  glVertex2f(5.109687f,14.465625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.241875f,12.202812f);
  glVertex2f(4.465312f,12.035625f);
  glVertex2f(4.737500f,21.203751f);
  glVertex2f(4.658125f,11.900312f);
  glVertex2f(4.718750f,16.171875f);
  glVertex2f(4.820313f,11.796875f);
  glVertex2f(4.762187f,15.553125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.500000f,5.531250f);
  glVertex2f(15.481875f,6.029687f);
  glVertex2f(15.473750f,4.915000f);
  glVertex2f(15.427500f,6.512500f);
  glVertex2f(15.395000f,4.328750f);
  glVertex2f(15.336875f,6.979688f);
  glVertex2f(15.263750f,3.772500f);
  glVertex2f(15.210000f,7.431250f);
  glVertex2f(15.080000f,3.246250f);
  glVertex2f(15.046875f,7.867188f);
  glVertex2f(14.861875f,8.277187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.080000f,3.246250f);
  glVertex2f(14.861875f,8.277187f);
  glVertex2f(14.843750f,2.750000f);
  glVertex2f(14.669375f,8.650937f);
  glVertex2f(14.564688f,2.291250f);
  glVertex2f(14.469375f,8.988438f);
  glVertex2f(14.261875f,9.289687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.564688f,2.291250f);
  glVertex2f(14.261875f,9.289687f);
  glVertex2f(14.252500f,1.877500f);
  glVertex2f(14.046875f,9.554688f);
  glVertex2f(13.907187f,1.508750f);
  glVertex2f(13.821563f,9.796562f);
  glVertex2f(13.583125f,10.028438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.907187f,1.508750f);
  glVertex2f(13.583125f,10.028438f);
  glVertex2f(13.528750f,1.185000f);
  glVertex2f(13.331562f,10.250313f);
  glVertex2f(13.117188f,0.906250f);
  glVertex2f(13.066875f,10.462188f);
  glVertex2f(12.789063f,10.664063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.685000f,0.662812f);
  glVertex2f(13.117188f,0.906250f);
  glVertex2f(12.789063f,10.664063f);
  glVertex2f(12.593750f,6.156250f);
  glVertex2f(12.554063f,5.413125f);
  glVertex2f(12.435000f,4.733750f);
  glVertex2f(12.244687f,0.445000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.593750f,6.156250f);
  glVertex2f(12.789063f,10.664063f);
  glVertex2f(12.550000f,6.876250f);
  glVertex2f(12.521875f,10.846562f);
  glVertex2f(12.418750f,7.536250f);
  glVertex2f(12.289063f,11.000313f);
  glVertex2f(12.200000f,8.136250f);
  glVertex2f(12.090625f,11.125313f);
  glVertex2f(11.926562f,11.221562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.893750f,8.676250f);
  glVertex2f(12.200000f,8.136250f);
  glVertex2f(11.926562f,11.221562f);
  glVertex2f(11.796875f,11.289063f);
  glVertex2f(11.688750f,11.339375f);
  glVertex2f(11.589375f,11.384063f);
  glVertex2f(11.500000f,9.156250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.500000f,9.156250f);
  glVertex2f(11.589375f,11.384063f);
  glVertex2f(11.498750f,11.423125f);
  glVertex2f(11.416875f,11.456562f);
  glVertex2f(11.343750f,11.484375f);
  glVertex2f(11.070313f,13.578125f);
  glVertex2f(11.027500f,9.561250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.037812f,12.633125f);
  glVertex2f(9.190000f,10.236250f);
  glVertex2f(9.601250f,12.751250f);
  glVertex2f(9.872499f,10.101250f);
  glVertex2f(10.127812f,12.948125f);
  glVertex2f(10.485000f,9.876250f);
  glVertex2f(10.617500f,13.223750f);
  glVertex2f(11.027500f,9.561250f);
  glVertex2f(11.070313f,13.578125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.747188f,12.948125f);
  glVertex2f(6.990000f,10.098750f);
  glVertex2f(7.273750f,12.751250f);
  glVertex2f(7.681875f,10.235625f);
  glVertex2f(7.837188f,12.633125f);
  glVertex2f(8.437500f,10.281250f);
  glVertex2f(8.437500f,12.593750f);
  glVertex2f(9.190000f,10.236250f);
  glVertex2f(9.037812f,12.633125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.125000f,6.156250f);
  glVertex2f(4.171875f,6.865625f);
  glVertex2f(4.217500f,10.855000f);
  glVertex2f(4.312500f,7.518750f);
  glVertex2f(4.488750f,11.018437f);
  glVertex2f(4.546875f,8.115625f);
  glVertex2f(4.750000f,11.156250f);
  glVertex2f(4.875000f,8.656250f);
  glVertex2f(5.390625f,11.484375f);
  glVertex2f(5.296875f,9.140625f);
  glVertex2f(5.797500f,9.551250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.504687f,4.118125f);
  glVertex2f(4.293750f,4.733750f);
  glVertex2f(4.581563f,0.445000f);
  glVertex2f(4.167188f,5.413125f);
  glVertex2f(4.134062f,0.662813f);
  glVertex2f(4.125000f,6.156250f);
  glVertex2f(3.936250f,10.665937f);
  glVertex2f(4.217500f,10.855000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.434999f,-0.323750f);
  glVertex2f(9.922500f,-0.259688f);
  glVertex2f(9.986250f,2.120000f);
  glVertex2f(10.402500f,-0.170000f);
  glVertex2f(10.619062f,2.348125f);
  glVertex2f(10.875000f,-0.054688f);
  glVertex2f(11.157500f,2.667500f);
  glVertex2f(11.339687f,0.086250f);
  glVertex2f(11.601563f,3.078125f);
  glVertex2f(11.796250f,0.252812f);
  glVertex2f(11.958750f,3.566250f);
  glVertex2f(12.244687f,0.445000f);
  glVertex2f(12.236563f,4.118125f);
  glVertex2f(12.435000f,4.733750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.934062f,-0.362188f);
  glVertex2f(8.437500f,-0.375000f);
  glVertex2f(8.437500f,1.937500f);
  glVertex2f(8.940000f,-0.362188f);
  glVertex2f(9.259063f,1.983125f);
  glVertex2f(9.434999f,-0.323750f);
  glVertex2f(9.986250f,2.120000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.602188f,1.983125f);
  glVertex2f(6.858750f,2.120000f);
  glVertex2f(6.944062f,-0.259687f);
  glVertex2f(7.436250f,-0.323750f);
  glVertex2f(7.934062f,-0.362188f);
  glVertex2f(8.437500f,1.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.504687f,4.118125f);
  glVertex2f(4.581563f,0.445000f);
  glVertex2f(4.800000f,3.566250f);
  glVertex2f(5.037813f,0.252813f);
  glVertex2f(5.179688f,3.078125f);
  glVertex2f(5.502812f,0.086250f);
  glVertex2f(5.647500f,2.667500f);
  glVertex2f(5.976563f,-0.054688f);
  glVertex2f(6.207188f,2.348125f);
  glVertex2f(6.457500f,-0.170000f);
  glVertex2f(6.858750f,2.120000f);
  glVertex2f(6.944062f,-0.259687f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.695313f,0.906250f);
  glVertex2f(4.134062f,0.662813f);
  glVertex2f(3.936250f,10.665937f);
  glVertex2f(3.645000f,10.451250f);
  glVertex2f(3.343750f,10.210938f);
  glVertex2f(3.278125f,1.185000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.322500f,6.132813f);
  glVertex2f(1.323125f,4.915000f);
  glVertex2f(1.399375f,6.712500f);
  glVertex2f(1.401875f,4.328750f);
  glVertex2f(1.527500f,7.270313f);
  glVertex2f(1.533125f,3.772500f);
  glVertex2f(1.706875f,7.806250f);
  glVertex2f(1.716875f,3.246250f);
  glVertex2f(1.937500f,8.320313f);
  glVertex2f(1.953125f,2.750000f);
  glVertex2f(2.198750f,8.798437f);
  glVertex2f(2.232812f,2.291250f);
  glVertex2f(2.470000f,9.226563f);
  glVertex2f(2.546875f,1.877500f);
  glVertex2f(2.751250f,9.604688f);
  glVertex2f(2.895313f,1.508750f);
  glVertex2f(3.042500f,9.932813f);
  glVertex2f(3.278125f,1.185000f);
  glVertex2f(3.343750f,10.210938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.811875f,17.738125f);
  glVertex2f(14.575625f,18.618124f);
  glVertex2f(14.688125f,15.230000f);
  glVertex2f(14.800625f,15.720625f);
  glVertex2f(14.868125f,16.232500f);
  glVertex2f(14.890625f,16.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.863125f,13.521250f);
  glVertex2f(14.099375f,13.895938f);
  glVertex2f(14.181875f,19.405624f);
  glVertex2f(14.328125f,14.312500f);
  glVertex2f(14.575625f,18.618124f);
  glVertex2f(14.530625f,14.760625f);
  glVertex2f(14.688125f,15.230000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.630625f,20.100624f);
  glVertex2f(12.921875f,20.703125f);
  glVertex2f(13.109375f,12.648438f);
  glVertex2f(13.368125f,12.897500f);
  glVertex2f(13.619375f,13.188437f);
  glVertex2f(13.863125f,13.521250f);
  glVertex2f(14.181875f,19.405624f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.921875f,20.703125f);
  glVertex2f(12.112500f,21.203751f);
  glVertex2f(12.117188f,16.812500f);
  glVertex2f(12.156250f,16.171875f);
  glVertex2f(12.355625f,12.062500f);
  glVertex2f(12.599375f,12.235937f);
  glVertex2f(12.850625f,12.431250f);
  glVertex2f(13.109375f,12.648438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.112500f,21.203751f);
  glVertex2f(11.259376f,21.593124f);
  glVertex2f(11.531250f,18.396875f);
  glVertex2f(11.804688f,17.924999f);
  glVertex2f(12.000000f,17.396875f);
  glVertex2f(12.117188f,16.812500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.726563f,19.626249f);
  glVertex2f(10.273438f,19.432501f);
  glVertex2f(10.362500f,21.871250f);
  glVertex2f(10.757813f,19.161249f);
  glVertex2f(11.259376f,21.593124f);
  glVertex2f(11.179688f,18.812500f);
  glVertex2f(11.531250f,18.396875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.421875f,22.038124f);
  glVertex2f(8.437500f,22.093750f);
  glVertex2f(8.445313f,19.781250f);
  glVertex2f(9.117188f,19.742500f);
  glVertex2f(9.726563f,19.626249f);
  glVertex2f(10.362500f,21.871250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.614375f,19.432501f);
  glVertex2f(7.162813f,19.626249f);
  glVertex2f(7.442188f,22.038124f);
  glVertex2f(7.773125f,19.742500f);
  glVertex2f(8.437500f,22.093750f);
  glVertex2f(8.445313f,19.781250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.493750f,21.871250f);
  glVertex2f(5.592187f,21.593124f);
  glVertex2f(5.703125f,18.812500f);
  glVertex2f(6.127812f,19.161249f);
  glVertex2f(6.614375f,19.432501f);
  glVertex2f(7.442188f,22.038124f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.592187f,21.593124f);
  glVertex2f(4.737500f,21.203751f);
  glVertex2f(4.758125f,16.812500f);
  glVertex2f(4.876250f,17.396875f);
  glVertex2f(5.073125f,17.924999f);
  glVertex2f(5.348750f,18.396875f);
  glVertex2f(5.703125f,18.812500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.413438f,12.898125f);
  glVertex2f(3.703125f,12.632813f);
  glVertex2f(3.929688f,20.703125f);
  glVertex2f(3.987813f,12.401875f);
  glVertex2f(4.737500f,21.203751f);
  glVertex2f(4.241875f,12.202812f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.223750f,20.100626f);
  glVertex2f(2.674688f,19.405624f);
  glVertex2f(2.895937f,13.539375f);
  glVertex2f(3.144375f,13.200313f);
  glVertex2f(3.413438f,12.898125f);
  glVertex2f(3.929688f,20.703125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.674688f,19.405624f);
  glVertex2f(2.282500f,18.618126f);
  glVertex2f(2.283750f,14.770625f);
  glVertex2f(2.460938f,14.328125f);
  glVertex2f(2.668125f,13.915313f);
  glVertex2f(2.895937f,13.539375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.968750f,16.765625f);
  glVertex2f(1.988438f,16.233126f);
  glVertex2f(2.047188f,17.738125f);
  glVertex2f(2.047500f,15.723125f);
  glVertex2f(2.282500f,18.618126f);
  glVertex2f(2.145937f,15.235625f);
  glVertex2f(2.283750f,14.770625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.119375f,11.910937f);
  glVertex2f(12.355625f,12.062500f);
  glVertex2f(12.156250f,16.171875f);
  glVertex2f(12.112812f,15.553125f);
  glVertex2f(11.982500f,14.984375f);
  glVertex2f(11.890625f,11.781250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.070313f,13.578125f);
  glVertex2f(11.343750f,11.484375f);
  glVertex2f(11.461250f,13.996875f);
  glVertex2f(11.890625f,11.781250f);
  glVertex2f(11.765312f,14.465625f);
  glVertex2f(11.982500f,14.984375f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.737500f,21.203751f);
  glVertex2f(4.718750f,16.171875f);
  glVertex2f(4.758125f,16.812500f);
  glVertex2f(1.323125f,4.915000f);
  glVertex2f(1.322500f,6.132813f);
  glVertex2f(1.296875f,5.531250f);
  glVertex2f(6.747188f,12.948125f);
  glVertex2f(6.361875f,9.870625f);
  glVertex2f(6.990000f,10.098750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.453125f,21.195313f);
  glVertex2f(12.134687f,21.348749f);
  glVertex2f(12.209375f,10.760625f);
  glVertex2f(12.315625f,10.903438f);
  glVertex2f(12.421875f,11.046875f);
  glVertex2f(12.868438f,1.537812f);
  glVertex2f(12.749687f,21.022188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.134687f,21.348749f);
  glVertex2f(11.791875f,21.490313f);
  glVertex2f(11.931875f,16.829687f);
  glVertex2f(12.041562f,16.049999f);
  glVertex2f(12.078125f,15.179688f);
  glVertex2f(12.103125f,10.618438f);
  glVertex2f(12.209375f,10.760625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.175625f,21.933750f);
  glVertex2f(10.261562f,19.365000f);
  glVertex2f(10.617188f,21.843750f);
  glVertex2f(10.755625f,19.041250f);
  glVertex2f(11.033125f,21.737812f);
  glVertex2f(11.164063f,18.625000f);
  glVertex2f(11.424687f,21.620001f);
  glVertex2f(11.493125f,18.117188f);
  glVertex2f(11.791875f,21.490313f);
  glVertex2f(11.749063f,17.518749f);
  glVertex2f(11.931875f,16.829687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.044375f,18.117188f);
  glVertex2f(5.359375f,18.625000f);
  glVertex2f(5.365625f,21.653749f);
  glVertex2f(5.755625f,19.041250f);
  glVertex2f(5.993750f,21.846251f);
  glVertex2f(6.244375f,19.365000f);
  glVertex2f(6.665625f,21.983749f);
  glVertex2f(6.825625f,19.596251f);
  glVertex2f(7.381250f,22.066250f);
  glVertex2f(7.499375f,19.735001f);
  glVertex2f(8.140625f,22.093750f);
  glVertex2f(8.265625f,19.781250f);
  glVertex2f(8.689688f,22.083750f);
  glVertex2f(9.016562f,19.735001f);
  glVertex2f(9.211875f,22.053749f);
  glVertex2f(9.681875f,19.596251f);
  glVertex2f(9.707188f,22.003750f);
  glVertex2f(10.261562f,19.365000f);
  glVertex2f(10.175625f,21.933750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.519375f,16.049999f);
  glVertex2f(4.624375f,16.829687f);
  glVertex2f(4.781250f,21.406250f);
  glVertex2f(4.799375f,17.518749f);
  glVertex2f(5.365625f,21.653749f);
  glVertex2f(5.044375f,18.117188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.247500f,21.114063f);
  glVertex2f(3.771250f,20.787500f);
  glVertex2f(4.109375f,9.205000f);
  glVertex2f(4.525000f,8.984062f);
  glVertex2f(4.484375f,15.179688f);
  glVertex2f(4.519375f,16.049999f);
  glVertex2f(4.781250f,21.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.349375f,12.618750f);
  glVertex2f(15.336875f,13.179688f);
  glVertex2f(15.348125f,10.445000f);
  glVertex2f(15.359375f,11.375000f);
  glVertex2f(15.356875f,12.017187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.319375f,13.700000f);
  glVertex2f(15.296875f,14.179688f);
  glVertex2f(15.314375f,9.555000f);
  glVertex2f(15.348125f,10.445000f);
  glVertex2f(15.336875f,13.179688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.267813f,14.641562f);
  glVertex2f(15.230625f,15.108438f);
  glVertex2f(15.258125f,8.705000f);
  glVertex2f(15.314375f,9.555000f);
  glVertex2f(15.296875f,14.179688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.070313f,16.539063f);
  glVertex2f(15.078125f,7.125000f);
  glVertex2f(15.131875f,16.057188f);
  glVertex2f(15.179375f,7.895000f);
  glVertex2f(15.185312f,15.580313f);
  glVertex2f(15.258125f,8.705000f);
  glVertex2f(15.230625f,15.108438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.998438f,17.006250f);
  glVertex2f(14.914063f,17.439062f);
  glVertex2f(14.946875f,6.377187f);
  glVertex2f(15.078125f,7.125000f);
  glVertex2f(15.070313f,16.539063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.817187f,17.837500f);
  glVertex2f(14.707812f,18.201563f);
  glVertex2f(14.778125f,5.633750f);
  glVertex2f(14.946875f,6.377187f);
  glVertex2f(14.914063f,17.439062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.297188f,19.150000f);
  glVertex2f(14.328125f,4.160000f);
  glVertex2f(14.449688f,18.842188f);
  glVertex2f(14.571875f,4.894687f);
  glVertex2f(14.585938f,18.531250f);
  glVertex2f(14.778125f,5.633750f);
  glVertex2f(14.707812f,18.201563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.128437f,19.454687f);
  glVertex2f(13.943438f,19.756250f);
  glVertex2f(14.046875f,3.429688f);
  glVertex2f(14.328125f,4.160000f);
  glVertex2f(14.297188f,19.150000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.284688f,20.593437f);
  glVertex2f(13.323125f,2.103437f);
  glVertex2f(13.523125f,20.337812f);
  glVertex2f(13.715938f,2.734062f);
  glVertex2f(13.742188f,20.054688f);
  glVertex2f(14.046875f,3.429688f);
  glVertex2f(13.943438f,19.756250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.026875f,20.821562f);
  glVertex2f(12.749687f,21.022188f);
  glVertex2f(12.868438f,1.537812f);
  glVertex2f(13.323125f,2.103437f);
  glVertex2f(13.284688f,20.593437f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.421875f,11.046875f);
  glVertex2f(12.390625f,9.609375f);
  glVertex2f(12.868438f,1.537812f);
  glVertex2f(12.368438f,9.034062f);
  glVertex2f(12.351875f,1.037187f);
  glVertex2f(12.326875f,8.433125f);
  glVertex2f(12.265938f,7.806562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.351875f,1.037187f);
  glVertex2f(12.265938f,7.806562f);
  glVertex2f(12.185625f,7.154375f);
  glVertex2f(12.085938f,6.476563f);
  glVertex2f(11.946250f,5.798125f);
  glVertex2f(11.773438f,0.601563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.773438f,0.601563f);
  glVertex2f(11.946250f,5.798125f);
  glVertex2f(11.745937f,5.144063f);
  glVertex2f(11.485000f,4.514375f);
  glVertex2f(11.163438f,3.909063f);
  glVertex2f(11.136250f,0.238750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.781250f,3.328125f);
  glVertex2f(10.343750f,2.816250f);
  glVertex2f(10.443438f,-0.043438f);
  glVertex2f(11.136250f,0.238750f);
  glVertex2f(11.163438f,3.909063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.731250f,1.963125f);
  glVertex2f(8.890938f,-0.365938f);
  glVertex2f(9.318750f,2.133750f);
  glVertex2f(9.695000f,-0.245000f);
  glVertex2f(9.856250f,2.418125f);
  glVertex2f(10.443438f,-0.043438f);
  glVertex2f(10.343750f,2.816250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.093750f,1.906250f);
  glVertex2f(7.532813f,1.935625f);
  glVertex2f(8.031250f,-0.406250f);
  glVertex2f(8.890938f,-0.365938f);
  glVertex2f(8.731250f,1.963125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.025000f,2.023750f);
  glVertex2f(6.570313f,2.170625f);
  glVertex2f(6.940625f,-0.352500f);
  glVertex2f(8.031250f,-0.406250f);
  glVertex2f(7.532813f,1.935625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.168750f,2.376250f);
  glVertex2f(5.820313f,2.640625f);
  glVertex2f(5.968750f,-0.191250f);
  glVertex2f(6.940625f,-0.352500f);
  glVertex2f(6.570313f,2.170625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.820313f,2.640625f);
  glVertex2f(5.525625f,2.976250f);
  glVertex2f(5.968750f,-0.191250f);
  glVertex2f(5.285313f,3.395625f);
  glVertex2f(5.115625f,0.077500f);
  glVertex2f(5.099375f,3.898750f);
  glVertex2f(4.967813f,4.485625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.890625f,5.156250f);
  glVertex2f(2.015625f,5.156250f);
  glVertex2f(2.200625f,4.067500f);
  glVertex2f(2.468125f,3.101250f);
  glVertex2f(2.818125f,2.257500f);
  glVertex2f(3.250625f,1.536250f);
  glVertex2f(3.765625f,0.937500f);
  glVertex2f(4.381250f,0.453750f);
  glVertex2f(5.115625f,0.077500f);
  glVertex2f(4.967813f,4.485625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.784062f,10.197187f);
  glVertex2f(11.890625f,10.335938f);
  glVertex2f(11.931875f,13.529688f);
  glVertex2f(11.996875f,10.476875f);
  glVertex2f(12.041562f,14.309375f);
  glVertex2f(12.103125f,10.618438f);
  glVertex2f(12.078125f,15.179688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.749063f,12.840625f);
  glVertex2f(11.493125f,12.242188f);
  glVertex2f(11.569062f,9.930938f);
  glVertex2f(11.676875f,10.062187f);
  glVertex2f(11.784062f,10.197187f);
  glVertex2f(11.931875f,13.529688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.493125f,12.242188f);
  glVertex2f(11.164063f,11.734375f);
  glVertex2f(11.239062f,9.560000f);
  glVertex2f(11.351563f,9.679688f);
  glVertex2f(11.460625f,9.803437f);
  glVertex2f(11.569062f,9.930938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.164063f,11.734375f);
  glVertex2f(10.755625f,11.318125f);
  glVertex2f(10.864062f,9.227187f);
  glVertex2f(10.995313f,9.333750f);
  glVertex2f(11.120313f,9.444688f);
  glVertex2f(11.239062f,9.560000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.755625f,11.318125f);
  glVertex2f(10.261562f,10.994375f);
  glVertex2f(10.287812f,8.847500f);
  glVertex2f(10.437813f,8.935000f);
  glVertex2f(10.584063f,9.027500f);
  glVertex2f(10.726563f,9.125000f);
  glVertex2f(10.864062f,9.227187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.261562f,10.994375f);
  glVertex2f(9.681875f,10.763125f);
  glVertex2f(9.810938f,8.615937f);
  glVertex2f(9.976563f,8.687500f);
  glVertex2f(10.134063f,8.765000f);
  glVertex2f(10.287812f,8.847500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.681875f,10.763125f);
  glVertex2f(9.016562f,10.624375f);
  glVertex2f(9.023438f,8.398438f);
  glVertex2f(9.239062f,8.442500f);
  glVertex2f(9.442187f,8.493438f);
  glVertex2f(9.632813f,8.551250f);
  glVertex2f(9.810938f,8.615937f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.016562f,10.624375f);
  glVertex2f(8.265625f,10.578125f);
  glVertex2f(8.315625f,8.313125f);
  glVertex2f(8.560938f,8.333438f);
  glVertex2f(8.796875f,8.361875f);
  glVertex2f(9.023438f,8.398438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.359375f,11.734375f);
  glVertex2f(5.481875f,8.606875f);
  glVertex2f(5.755625f,11.318125f);
  glVertex2f(6.011875f,8.471250f);
  glVertex2f(6.244375f,10.994375f);
  glVertex2f(6.574375f,8.374375f);
  glVertex2f(6.825625f,10.763125f);
  glVertex2f(7.169375f,8.316250f);
  glVertex2f(7.499375f,10.624375f);
  glVertex2f(7.796875f,8.296875f);
  glVertex2f(8.265625f,10.578125f);
  glVertex2f(8.060938f,8.300938f);
  glVertex2f(8.315625f,8.313125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.044375f,12.242188f);
  glVertex2f(4.799375f,12.840625f);
  glVertex2f(4.984375f,8.781250f);
  glVertex2f(5.481875f,8.606875f);
  glVertex2f(5.359375f,11.734375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.624375f,13.529688f);
  glVertex2f(4.519375f,14.309375f);
  glVertex2f(4.525000f,8.984062f);
  glVertex2f(4.984375f,8.781250f);
  glVertex2f(4.799375f,12.840625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.230000f,11.299063f);
  glVertex2f(2.424687f,10.933750f);
  glVertex2f(2.428125f,19.155937f);
  glVertex2f(2.638750f,10.591562f);
  glVertex2f(2.687500f,19.601563f);
  glVertex2f(2.872188f,10.272500f);
  glVertex2f(2.991250f,20.031250f);
  glVertex2f(3.125000f,9.976563f);
  glVertex2f(3.352500f,20.426563f);
  glVertex2f(3.409375f,9.701250f);
  glVertex2f(3.771250f,20.787500f);
  glVertex2f(3.737500f,9.444062f);
  glVertex2f(4.109375f,9.205000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.523438f,13.492188f);
  glVertex2f(1.582188f,13.162500f);
  glVertex2f(1.596250f,16.961876f);
  glVertex2f(1.664688f,12.817187f);
  glVertex2f(1.703125f,17.398438f);
  glVertex2f(1.770937f,12.456250f);
  glVertex2f(1.837500f,17.834063f);
  glVertex2f(1.900938f,12.079687f);
  glVertex2f(2.003125f,18.272188f);
  glVertex2f(2.054688f,11.687500f);
  glVertex2f(2.200000f,18.712812f);
  glVertex2f(2.230000f,11.299063f);
  glVertex2f(2.428125f,19.155937f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.425000f,14.483125f);
  glVertex2f(1.448437f,14.147187f);
  glVertex2f(1.453750f,16.075624f);
  glVertex2f(1.481250f,13.816875f);
  glVertex2f(1.513125f,16.520937f);
  glVertex2f(1.523438f,13.492188f);
  glVertex2f(1.596250f,16.961876f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.418125f,15.625937f);
  glVertex2f(1.406250f,15.171875f);
  glVertex2f(1.410938f,14.824688f);
  glVertex2f(1.425000f,14.483125f);
  glVertex2f(1.453750f,16.075624f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.484375f,15.179688f);
  glVertex2f(4.525000f,8.984062f);
  glVertex2f(4.519375f,14.309375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.937500f,15.000000f);
  glVertex2f(2.937500f,11.312500f);
  glVertex2f(6.187500f,11.312500f);
  glVertex2f(6.187500f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.937500f,3.687500f);
  glVertex2f(2.937500f,0.000000f);
  glVertex2f(6.187500f,0.000000f);
  glVertex2f(6.187500f,3.687500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.937500f,15.000000f);
  glVertex2f(2.937500f,11.312500f);
  glVertex2f(6.187500f,11.312500f);
  glVertex2f(6.187500f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.250000f,3.687500f);
  glVertex2f(1.437500f,-3.812500f);
  glVertex2f(3.546875f,-3.812500f);
  glVertex2f(6.828125f,3.687500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.906250f,9.000000f);
  glVertex2f(24.000000f,14.968750f);
  glVertex2f(24.000000f,16.812500f);
  glVertex2f(6.000000f,9.937500f);
  glVertex2f(6.000000f,8.062500f);
  glVertex2f(24.000000f,1.171875f);
  glVertex2f(24.000000f,3.015625f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.000000f,12.656250f);
  glVertex2f(6.000000f,10.812500f);
  glVertex2f(24.000000f,10.812500f);
  glVertex2f(24.000000f,12.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.000000f,7.203125f);
  glVertex2f(6.000000f,5.328125f);
  glVertex2f(24.000000f,5.328125f);
  glVertex2f(24.000000f,7.203125f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(22.093750f,9.000000f);
  glVertex2f(6.000000f,3.015625f);
  glVertex2f(24.000000f,8.062500f);
  glVertex2f(24.000000f,9.937500f);
  glVertex2f(6.000000f,16.812500f);
  glVertex2f(6.000000f,14.968750f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(24.000000f,8.062500f);
  glVertex2f(6.000000f,3.015625f);
  glVertex2f(6.000000f,1.171875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.926250f,21.143749f);
  glVertex2f(10.033125f,21.559376f);
  glVertex2f(10.138750f,18.309376f);
  glVertex2f(10.447187f,17.971874f);
  glVertex2f(10.667500f,17.596874f);
  glVertex2f(10.799687f,17.184376f);
  glVertex2f(10.843750f,16.734375f);
  glVertex2f(10.959375f,11.892813f);
  glVertex2f(11.765625f,20.609375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.260000f,19.177500f);
  glVertex2f(8.789687f,19.049376f);
  glVertex2f(9.086250f,21.856251f);
  glVertex2f(9.283750f,18.860001f);
  glVertex2f(10.033125f,21.559376f);
  glVertex2f(9.742188f,18.609375f);
  glVertex2f(10.138750f,18.309376f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.085625f,22.034374f);
  glVertex2f(7.031250f,22.093750f);
  glVertex2f(7.093750f,19.250000f);
  glVertex2f(7.694687f,19.244375f);
  glVertex2f(8.260000f,19.177500f);
  glVertex2f(9.086250f,21.856251f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.031250f,22.093750f);
  glVertex2f(5.420625f,21.936874f);
  glVertex2f(5.610312f,19.142187f);
  glVertex2f(5.786875f,19.171875f);
  glVertex2f(5.942812f,19.192188f);
  glVertex2f(6.078125f,19.203125f);
  glVertex2f(6.218750f,19.209999f);
  glVertex2f(6.390625f,19.218124f);
  glVertex2f(6.593750f,19.227501f);
  glVertex2f(6.828125f,19.238125f);
  glVertex2f(7.093750f,19.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.420625f,21.936874f);
  glVertex2f(3.988750f,21.466249f);
  glVertex2f(4.004063f,18.467501f);
  glVertex2f(4.150625f,18.585625f);
  glVertex2f(4.289063f,18.687500f);
  glVertex2f(4.432813f,18.777187f);
  glVertex2f(4.595313f,18.858749f);
  glVertex2f(4.776563f,18.932188f);
  glVertex2f(4.976563f,18.997499f);
  glVertex2f(5.195313f,19.054688f);
  glVertex2f(5.413125f,19.103125f);
  glVertex2f(5.610312f,19.142187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.988750f,21.466249f);
  glVertex2f(2.735625f,20.681875f);
  glVertex2f(2.865625f,17.165625f);
  glVertex2f(3.018750f,17.406250f);
  glVertex2f(3.178125f,17.628124f);
  glVertex2f(3.343750f,17.831249f);
  glVertex2f(3.515625f,18.015625f);
  glVertex2f(3.686563f,18.182501f);
  glVertex2f(3.849375f,18.333124f);
  glVertex2f(4.004063f,18.467501f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.718750f,16.906250f);
  glVertex2f(2.865625f,17.165625f);
  glVertex2f(2.735625f,20.681875f);
  glVertex2f(1.661250f,19.583750f);
  glVertex2f(0.765625f,18.171875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.715625f,17.594376f);
  glVertex2f(13.471875f,18.468124f);
  glVertex2f(13.574688f,15.265312f);
  glVertex2f(13.698125f,15.716875f);
  glVertex2f(13.772187f,16.175312f);
  glVertex2f(13.796875f,16.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.642187f,13.561563f);
  glVertex2f(12.921875f,13.960313f);
  glVertex2f(13.065625f,19.261875f);
  glVertex2f(13.179688f,14.382813f);
  glVertex2f(13.471875f,18.468124f);
  glVertex2f(13.401875f,14.820625f);
  glVertex2f(13.574688f,15.265312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.496875f,19.975624f);
  glVertex2f(11.765625f,20.609375f);
  glVertex2f(12.017187f,12.835313f);
  glVertex2f(12.340625f,13.186563f);
  glVertex2f(12.642187f,13.561563f);
  glVertex2f(13.065625f,19.261875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.765625f,20.609375f);
  glVertex2f(10.959375f,11.892813f);
  glVertex2f(11.315625f,12.196250f);
  glVertex2f(11.671875f,12.507813f);
  glVertex2f(12.017187f,12.835313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.959375f,11.892813f);
  glVertex2f(10.843750f,16.734375f);
  glVertex2f(10.820937f,16.259062f);
  glVertex2f(10.752500f,15.795625f);
  glVertex2f(10.638437f,15.344063f);
  glVertex2f(10.603125f,11.597500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.987813f,9.093125f);
  glVertex2f(8.160625f,9.363125f);
  glVertex2f(8.255938f,12.116250f);
  glVertex2f(8.382813f,9.640625f);
  glVertex2f(8.576875f,12.397813f);
  glVertex2f(8.640625f,9.921250f);
  glVertex2f(8.898438f,12.687500f);
  glVertex2f(8.920313f,10.200625f);
  glVertex2f(9.210938f,12.994062f);
  glVertex2f(9.221875f,10.478750f);
  glVertex2f(9.504687f,13.326250f);
  glVertex2f(9.545313f,10.755625f);
  glVertex2f(9.779688f,13.684063f);
  glVertex2f(9.890625f,11.031250f);
  glVertex2f(10.035937f,14.067500f);
  glVertex2f(10.246875f,11.310312f);
  glVertex2f(10.273438f,14.476563f);
  glVertex2f(10.603125f,11.597500f);
  glVertex2f(10.478750f,14.904375f);
  glVertex2f(10.638437f,15.344063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.935625f,11.842813f);
  glVertex2f(7.615938f,11.577500f);
  glVertex2f(7.765625f,8.328125f);
  glVertex2f(7.790312f,8.575625f);
  glVertex2f(7.864375f,8.830625f);
  glVertex2f(7.987813f,9.093125f);
  glVertex2f(8.255938f,12.116250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.765625f,4.953125f);
  glVertex2f(7.765625f,8.328125f);
  glVertex2f(7.615938f,11.577500f);
  glVertex2f(7.296875f,11.320313f);
  glVertex2f(6.987187f,11.066875f);
  glVertex2f(6.695625f,10.812813f);
  glVertex2f(6.422187f,10.558125f);
  glVertex2f(6.166875f,10.302813f);
  glVertex2f(5.929688f,10.046875f);
  glVertex2f(5.724375f,9.791875f);
  glVertex2f(5.564688f,9.539375f);
  glVertex2f(5.450625f,9.289375f);
  glVertex2f(5.382187f,9.041875f);
  glVertex2f(5.359375f,8.796875f);
  glVertex2f(5.359375f,4.953125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.062500f,2.843750f);
  glVertex2f(5.062500f,0.000000f);
  glVertex2f(8.062500f,0.000000f);
  glVertex2f(8.062500f,2.843750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(17.203125f,-5.285937f);
  glVertex2f(17.637501f,-5.253125f);
  glVertex2f(17.676874f,-2.585625f);
  glVertex2f(18.015625f,-5.210938f);
  glVertex2f(18.078125f,-2.554688f);
  glVertex2f(18.391874f,-5.148125f);
  glVertex2f(18.461876f,-2.508125f);
  glVertex2f(18.820625f,-5.053438f);
  glVertex2f(18.888124f,-2.437187f);
  glVertex2f(19.301874f,-4.926875f);
  glVertex2f(19.356874f,-2.341875f);
  glVertex2f(19.835625f,-4.768437f);
  glVertex2f(19.868126f,-2.222188f);
  glVertex2f(20.421875f,-4.578125f);
  glVertex2f(20.421875f,-2.078125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.890000f,-5.265625f);
  glVertex2f(14.716250f,-5.312500f);
  glVertex2f(15.296875f,-2.640625f);
  glVertex2f(15.562500f,-5.328125f);
  glVertex2f(16.008125f,-2.637187f);
  glVertex2f(16.165625f,-5.323438f);
  glVertex2f(16.641874f,-2.626875f);
  glVertex2f(16.712500f,-5.309375f);
  glVertex2f(17.198126f,-2.609688f);
  glVertex2f(17.203125f,-5.285937f);
  glVertex2f(17.676874f,-2.585625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.310312f,-2.520937f);
  glVertex2f(11.525625f,-2.161875f);
  glVertex2f(11.531250f,-4.937500f);
  glVertex2f(12.297500f,-5.078125f);
  glVertex2f(13.083750f,-5.187500f);
  glVertex2f(13.890000f,-5.265625f);
  glVertex2f(15.296875f,-2.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.820313f,-3.531250f);
  glVertex2f(8.551250f,-3.912500f);
  glVertex2f(8.561875f,-0.725625f);
  glVertex2f(9.287812f,-4.243750f);
  glVertex2f(9.942813f,-1.563437f);
  glVertex2f(10.030000f,-4.525000f);
  glVertex2f(11.525625f,-2.161875f);
  glVertex2f(10.777813f,-4.756250f);
  glVertex2f(11.531250f,-4.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.382813f,0.351563f);
  glVertex2f(6.412500f,1.644375f);
  glVertex2f(6.447813f,-2.635000f);
  glVertex2f(7.113125f,-3.104063f);
  glVertex2f(7.820313f,-3.531250f);
  glVertex2f(8.561875f,-0.725625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.447813f,-2.635000f);
  glVertex2f(6.412500f,1.644375f);
  glVertex2f(5.824375f,-2.124063f);
  glVertex2f(5.657813f,3.129062f);
  glVertex2f(5.242813f,-1.571250f);
  glVertex2f(5.118750f,4.805625f);
  glVertex2f(4.795312f,6.674062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.242813f,-1.571250f);
  glVertex2f(4.795312f,6.674062f);
  glVertex2f(4.703125f,-0.976563f);
  glVertex2f(4.687500f,8.734375f);
  glVertex2f(4.466250f,16.755312f);
  glVertex2f(4.713438f,9.604062f);
  glVertex2f(5.110312f,17.494688f);
  glVertex2f(4.791250f,10.438125f);
  glVertex2f(4.920938f,11.236563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.938125f,2.090938f);
  glVertex2f(3.321250f,1.210625f);
  glVertex2f(3.352500f,15.066563f);
  glVertex2f(3.743125f,0.405938f);
  glVertex2f(3.880312f,15.945937f);
  glVertex2f(4.203750f,-0.323125f);
  glVertex2f(4.466250f,16.755312f);
  glVertex2f(4.703125f,-0.976563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.781250f,8.703125f);
  glVertex2f(1.813750f,7.461875f);
  glVertex2f(1.825312f,9.864688f);
  glVertex2f(1.911250f,6.275625f);
  glVertex2f(1.957500f,10.986875f);
  glVertex2f(2.073750f,5.144375f);
  glVertex2f(2.177813f,12.069688f);
  glVertex2f(2.301250f,4.068125f);
  glVertex2f(2.486250f,13.113125f);
  glVertex2f(2.593750f,3.046875f);
  glVertex2f(2.882813f,14.117188f);
  glVertex2f(2.938125f,2.090938f);
  glVertex2f(3.352500f,15.066563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(17.746876f,7.159688f);
  glVertex2f(17.875938f,2.963125f);
  glVertex2f(17.781250f,7.968750f);
  glVertex2f(17.819687f,12.852813f);
  glVertex2f(17.747812f,8.747812f);
  glVertex2f(17.709999f,12.955000f);
  glVertex2f(17.647499f,9.472500f);
  glVertex2f(17.577187f,13.087812f);
  glVertex2f(17.480312f,10.142813f);
  glVertex2f(17.421249f,13.251250f);
  glVertex2f(17.246250f,10.758750f);
  glVertex2f(17.242188f,13.445313f);
  glVertex2f(17.059999f,13.641562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.945313f,11.320313f);
  glVertex2f(17.246250f,10.758750f);
  glVertex2f(17.059999f,13.641562f);
  glVertex2f(16.894688f,13.811563f);
  glVertex2f(16.746250f,13.955313f);
  glVertex2f(16.614687f,14.072812f);
  glVertex2f(16.580000f,11.801250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.580000f,11.801250f);
  glVertex2f(16.614687f,14.072812f);
  glVertex2f(16.500000f,14.164063f);
  glVertex2f(16.374374f,14.242500f);
  glVertex2f(16.209999f,14.321563f);
  glVertex2f(16.152813f,12.175312f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.209999f,14.321563f);
  glVertex2f(16.006874f,14.401250f);
  glVertex2f(16.152813f,12.175312f);
  glVertex2f(15.765000f,14.481563f);
  glVertex2f(15.663750f,12.442500f);
  glVertex2f(15.484375f,14.562500f);
  glVertex2f(15.172500f,14.635625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.663750f,12.442500f);
  glVertex2f(15.172500f,14.635625f);
  glVertex2f(15.112812f,12.602813f);
  glVertex2f(14.836875f,14.692500f);
  glVertex2f(14.500000f,12.656250f);
  glVertex2f(14.477500f,14.733125f);
  glVertex2f(14.094375f,14.757500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.820937f,12.175312f);
  glVertex2f(13.316250f,12.442500f);
  glVertex2f(13.687500f,14.765625f);
  glVertex2f(13.875937f,12.602813f);
  glVertex2f(14.094375f,14.757500f);
  glVertex2f(14.500000f,12.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.794375f,14.689375f);
  glVertex2f(11.965000f,14.460625f);
  glVertex2f(12.023438f,11.320313f);
  glVertex2f(12.390000f,11.801250f);
  glVertex2f(12.820937f,12.175312f);
  glVertex2f(13.687500f,14.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.965000f,14.460625f);
  glVertex2f(11.199375f,14.079375f);
  glVertex2f(11.220938f,8.747812f);
  glVertex2f(11.321250f,9.472500f);
  glVertex2f(11.488438f,10.142813f);
  glVertex2f(11.722500f,10.758750f);
  glVertex2f(12.023438f,11.320313f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.404375f,8.989375f);
  glVertex2f(8.405313f,6.622188f);
  glVertex2f(8.586250f,10.110625f);
  glVertex2f(8.590000f,5.554375f);
  glVertex2f(8.889375f,11.129375f);
  glVertex2f(8.897813f,4.562188f);
  glVertex2f(9.313750f,12.045625f);
  glVertex2f(9.328750f,3.645625f);
  glVertex2f(9.859375f,12.859375f);
  glVertex2f(9.882813f,2.804688f);
  glVertex2f(10.497500f,13.545625f);
  glVertex2f(10.527500f,2.081875f);
  glVertex2f(11.199375f,14.079375f);
  glVertex2f(11.187500f,7.968750f);
  glVertex2f(11.220938f,8.747812f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(21.063749f,3.641875f);
  glVertex2f(20.789375f,4.005000f);
  glVertex2f(21.152500f,0.754375f);
  glVertex2f(20.593750f,4.484375f);
  glVertex2f(20.244375f,1.095625f);
  glVertex2f(20.593750f,14.562500f);
  glVertex2f(19.447500f,1.664375f);
  glVertex2f(18.761875f,2.460625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.187500f,3.484375f);
  glVertex2f(18.761875f,2.460625f);
  glVertex2f(20.593750f,14.562500f);
  glVertex2f(17.906250f,14.562500f);
  glVertex2f(17.906250f,12.781250f);
  glVertex2f(17.875938f,2.963125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.643749f,6.395000f);
  glVertex2f(17.471874f,5.674687f);
  glVertex2f(17.541250f,2.499375f);
  glVertex2f(17.875938f,2.963125f);
  glVertex2f(17.746876f,7.159688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.687500f,0.796875f);
  glVertex2f(14.330937f,0.823125f);
  glVertex2f(14.500000f,2.843750f);
  glVertex2f(14.923750f,0.901875f);
  glVertex2f(15.096875f,2.904687f);
  glVertex2f(15.465938f,1.033125f);
  glVertex2f(15.637500f,3.087500f);
  glVertex2f(15.957500f,1.216875f);
  glVertex2f(16.121876f,3.392188f);
  glVertex2f(16.398438f,1.453125f);
  glVertex2f(16.549999f,3.818750f);
  glVertex2f(16.802500f,1.744375f);
  glVertex2f(16.921875f,4.367188f);
  glVertex2f(17.183437f,2.093125f);
  glVertex2f(17.231251f,4.998750f);
  glVertex2f(17.541250f,2.499375f);
  glVertex2f(17.471874f,5.674687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.717500f,4.688750f);
  glVertex2f(11.991250f,1.118125f);
  glVertex2f(12.380000f,3.663750f);
  glVertex2f(12.810312f,0.877187f);
  glVertex2f(13.307500f,3.048750f);
  glVertex2f(13.687500f,0.796875f);
  glVertex2f(14.500000f,2.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.320000f,6.123750f);
  glVertex2f(11.187500f,7.968750f);
  glVertex2f(11.230312f,1.519688f);
  glVertex2f(11.991250f,1.118125f);
  glVertex2f(11.717500f,4.688750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(27.103750f,4.142500f);
  glVertex2f(27.591562f,5.237187f);
  glVertex2f(27.639999f,13.335000f);
  glVertex2f(27.940001f,6.401250f);
  glVertex2f(28.074062f,11.249375f);
  glVertex2f(28.149063f,7.634687f);
  glVertex2f(28.218750f,8.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(25.281250f,8.937500f);
  glVertex2f(25.746876f,2.225625f);
  glVertex2f(25.903749f,16.827499f);
  glVertex2f(26.476563f,3.117188f);
  glVertex2f(26.916563f,15.194375f);
  glVertex2f(27.103750f,4.142500f);
  glVertex2f(27.639999f,13.335000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(23.556250f,15.447500f);
  glVertex2f(24.310938f,14.174376f);
  glVertex2f(24.601563f,18.234375f);
  glVertex2f(24.850000f,12.665000f);
  glVertex2f(25.903749f,16.827499f);
  glVertex2f(25.173437f,10.919375f);
  glVertex2f(25.281250f,8.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(23.049376f,19.398750f);
  glVertex2f(21.286562f,20.304375f);
  glVertex2f(21.418751f,17.311251f);
  glVertex2f(22.585938f,16.484375f);
  glVertex2f(23.556250f,15.447500f);
  glVertex2f(24.601563f,18.234375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.968750f,18.781250f);
  glVertex2f(16.848438f,18.689375f);
  glVertex2f(17.129063f,21.339375f);
  glVertex2f(18.549999f,18.413750f);
  glVertex2f(19.313126f,20.951250f);
  glVertex2f(20.073437f,17.954374f);
  glVertex2f(21.286562f,20.304375f);
  glVertex2f(21.418751f,17.311251f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.734375f,21.468750f);
  glVertex2f(13.747812f,21.434376f);
  glVertex2f(13.808750f,18.733749f);
  glVertex2f(14.385000f,18.769375f);
  glVertex2f(14.968750f,18.781250f);
  glVertex2f(17.129063f,21.339375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.125000f,18.484375f);
  glVertex2f(12.678750f,18.591249f);
  glVertex2f(12.775625f,21.331249f);
  glVertex2f(13.240000f,18.674376f);
  glVertex2f(13.747812f,21.434376f);
  glVertex2f(13.808750f,18.733749f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.817813f,21.159374f);
  glVertex2f(10.874375f,20.918751f);
  glVertex2f(11.025000f,18.178125f);
  glVertex2f(11.575000f,18.348438f);
  glVertex2f(12.125000f,18.484375f);
  glVertex2f(12.775625f,21.331249f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.375000f,17.460938f);
  glVertex2f(9.925000f,17.734375f);
  glVertex2f(9.945313f,20.609375f);
  glVertex2f(10.475000f,17.973438f);
  glVertex2f(10.874375f,20.918751f);
  glVertex2f(11.025000f,18.178125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.042500f,20.236563f);
  glVertex2f(8.177813f,19.805626f);
  glVertex2f(8.333750f,16.817188f);
  glVertex2f(8.839687f,17.154688f);
  glVertex2f(9.375000f,17.460938f);
  glVertex2f(9.945313f,20.609375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.603437f,15.144062f);
  glVertex2f(6.992188f,15.617188f);
  glVertex2f(7.351250f,19.316563f);
  glVertex2f(7.410000f,16.048437f);
  glVertex2f(8.177813f,19.805626f);
  glVertex2f(7.857187f,16.448437f);
  glVertex2f(8.333750f,16.817188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.562812f,18.769375f);
  glVertex2f(5.812500f,18.164063f);
  glVertex2f(5.912188f,14.040313f);
  glVertex2f(6.243437f,14.618438f);
  glVertex2f(6.603437f,15.144062f);
  glVertex2f(7.351250f,19.316563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.920938f,11.236563f);
  glVertex2f(5.102500f,11.999375f);
  glVertex2f(5.110312f,17.494688f);
  glVertex2f(5.335938f,12.726563f);
  glVertex2f(5.812500f,18.164063f);
  glVertex2f(5.609687f,13.409687f);
  glVertex2f(5.912188f,14.040313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(25.746876f,2.225625f);
  glVertex2f(25.281250f,8.937500f);
  glVertex2f(25.267187f,8.251562f);
  glVertex2f(25.225000f,7.606250f);
  glVertex2f(25.154688f,7.001563f);
  glVertex2f(25.056250f,6.437500f);
  glVertex2f(24.951563f,1.532187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(24.951563f,1.532187f);
  glVertex2f(25.056250f,6.437500f);
  glVertex2f(24.929688f,5.914063f);
  glVertex2f(24.782812f,5.439688f);
  glVertex2f(24.623438f,5.022812f);
  glVertex2f(24.451563f,4.663437f);
  glVertex2f(24.267187f,4.361563f);
  glVertex2f(24.090626f,1.036875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(24.090626f,1.036875f);
  glVertex2f(24.267187f,4.361563f);
  glVertex2f(24.070313f,4.117188f);
  glVertex2f(23.869062f,3.915000f);
  glVertex2f(23.671562f,3.739687f);
  glVertex2f(23.477812f,3.591250f);
  glVertex2f(23.287813f,3.469687f);
  glVertex2f(23.164063f,0.739688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(23.164063f,0.739688f);
  glVertex2f(23.287813f,3.469687f);
  glVertex2f(23.101563f,3.375000f);
  glVertex2f(22.924376f,3.305000f);
  glVertex2f(22.761562f,3.257500f);
  glVertex2f(22.613125f,3.232500f);
  glVertex2f(22.479063f,3.230000f);
  glVertex2f(22.359375f,3.250000f);
  glVertex2f(22.171875f,0.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(21.063749f,3.641875f);
  glVertex2f(21.152500f,0.754375f);
  glVertex2f(21.416876f,3.395000f);
  glVertex2f(22.171875f,0.640625f);
  glVertex2f(21.848749f,3.264375f);
  glVertex2f(22.359375f,3.250000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(11.230312f,1.519688f);
  glVertex2f(11.187500f,7.968750f);
  glVertex2f(10.527500f,2.081875f);
  glVertex2f(17.819687f,12.852813f);
  glVertex2f(17.875938f,2.963125f);
  glVertex2f(17.906250f,12.781250f);
  glVertex2f(8.405313f,6.622188f);
  glVertex2f(8.404375f,8.989375f);
  glVertex2f(8.343750f,7.765625f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.921875f,5.796875f);
  glVertex2f(7.093750f,8.343750f);
  glVertex2f(9.546875f,21.656250f);
  glVertex2f(11.140625f,18.343750f);
  glVertex2f(12.828125f,21.656250f);
  glVertex2f(15.265625f,8.343750f);
  glVertex2f(22.062500f,0.000000f);
  glVertex2f(16.531250f,5.796875f);
  glVertex2f(18.875000f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.546875f,21.656250f);
  glVertex2f(0.437500f,0.000000f);
  glVertex2f(3.546875f,0.000000f);
  glVertex2f(5.921875f,5.796875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.093750f,8.343750f);
  glVertex2f(5.921875f,5.796875f);
  glVertex2f(16.531250f,5.796875f);
  glVertex2f(15.265625f,8.343750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(10.203125f,19.046875f);
  glVertex2f(11.109375f,21.656250f);
  glVertex2f(11.868125f,18.921249f);
  glVertex2f(12.195625f,21.601563f);
  glVertex2f(13.163125f,18.544374f);
  glVertex2f(13.204375f,21.437500f);
  glVertex2f(14.088125f,17.916250f);
  glVertex2f(14.135625f,21.164063f);
  glVertex2f(14.643125f,17.036875f);
  glVertex2f(14.989375f,20.781250f);
  glVertex2f(14.828125f,15.906250f);
  glVertex2f(15.006875f,12.041250f);
  glVertex2f(14.808750f,11.919687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(5.421875f,10.109375f);
  glVertex2f(5.421875f,12.593750f);
  glVertex2f(9.984375f,10.109375f);
  glVertex2f(10.140625f,12.593750f);
  glVertex2f(11.013124f,10.070625f);
  glVertex2f(11.828125f,12.726250f);
  glVertex2f(11.936875f,9.954375f);
  glVertex2f(13.140625f,13.123750f);
  glVertex2f(12.755625f,9.760625f);
  glVertex2f(13.469375f,9.489375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(17.364374f,14.772500f);
  glVertex2f(17.471563f,15.141562f);
  glVertex2f(17.535625f,17.306562f);
  glVertex2f(17.548124f,15.521250f);
  glVertex2f(17.609375f,16.312500f);
  glVertex2f(17.594063f,15.911563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.314375f,18.201250f);
  glVertex2f(16.945625f,18.996563f);
  glVertex2f(17.067188f,14.076563f);
  glVertex2f(17.226563f,14.414063f);
  glVertex2f(17.364374f,14.772500f);
  glVertex2f(17.535625f,17.306562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.945625f,18.996563f);
  glVertex2f(16.429375f,19.692499f);
  glVertex2f(16.514063f,13.251562f);
  glVertex2f(16.710938f,13.495313f);
  glVertex2f(16.895313f,13.770312f);
  glVertex2f(17.067188f,14.076563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.429375f,19.692499f);
  glVertex2f(15.765625f,20.289063f);
  glVertex2f(15.872188f,12.665313f);
  glVertex2f(16.088751f,12.847187f);
  glVertex2f(16.304688f,13.039063f);
  glVertex2f(16.514063f,13.251562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.765625f,20.289063f);
  glVertex2f(14.989375f,20.781250f);
  glVertex2f(15.006875f,12.041250f);
  glVertex2f(15.218750f,12.179688f);
  glVertex2f(15.437187f,12.331562f);
  glVertex2f(15.655000f,12.493438f);
  glVertex2f(15.872188f,12.665313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.640625f,14.713750f);
  glVertex2f(14.078125f,13.786250f);
  glVertex2f(14.296875f,11.656250f);
  glVertex2f(14.453750f,11.727187f);
  glVertex2f(14.624375f,11.815000f);
  glVertex2f(14.808750f,11.919687f);
  glVertex2f(14.828125f,15.906250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.921875f,11.546875f);
  glVertex2f(14.296875f,11.656250f);
  glVertex2f(14.078125f,13.786250f);
  glVertex2f(13.469375f,9.489375f);
  glVertex2f(14.078125f,9.140625f);
  glVertex2f(13.995937f,11.520938f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.351563f,10.305000f);
  glVertex2f(16.078125f,10.505000f);
  glVertex2f(16.468750f,1.742188f);
  glVertex2f(15.789063f,10.695000f);
  glVertex2f(15.665625f,1.115000f);
  glVertex2f(15.484375f,10.875000f);
  glVertex2f(15.468750f,6.359375f);
  glVertex2f(15.413125f,7.050625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.413125f,7.050625f);
  glVertex2f(15.484375f,10.875000f);
  glVertex2f(15.246250f,7.674375f);
  glVertex2f(15.190937f,11.035937f);
  glVertex2f(14.968125f,8.230625f);
  glVertex2f(14.935625f,11.168750f);
  glVertex2f(14.718437f,11.273438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.578750f,8.719375f);
  glVertex2f(14.968125f,8.230625f);
  glVertex2f(14.718437f,11.273438f);
  glVertex2f(14.539375f,11.350000f);
  glVertex2f(14.398438f,11.398438f);
  glVertex2f(14.281875f,11.431875f);
  glVertex2f(14.175938f,11.463437f);
  glVertex2f(14.080625f,11.493125f);
  glVertex2f(14.078125f,9.140625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.328751f,6.985000f);
  glVertex2f(18.231874f,7.436563f);
  glVertex2f(18.328751f,5.044687f);
  glVertex2f(18.406250f,6.031250f);
  glVertex2f(18.386875f,6.516562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.096251f,7.871250f);
  glVertex2f(17.921875f,8.289063f);
  glVertex2f(18.096251f,4.122500f);
  glVertex2f(18.328751f,5.044687f);
  glVertex2f(18.231874f,7.436563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.724062f,8.680000f);
  glVertex2f(17.518126f,9.034062f);
  glVertex2f(17.708750f,3.264687f);
  glVertex2f(18.096251f,4.122500f);
  glVertex2f(17.921875f,8.289063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.304062f,9.351250f);
  glVertex2f(17.081875f,9.631562f);
  glVertex2f(17.166250f,2.471250f);
  glVertex2f(17.708750f,3.264687f);
  glVertex2f(17.518126f,9.034062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.351563f,10.305000f);
  glVertex2f(16.468750f,1.742188f);
  glVertex2f(16.609375f,10.095000f);
  glVertex2f(17.166250f,2.471250f);
  glVertex2f(16.851563f,9.875000f);
  glVertex2f(17.081875f,9.631562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.665625f,1.115000f);
  glVertex2f(15.468750f,6.359375f);
  glVertex2f(15.409687f,5.726563f);
  glVertex2f(15.232500f,5.140625f);
  glVertex2f(14.937187f,4.601563f);
  glVertex2f(14.806250f,0.627187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.937187f,4.601563f);
  glVertex2f(14.523750f,4.109375f);
  glVertex2f(14.806250f,0.627187f);
  glVertex2f(13.992188f,3.664063f);
  glVertex2f(13.890625f,0.278750f);
  glVertex2f(13.365625f,3.284375f);
  glVertex2f(12.918750f,0.069687f);
  glVertex2f(12.667188f,2.989063f);
  glVertex2f(11.896875f,2.778125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.890625f,0.000000f);
  glVertex2f(12.918750f,0.069687f);
  glVertex2f(11.896875f,2.778125f);
  glVertex2f(11.054688f,2.651562f);
  glVertex2f(10.140625f,2.609375f);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(2.406250f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(13.995937f,11.520938f);
  glVertex2f(14.078125f,9.140625f);
  glVertex2f(14.080625f,11.493125f);
  glVertex2f(13.140625f,13.123750f);
  glVertex2f(13.469375f,9.489375f);
  glVertex2f(14.078125f,13.786250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(11.109375f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.609375f,5.796875f);
  glVertex2f(15.562500f,5.796875f);
  glVertex2f(15.593750f,0.718750f);
  glVertex2f(16.500000f,1.351563f);
  glVertex2f(17.259375f,2.091875f);
  glVertex2f(17.850000f,2.906562f);
  glVertex2f(18.271875f,3.795625f);
  glVertex2f(18.525000f,4.759062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.718750f,-0.406250f);
  glVertex2f(12.125000f,-0.335938f);
  glVertex2f(12.442500f,2.166875f);
  glVertex2f(13.406250f,-0.125000f);
  glVertex2f(13.807500f,2.620625f);
  glVertex2f(14.562500f,0.226562f);
  glVertex2f(14.782500f,3.376875f);
  glVertex2f(15.593750f,0.718750f);
  glVertex2f(15.367500f,4.435625f);
  glVertex2f(15.562500f,5.796875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.799375f,4.912500f);
  glVertex2f(5.823750f,0.868438f);
  glVertex2f(6.328125f,4.007813f);
  glVertex2f(6.507813f,0.484375f);
  glVertex2f(6.972500f,3.290625f);
  glVertex2f(7.248750f,0.163750f);
  glVertex2f(7.730625f,2.732812f);
  glVertex2f(8.040313f,-0.085625f);
  glVertex2f(8.602500f,2.334375f);
  glVertex2f(8.882500f,-0.263750f);
  glVertex2f(9.588125f,2.095313f);
  glVertex2f(9.775312f,-0.370625f);
  glVertex2f(10.687500f,2.015625f);
  glVertex2f(10.718750f,-0.406250f);
  glVertex2f(12.442500f,2.166875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.388125f,6.032812f);
  glVertex2f(5.094375f,7.368750f);
  glVertex2f(5.202813f,1.308125f);
  glVertex2f(5.823750f,0.868438f);
  glVertex2f(5.799375f,4.912500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.208437f,20.291250f);
  glVertex2f(4.647500f,19.772499f);
  glVertex2f(4.859375f,10.687500f);
  glVertex2f(4.645000f,1.803438f);
  glVertex2f(4.918125f,8.920313f);
  glVertex2f(5.202813f,1.308125f);
  glVertex2f(5.094375f,7.368750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.781250f,10.695313f);
  glVertex2f(1.800000f,9.783438f);
  glVertex2f(1.800000f,11.608438f);
  glVertex2f(1.856250f,8.904062f);
  glVertex2f(1.856250f,12.491563f);
  glVertex2f(1.950000f,8.057187f);
  glVertex2f(1.950000f,13.344687f);
  glVertex2f(2.081250f,7.242813f);
  glVertex2f(2.081250f,14.167812f);
  glVertex2f(2.250000f,6.460938f);
  glVertex2f(2.250000f,14.960938f);
  glVertex2f(2.458750f,5.708437f);
  glVertex2f(2.458750f,15.727500f);
  glVertex2f(2.710000f,4.982188f);
  glVertex2f(2.710000f,16.470938f);
  glVertex2f(3.003750f,4.282187f);
  glVertex2f(3.003750f,17.191250f);
  glVertex2f(3.340000f,3.608438f);
  glVertex2f(3.340000f,17.888437f);
  glVertex2f(3.718750f,2.960938f);
  glVertex2f(3.718750f,18.562500f);
  glVertex2f(4.150312f,2.354375f);
  glVertex2f(4.150938f,19.196251f);
  glVertex2f(4.645000f,1.803438f);
  glVertex2f(4.647500f,19.772499f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.484375f,15.875000f);
  glVertex2f(18.407812f,16.929062f);
  glVertex2f(18.178125f,17.903749f);
  glVertex2f(17.795313f,18.799063f);
  glVertex2f(17.259375f,19.615000f);
  glVertex2f(16.570313f,20.351563f);
  glVertex2f(15.726250f,20.978750f);
  glVertex2f(15.437500f,15.875000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.726250f,20.978750f);
  glVertex2f(14.725312f,21.466562f);
  glVertex2f(14.742500f,18.344999f);
  glVertex2f(15.046562f,17.845625f);
  glVertex2f(15.263750f,17.267500f);
  glVertex2f(15.394062f,16.610624f);
  glVertex2f(15.437500f,15.875000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.556250f,19.566250f);
  glVertex2f(13.264063f,19.375626f);
  glVertex2f(13.567500f,21.815001f);
  glVertex2f(13.862500f,19.108749f);
  glVertex2f(14.725312f,21.466562f);
  glVertex2f(14.351563f,18.765625f);
  glVertex2f(14.742500f,18.344999f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.252812f,22.024063f);
  glVertex2f(10.781250f,22.093750f);
  glVertex2f(10.812500f,19.718750f);
  glVertex2f(11.739062f,19.680626f);
  glVertex2f(12.556250f,19.566250f);
  glVertex2f(13.567500f,21.815001f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.781250f,22.093750f);
  glVertex2f(9.825937f,22.056250f);
  glVertex2f(10.812500f,19.718750f);
  glVertex2f(8.922500f,21.943750f);
  glVertex2f(8.669375f,19.357500f);
  glVertex2f(8.070937f,21.756250f);
  glVertex2f(7.271250f,21.493750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.002500f,18.273750f);
  glVertex2f(8.669375f,19.357500f);
  glVertex2f(7.271250f,21.493750f);
  glVertex2f(6.523438f,21.156250f);
  glVertex2f(5.833750f,20.752501f);
  glVertex2f(5.811875f,16.467501f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.208437f,20.291250f);
  glVertex2f(4.859375f,10.687500f);
  glVertex2f(5.097500f,13.938750f);
  glVertex2f(5.811875f,16.467501f);
  glVertex2f(5.833750f,20.752501f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.812500f,10.875000f);
  glVertex2f(19.799999f,11.554063f);
  glVertex2f(19.799999f,10.224375f);
  glVertex2f(19.762501f,12.216249f);
  glVertex2f(19.762501f,9.585000f);
  glVertex2f(19.700001f,12.861563f);
  glVertex2f(19.700001f,8.956875f);
  glVertex2f(19.612499f,13.490000f);
  glVertex2f(19.612499f,8.340000f);
  glVertex2f(19.500000f,14.101563f);
  glVertex2f(19.500000f,7.734375f);
  glVertex2f(19.356562f,14.700625f);
  glVertex2f(19.356562f,7.137187f);
  glVertex2f(19.176250f,15.291562f);
  glVertex2f(19.176250f,6.545625f);
  glVertex2f(18.959063f,15.874375f);
  glVertex2f(18.959063f,5.959687f);
  glVertex2f(18.705000f,16.449062f);
  glVertex2f(18.705000f,5.379375f);
  glVertex2f(18.414063f,17.015625f);
  glVertex2f(18.414063f,4.804688f);
  glVertex2f(18.088125f,17.562500f);
  glVertex2f(18.088125f,4.248437f);
  glVertex2f(17.729063f,18.078125f);
  glVertex2f(17.729063f,3.723438f);
  glVertex2f(17.336876f,18.562500f);
  glVertex2f(17.336874f,3.229687f);
  glVertex2f(16.911562f,19.015625f);
  glVertex2f(16.911562f,2.767187f);
  glVertex2f(16.812500f,10.875000f);
  glVertex2f(16.731251f,9.381562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.780625f,20.507187f);
  glVertex2f(14.796875f,16.921875f);
  glVertex2f(15.393126f,20.183750f);
  glVertex2f(15.522500f,16.000000f);
  glVertex2f(15.950625f,19.827187f);
  glVertex2f(16.086874f,14.934375f);
  glVertex2f(16.453125f,19.437500f);
  glVertex2f(16.490000f,13.725000f);
  glVertex2f(16.911562f,19.015625f);
  glVertex2f(16.731874f,12.371875f);
  glVertex2f(16.812500f,10.875000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.810625f,21.439688f);
  glVertex2f(11.815625f,18.706875f);
  glVertex2f(12.620625f,21.271250f);
  glVertex2f(12.934375f,18.281876f);
  glVertex2f(13.390625f,21.054688f);
  glVertex2f(13.928125f,17.686874f);
  glVertex2f(14.113125f,20.797501f);
  glVertex2f(14.796875f,16.921875f);
  glVertex2f(14.780625f,20.507187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(9.140625f,21.656250f);
  glVertex2f(9.203125f,19.046875f);
  glVertex2f(10.070625f,21.632187f);
  glVertex2f(10.571875f,18.961876f);
  glVertex2f(10.960625f,21.559999f);
  glVertex2f(11.815625f,18.706875f);
  glVertex2f(11.810625f,21.439688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.113125f,0.923437f);
  glVertex2f(14.780625f,1.229687f);
  glVertex2f(14.781250f,4.789063f);
  glVertex2f(15.393125f,1.567188f);
  glVertex2f(15.512500f,5.730000f);
  glVertex2f(15.950625f,1.935938f);
  glVertex2f(16.081249f,6.809062f);
  glVertex2f(16.453125f,2.335938f);
  glVertex2f(16.487499f,8.026250f);
  glVertex2f(16.911562f,2.767187f);
  glVertex2f(16.731251f,9.381562f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.810625f,0.233437f);
  glVertex2f(12.620625f,0.415000f);
  glVertex2f(12.913750f,3.394063f);
  glVertex2f(13.390625f,0.648438f);
  glVertex2f(13.908125f,4.004375f);
  glVertex2f(14.113125f,0.923437f);
  glVertex2f(14.781250f,4.789063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(9.140625f,0.000000f);
  glVertex2f(9.203125f,2.609375f);
  glVertex2f(10.070625f,0.025937f);
  glVertex2f(10.561250f,2.696563f);
  glVertex2f(10.960625f,0.103750f);
  glVertex2f(11.798125f,2.958125f);
  glVertex2f(11.810625f,0.233437f);
  glVertex2f(12.913750f,3.394063f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(9.140625f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(5.421875f,9.781250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(16.109375f,0.000000f);
  glVertex2f(16.109375f,2.609375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.828125f,21.656250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(15.828125f,19.046875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,12.390625f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(5.421875f,9.781250f);
  glVertex2f(15.500000f,9.781250f);
  glVertex2f(15.500000f,12.390625f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(15.000000f,19.046875f);
  glVertex2f(15.000000f,21.656250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(5.421875f,9.781250f);
  glVertex2f(5.421875f,12.390625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,12.390625f);
  glVertex2f(5.421875f,9.781250f);
  glVertex2f(14.421875f,9.781250f);
  glVertex2f(14.421875f,12.390625f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.421875f,11.546875f);
  glVertex2f(12.484375f,11.546875f);
  glVertex2f(17.406250f,8.937500f);
  glVertex2f(18.034063f,0.346875f);
  glVertex2f(18.860624f,0.565625f);
  glVertex2f(19.656563f,0.809375f);
  glVertex2f(20.421875f,1.078125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.406250f,2.937500f);
  glVertex2f(15.734375f,2.578125f);
  glVertex2f(16.289063f,-0.015625f);
  glVertex2f(17.176874f,0.153125f);
  glVertex2f(18.034063f,0.346875f);
  glVertex2f(17.406250f,8.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.289063f,-0.015625f);
  glVertex2f(15.734375f,2.578125f);
  glVertex2f(15.415625f,-0.156250f);
  glVertex2f(15.057500f,2.454375f);
  glVertex2f(14.601563f,-0.265625f);
  glVertex2f(14.364375f,2.358125f);
  glVertex2f(13.846875f,-0.343750f);
  glVertex2f(13.655000f,2.289375f);
  glVertex2f(13.151563f,-0.390625f);
  glVertex2f(12.929375f,2.248125f);
  glVertex2f(12.515625f,-0.406250f);
  glVertex2f(12.187500f,2.234375f);
  glVertex2f(11.414375f,2.264688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.515625f,-0.406250f);
  glVertex2f(11.414375f,2.264688f);
  glVertex2f(10.682500f,2.355625f);
  glVertex2f(9.991875f,2.507188f);
  glVertex2f(9.342500f,2.719375f);
  glVertex2f(8.734375f,2.992188f);
  glVertex2f(8.651250f,0.077500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.651250f,0.077500f);
  glVertex2f(8.734375f,2.992188f);
  glVertex2f(8.173437f,3.319375f);
  glVertex2f(7.665625f,3.694687f);
  glVertex2f(7.210938f,4.118125f);
  glVertex2f(6.809375f,4.589687f);
  glVertex2f(6.460938f,5.109375f);
  glVertex2f(6.155938f,5.663437f);
  glVertex2f(5.884687f,6.238125f);
  glVertex2f(5.645625f,1.528750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.645625f,1.528750f);
  glVertex2f(5.884687f,6.238125f);
  glVertex2f(5.647188f,6.833437f);
  glVertex2f(5.443438f,7.449375f);
  glVertex2f(5.273438f,8.085938f);
  glVertex2f(5.135625f,8.745000f);
  glVertex2f(5.028438f,9.428437f);
  glVertex2f(4.951875f,10.136250f);
  glVertex2f(3.621250f,17.867500f);
  glVertex2f(3.498750f,3.947500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.905938f,10.868438f);
  glVertex2f(4.890625f,11.625000f);
  glVertex2f(4.656250f,19.117188f);
  glVertex2f(4.966250f,12.988125f);
  glVertex2f(5.881250f,20.188749f);
  glVertex2f(5.193125f,14.240000f);
  glVertex2f(5.571250f,15.380625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.621250f,17.867500f);
  glVertex2f(4.951875f,10.136250f);
  glVertex2f(4.905938f,10.868438f);
  glVertex2f(4.656250f,19.117188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.621250f,17.867500f);
  glVertex2f(2.816250f,16.499687f);
  glVertex2f(3.498750f,3.947500f);
  glVertex2f(2.241250f,15.013750f);
  glVertex2f(2.210625f,7.333750f);
  glVertex2f(1.896250f,13.409688f);
  glVertex2f(1.781250f,11.687500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.531250f,16.265625f);
  glVertex2f(20.510937f,16.642187f);
  glVertex2f(20.450001f,17.021875f);
  glVertex2f(20.348438f,17.404688f);
  glVertex2f(20.206249f,17.790625f);
  glVertex2f(20.023438f,18.179688f);
  glVertex2f(19.802500f,18.567188f);
  glVertex2f(19.545937f,18.948437f);
  glVertex2f(19.253750f,19.323437f);
  glVertex2f(18.925938f,19.692188f);
  glVertex2f(18.562500f,20.054688f);
  glVertex2f(18.153126f,20.400938f);
  glVertex2f(17.687500f,20.720938f);
  glVertex2f(17.515625f,16.265625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.600624f,17.965626f);
  glVertex2f(17.000937f,17.535938f);
  glVertex2f(17.165625f,21.014687f);
  glVertex2f(17.286875f,17.109375f);
  glVertex2f(17.687500f,20.720938f);
  glVertex2f(17.458437f,16.685938f);
  glVertex2f(17.515625f,16.265625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.616875f,18.104376f);
  glVertex2f(8.611250f,18.708124f);
  glVertex2f(8.781250f,21.617500f);
  glVertex2f(9.764375f,19.139376f);
  glVertex2f(10.456250f,21.974688f);
  glVertex2f(11.076250f,19.398125f);
  glVertex2f(12.281250f,22.093750f);
  glVertex2f(12.546875f,19.484375f);
  glVertex2f(13.073125f,22.070938f);
  glVertex2f(13.363438f,19.440937f);
  glVertex2f(13.836250f,22.002501f);
  glVertex2f(14.125625f,19.310625f);
  glVertex2f(14.570625f,21.888437f);
  glVertex2f(14.833438f,19.093437f);
  glVertex2f(15.276250f,21.728750f);
  glVertex2f(15.486875f,18.789375f);
  glVertex2f(15.953125f,21.523438f);
  glVertex2f(16.085938f,18.398438f);
  glVertex2f(16.587500f,21.282188f);
  glVertex2f(16.600624f,17.965626f);
  glVertex2f(17.165625f,21.014687f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.256250f,21.022188f);
  glVertex2f(5.881250f,20.188749f);
  glVertex2f(6.100625f,16.410000f);
  glVertex2f(6.781250f,17.328125f);
  glVertex2f(7.616875f,18.104376f);
  glVertex2f(8.781250f,21.617500f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(5.881250f,20.188749f);
  glVertex2f(5.571250f,15.380625f);
  glVertex2f(6.100625f,16.410000f);
  glVertex2f(17.406250f,8.937500f);
  glVertex2f(12.484375f,11.546875f);
  glVertex2f(12.484375f,8.937500f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(18.875000f,21.656250f);
  glVertex2f(15.843750f,21.656250f);
  glVertex2f(18.875000f,0.000000f);
  glVertex2f(15.843750f,12.390625f);
  glVertex2f(15.843750f,9.781250f);
  glVertex2f(5.421875f,12.390625f);
  glVertex2f(5.421875f,9.781250f);
  glVertex2f(5.421875f,21.656250f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(18.875000f,0.000000f);
  glVertex2f(15.843750f,9.781250f);
  glVertex2f(15.843750f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(5.421875f,21.656250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.671875f,21.656250f);
  glVertex2f(11.625000f,21.656250f);
  glVertex2f(12.046250f,0.803750f);
  glVertex2f(12.828125f,1.484375f);
  glVertex2f(13.491875f,2.288125f);
  glVertex2f(14.008125f,3.186875f);
  glVertex2f(14.376875f,4.180625f);
  glVertex2f(14.598125f,5.269375f);
  glVertex2f(14.671875f,6.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.046250f,0.803750f);
  glVertex2f(11.625000f,21.656250f);
  glVertex2f(11.625000f,6.453125f);
  glVertex2f(11.585938f,5.678125f);
  glVertex2f(11.468750f,4.978125f);
  glVertex2f(11.273438f,4.353125f);
  glVertex2f(11.175625f,0.274375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.175625f,0.274375f);
  glVertex2f(11.273438f,4.353125f);
  glVertex2f(11.000000f,3.803125f);
  glVertex2f(10.648438f,3.328125f);
  glVertex2f(10.238125f,2.934375f);
  glVertex2f(10.216249f,-0.103750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.238125f,2.934375f);
  glVertex2f(9.788438f,2.628125f);
  glVertex2f(10.216249f,-0.103750f);
  glVertex2f(9.299375f,2.409375f);
  glVertex2f(9.168125f,-0.330625f);
  glVertex2f(8.770938f,2.278125f);
  glVertex2f(8.203125f,2.234375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.168125f,-0.330625f);
  glVertex2f(8.203125f,2.234375f);
  glVertex2f(8.031250f,-0.406250f);
  glVertex2f(6.985000f,2.378125f);
  glVertex2f(6.950000f,-0.336562f);
  glVertex2f(6.030625f,2.809375f);
  glVertex2f(5.956250f,-0.127500f);
  glVertex2f(5.340000f,3.528125f);
  glVertex2f(5.050000f,0.220938f);
  glVertex2f(4.913125f,4.534375f);
  glVertex2f(4.750000f,5.828125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.750000f,5.828125f);
  glVertex2f(1.781250f,5.828125f);
  glVertex2f(1.850000f,4.768437f);
  glVertex2f(2.056250f,3.789375f);
  glVertex2f(2.400000f,2.890938f);
  glVertex2f(2.881250f,2.073125f);
  glVertex2f(3.500000f,1.335938f);
  glVertex2f(4.231250f,0.708750f);
  glVertex2f(5.050000f,0.220938f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.187500f,0.000000f);
  glVertex2f(8.875000f,12.328125f);
  glVertex2f(15.140625f,0.000000f);
  glVertex2f(5.421875f,12.453125f);
  glVertex2f(5.421875f,11.421875f);
  glVertex2f(5.421875f,21.656250f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.359375f,21.656250f);
  glVertex2f(5.421875f,12.453125f);
  glVertex2f(8.875000f,12.328125f);
  glVertex2f(18.078125f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,2.609375f);
  glVertex2f(5.421875f,21.656250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(15.000000f,0.000000f);
  glVertex2f(15.000000f,2.609375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,18.656250f);
  glVertex2f(7.171875f,21.656250f);
  glVertex2f(12.250000f,0.000000f);
  glVertex2f(13.453125f,4.187500f);
  glVertex2f(14.656250f,0.000000f);
  glVertex2f(19.781250f,21.656250f);
  glVertex2f(21.500000f,18.812500f);
  glVertex2f(24.546875f,21.656250f);
  glVertex2f(24.546875f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(24.546875f,0.000000f);
  glVertex2f(21.500000f,18.812500f);
  glVertex2f(21.500000f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,17.750000f);
  glVertex2f(6.687500f,21.656250f);
  glVertex2f(14.968750f,0.000000f);
  glVertex2f(16.265625f,3.890625f);
  glVertex2f(19.281250f,0.000000f);
  glVertex2f(16.265625f,21.656250f);
  glVertex2f(19.281250f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(21.322187f,13.119062f);
  glVertex2f(21.023125f,14.838750f);
  glVertex2f(21.050625f,7.644375f);
  glVertex2f(21.256874f,8.797500f);
  glVertex2f(21.380625f,9.999375f);
  glVertex2f(21.421875f,11.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.928749f,4.490000f);
  glVertex2f(20.390625f,5.484375f);
  glVertex2f(20.524687f,16.409063f);
  glVertex2f(20.761875f,6.540000f);
  glVertex2f(21.023125f,14.838750f);
  glVertex2f(21.050625f,7.644375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(18.343750f,11.250000f);
  glVertex2f(18.708750f,2.722500f);
  glVertex2f(18.929688f,19.101563f);
  glVertex2f(19.368126f,3.569375f);
  glVertex2f(19.826876f,17.830000f);
  glVertex2f(19.928749f,4.490000f);
  glVertex2f(20.524687f,16.409063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.929688f,19.101563f);
  glVertex2f(17.840000f,20.178749f);
  glVertex2f(17.878750f,15.042500f);
  glVertex2f(18.023438f,14.484375f);
  glVertex2f(18.138750f,13.900000f);
  glVertex2f(18.228437f,13.284375f);
  glVertex2f(18.292500f,12.637500f);
  glVertex2f(18.330938f,11.959375f);
  glVertex2f(18.343750f,11.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.840000f,20.178749f);
  glVertex2f(16.564688f,21.016562f);
  glVertex2f(16.650312f,17.504063f);
  glVertex2f(16.968750f,17.062500f);
  glVertex2f(17.245937f,16.589375f);
  glVertex2f(17.490000f,16.094999f);
  glVertex2f(17.700937f,15.579375f);
  glVertex2f(17.878750f,15.042500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.564688f,21.016562f);
  glVertex2f(15.103750f,21.615000f);
  glVertex2f(15.398750f,18.577499f);
  glVertex2f(15.865313f,18.261562f);
  glVertex2f(16.282499f,17.903749f);
  glVertex2f(16.650312f,17.504063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.103750f,21.615000f);
  glVertex2f(13.457188f,21.974062f);
  glVertex2f(13.712812f,19.256563f);
  glVertex2f(14.320000f,19.079374f);
  glVertex2f(14.882813f,18.851563f);
  glVertex2f(15.398750f,18.577499f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.890625f,11.250000f);
  glVertex2f(5.160000f,14.214375f);
  glVertex2f(5.385000f,20.178749f);
  glVertex2f(5.968125f,16.520000f);
  glVertex2f(6.666563f,21.016563f);
  glVertex2f(7.315000f,18.166876f);
  glVertex2f(8.133750f,21.615000f);
  glVertex2f(9.200625f,19.155001f);
  glVertex2f(9.786563f,21.974062f);
  glVertex2f(11.625000f,19.484375f);
  glVertex2f(11.625000f,22.093750f);
  glVertex2f(12.365313f,19.459063f);
  glVertex2f(13.457188f,21.974062f);
  glVertex2f(13.061250f,19.383125f);
  glVertex2f(13.712812f,19.256563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.289063f,19.101563f);
  glVertex2f(3.386250f,17.830000f);
  glVertex2f(3.863125f,3.569375f);
  glVertex2f(4.528750f,2.722500f);
  glVertex2f(4.890625f,11.250000f);
  glVertex2f(5.385000f,20.178749f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.948750f,8.797501f);
  glVertex2f(2.158125f,7.644375f);
  glVertex2f(2.182500f,14.838750f);
  glVertex2f(2.451250f,6.540000f);
  glVertex2f(2.684062f,16.409063f);
  glVertex2f(2.828125f,5.484375f);
  glVertex2f(3.386250f,17.830000f);
  glVertex2f(3.296250f,4.490000f);
  glVertex2f(3.863125f,3.569375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.881562f,13.119062f);
  glVertex2f(1.781250f,11.250000f);
  glVertex2f(1.823125f,9.999375f);
  glVertex2f(1.948750f,8.797501f);
  glVertex2f(2.182500f,14.838750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.708750f,2.722500f);
  glVertex2f(18.343750f,11.250000f);
  glVertex2f(18.335938f,10.682813f);
  glVertex2f(18.312500f,10.131250f);
  glVertex2f(18.273438f,9.595312f);
  glVertex2f(18.218750f,9.075000f);
  glVertex2f(18.148438f,8.570313f);
  glVertex2f(18.059376f,8.075000f);
  glVertex2f(17.950624f,1.949375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.950624f,1.949375f);
  glVertex2f(18.059376f,8.075000f);
  glVertex2f(17.948437f,7.582813f);
  glVertex2f(17.815624f,7.093750f);
  glVertex2f(17.660938f,6.607812f);
  glVertex2f(17.484375f,6.125000f);
  glVertex2f(17.285938f,5.658438f);
  glVertex2f(17.093750f,1.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.093750f,1.250000f);
  glVertex2f(17.285938f,5.658438f);
  glVertex2f(17.065624f,5.221250f);
  glVertex2f(16.823437f,4.813437f);
  glVertex2f(16.559376f,4.435000f);
  glVertex2f(16.273438f,4.085938f);
  glVertex2f(16.150312f,0.653750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.150312f,0.653750f);
  glVertex2f(16.273438f,4.085938f);
  glVertex2f(15.958750f,3.764688f);
  glVertex2f(15.608438f,3.469687f);
  glVertex2f(15.222500f,3.200938f);
  glVertex2f(15.132500f,0.190000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.222500f,3.200938f);
  glVertex2f(14.800938f,2.958437f);
  glVertex2f(15.132500f,0.190000f);
  glVertex2f(14.343750f,2.742188f);
  glVertex2f(14.040313f,-0.141250f);
  glVertex2f(13.855312f,2.559375f);
  glVertex2f(13.340000f,2.417187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.873750f,-0.340000f);
  glVertex2f(14.040313f,-0.141250f);
  glVertex2f(13.340000f,2.417187f);
  glVertex2f(12.797812f,2.315625f);
  glVertex2f(12.228750f,2.254688f);
  glVertex2f(11.632813f,2.234375f);
  glVertex2f(11.632813f,-0.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.632813f,2.234375f);
  glVertex2f(11.036875f,2.254688f);
  glVertex2f(11.632813f,-0.406250f);
  glVertex2f(10.467813f,2.315625f);
  glVertex2f(10.391250f,-0.340000f);
  glVertex2f(9.925625f,2.417187f);
  glVertex2f(9.410313f,2.559375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.222813f,-0.141250f);
  glVertex2f(10.391250f,-0.340000f);
  glVertex2f(9.410313f,2.559375f);
  glVertex2f(8.921875f,2.742188f);
  glVertex2f(8.464375f,2.958437f);
  glVertex2f(8.127500f,0.190000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.127500f,0.190000f);
  glVertex2f(8.464375f,2.958437f);
  glVertex2f(8.041875f,3.200938f);
  glVertex2f(7.654375f,3.469687f);
  glVertex2f(7.301875f,3.764688f);
  glVertex2f(7.105312f,0.653750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.105312f,0.653750f);
  glVertex2f(7.301875f,3.764688f);
  glVertex2f(6.984375f,4.085938f);
  glVertex2f(6.695313f,4.434375f);
  glVertex2f(6.428125f,4.810937f);
  glVertex2f(6.182813f,5.215625f);
  glVertex2f(6.156250f,1.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.156250f,1.250000f);
  glVertex2f(6.182813f,5.215625f);
  glVertex2f(5.959375f,5.648438f);
  glVertex2f(5.757813f,6.109375f);
  glVertex2f(5.578437f,6.587187f);
  glVertex2f(5.421563f,7.070625f);
  glVertex2f(5.293125f,1.949375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.293125f,1.949375f);
  glVertex2f(5.421563f,7.070625f);
  glVertex2f(5.287188f,7.559688f);
  glVertex2f(5.175313f,8.054375f);
  glVertex2f(5.085938f,8.554688f);
  glVertex2f(5.015625f,9.065000f);
  glVertex2f(4.960938f,9.589687f);
  glVertex2f(4.921875f,10.128750f);
  glVertex2f(4.528750f,2.722500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.898438f,10.682187f);
  glVertex2f(4.890625f,11.250000f);
  glVertex2f(4.528750f,2.722500f);
  glVertex2f(4.921875f,10.128750f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.906250f,15.414063f);
  glVertex2f(16.886875f,16.031250f);
  glVertex2f(16.886875f,14.796875f);
  glVertex2f(16.828751f,16.614063f);
  glVertex2f(16.828751f,14.214063f);
  glVertex2f(16.731874f,17.162500f);
  glVertex2f(16.731874f,13.665625f);
  glVertex2f(16.596251f,17.676563f);
  glVertex2f(16.596251f,13.151563f);
  glVertex2f(16.421875f,18.156250f);
  glVertex2f(16.421875f,12.671875f);
  glVertex2f(16.217188f,18.598749f);
  glVertex2f(16.217188f,12.229375f);
  glVertex2f(15.990625f,19.001249f);
  glVertex2f(15.990625f,11.826875f);
  glVertex2f(15.742188f,19.363750f);
  glVertex2f(15.742188f,11.464375f);
  glVertex2f(15.471875f,19.686251f);
  glVertex2f(15.471875f,11.141875f);
  glVertex2f(15.179688f,19.968750f);
  glVertex2f(15.179688f,10.859375f);
  glVertex2f(14.860312f,20.220938f);
  glVertex2f(14.860312f,10.607187f);
  glVertex2f(14.508437f,20.452499f);
  glVertex2f(14.508437f,10.375625f);
  glVertex2f(14.124063f,20.663437f);
  glVertex2f(14.124063f,10.164687f);
  glVertex2f(13.968750f,15.414063f);
  glVertex2f(13.917812f,14.675313f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.891875f,21.400312f);
  glVertex2f(12.104375f,18.511875f);
  glVertex2f(12.340313f,21.297188f);
  glVertex2f(12.679688f,18.210938f);
  glVertex2f(12.795625f,21.171562f);
  glVertex2f(13.143750f,17.831562f);
  glVertex2f(13.257813f,21.023438f);
  glVertex2f(13.504687f,17.362188f);
  glVertex2f(13.707188f,20.853750f);
  glVertex2f(13.762500f,16.802813f);
  glVertex2f(14.124063f,20.663437f);
  glVertex2f(13.917188f,16.153437f);
  glVertex2f(13.968750f,15.414063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.571250f,21.581249f);
  glVertex2f(10.595625f,18.913124f);
  glVertex2f(11.015625f,21.539063f);
  glVertex2f(11.409687f,18.745937f);
  glVertex2f(11.450313f,21.480938f);
  glVertex2f(12.104375f,18.511875f);
  glVertex2f(11.891875f,21.400312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.100625f,21.614063f);
  glVertex2f(9.603750f,21.637501f);
  glVertex2f(9.662188f,19.013437f);
  glVertex2f(10.595625f,18.913124f);
  glVertex2f(10.571250f,21.581249f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(8.531250f,21.656250f);
  glVertex2f(8.609375f,19.046875f);
  glVertex2f(9.080625f,21.651562f);
  glVertex2f(9.662188f,19.013437f);
  glVertex2f(9.603750f,21.637501f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(5.421875f,9.171875f);
  glVertex2f(5.421875f,11.812500f);
  glVertex2f(8.531250f,9.171875f);
  glVertex2f(8.609375f,11.812500f);
  glVertex2f(9.080625f,9.176562f);
  glVertex2f(9.672812f,11.845312f);
  glVertex2f(9.603750f,9.190625f);
  glVertex2f(10.100625f,9.214063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.450313f,9.347187f);
  glVertex2f(11.891875f,9.427813f);
  glVertex2f(12.124375f,12.337500f);
  glVertex2f(12.340313f,9.530937f);
  glVertex2f(12.695313f,12.632813f);
  glVertex2f(12.795625f,9.656563f);
  glVertex2f(13.153750f,13.006562f);
  glVertex2f(13.257813f,9.804688f);
  glVertex2f(13.510312f,13.471562f);
  glVertex2f(13.707188f,9.974375f);
  glVertex2f(13.765000f,14.027813f);
  glVertex2f(14.124063f,10.164687f);
  glVertex2f(13.917812f,14.675313f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.100625f,9.214063f);
  glVertex2f(10.571250f,9.246875f);
  glVertex2f(10.613125f,11.943750f);
  glVertex2f(11.015625f,9.289063f);
  glVertex2f(11.430312f,12.107813f);
  glVertex2f(11.450313f,9.347187f);
  glVertex2f(12.124375f,12.337500f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(9.672812f,11.845312f);
  glVertex2f(10.100625f,9.214063f);
  glVertex2f(10.613125f,11.943750f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(5.421875f,9.171875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(21.041876f,7.805000f);
  glVertex2f(21.208124f,8.663750f);
  glVertex2f(21.239374f,13.837500f);
  glVertex2f(21.326876f,9.545000f);
  glVertex2f(21.376249f,12.640625f);
  glVertex2f(21.398125f,10.448750f);
  glVertex2f(21.421875f,11.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(20.373125f,5.683750f);
  glVertex2f(20.614374f,6.313125f);
  glVertex2f(20.691875f,16.025000f);
  glVertex2f(20.828125f,6.968750f);
  glVertex2f(21.011250f,14.965625f);
  glVertex2f(21.041876f,7.805000f);
  glVertex2f(21.239374f,13.837500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(20.281250f,17.015625f);
  glVertex2f(19.772499f,17.955626f);
  glVertex2f(19.808125f,4.503750f);
  glVertex2f(20.104376f,5.080625f);
  glVertex2f(20.373125f,5.683750f);
  glVertex2f(20.691875f,16.025000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(18.685625f,2.846875f);
  glVertex2f(18.966875f,3.203125f);
  glVertex2f(19.183750f,18.800625f);
  glVertex2f(19.233126f,3.571875f);
  glVertex2f(19.772499f,17.955626f);
  glVertex2f(19.484375f,3.953125f);
  glVertex2f(19.808125f,4.503750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.514999f,19.550625f);
  glVertex2f(17.766251f,20.205626f);
  glVertex2f(17.878750f,15.042500f);
  glVertex2f(18.023438f,14.484375f);
  glVertex2f(18.138750f,13.900000f);
  glVertex2f(18.228437f,13.284375f);
  glVertex2f(18.292500f,12.637500f);
  glVertex2f(18.330938f,11.959375f);
  glVertex2f(18.343750f,11.250000f);
  glVertex2f(18.389376f,2.503125f);
  glVertex2f(18.685625f,2.846875f);
  glVertex2f(19.183750f,18.800625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.766251f,20.205626f);
  glVertex2f(16.937500f,20.765625f);
  glVertex2f(16.968750f,17.062500f);
  glVertex2f(17.245937f,16.589375f);
  glVertex2f(17.490000f,16.094999f);
  glVertex2f(17.700937f,15.579375f);
  glVertex2f(17.878750f,15.042500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.398750f,18.577499f);
  glVertex2f(15.865313f,18.261562f);
  glVertex2f(16.011250f,21.243750f);
  glVertex2f(16.282499f,17.903749f);
  glVertex2f(16.937500f,20.765625f);
  glVertex2f(16.650312f,17.504063f);
  glVertex2f(16.968750f,17.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.020000f,21.615625f);
  glVertex2f(13.963750f,21.881250f);
  glVertex2f(14.320000f,19.079374f);
  glVertex2f(14.882813f,18.851563f);
  glVertex2f(15.398750f,18.577499f);
  glVertex2f(16.011250f,21.243750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.656250f,22.093750f);
  glVertex2f(12.365313f,19.459063f);
  glVertex2f(12.842500f,22.040625f);
  glVertex2f(13.061250f,19.383125f);
  glVertex2f(13.963750f,21.881250f);
  glVertex2f(13.712812f,19.256563f);
  glVertex2f(14.320000f,19.079374f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.625000f,22.093750f);
  glVertex2f(10.433125f,22.040625f);
  glVertex2f(11.625000f,19.484375f);
  glVertex2f(12.365313f,19.459063f);
  glVertex2f(11.656250f,22.093750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.255000f,21.243750f);
  glVertex2f(7.315000f,18.166876f);
  glVertex2f(8.248125f,21.615625f);
  glVertex2f(9.200625f,19.155001f);
  glVertex2f(9.307500f,21.881250f);
  glVertex2f(11.625000f,19.484375f);
  glVertex2f(10.433125f,22.040625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.890625f,11.250000f);
  glVertex2f(5.160000f,14.214375f);
  glVertex2f(5.488125f,20.195938f);
  glVertex2f(5.968125f,16.520000f);
  glVertex2f(6.328125f,20.765625f);
  glVertex2f(7.315000f,18.166876f);
  glVertex2f(7.255000f,21.243750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.015625f,9.065000f);
  glVertex2f(4.960938f,9.589687f);
  glVertex2f(5.412500f,1.798125f);
  glVertex2f(4.921875f,10.128750f);
  glVertex2f(4.671875f,2.545625f);
  glVertex2f(4.898438f,10.682187f);
  glVertex2f(4.730625f,19.536875f);
  glVertex2f(4.890625f,11.250000f);
  glVertex2f(5.488125f,20.195938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.389376f,2.503125f);
  glVertex2f(18.343750f,11.250000f);
  glVertex2f(18.335938f,10.682813f);
  glVertex2f(18.312500f,10.131250f);
  glVertex2f(18.273438f,9.595312f);
  glVertex2f(18.218750f,9.075000f);
  glVertex2f(18.148438f,8.570313f);
  glVertex2f(18.078125f,2.171875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(18.078125f,2.171875f);
  glVertex2f(18.148438f,8.570313f);
  glVertex2f(18.059376f,8.075000f);
  glVertex2f(17.948437f,7.582813f);
  glVertex2f(17.815624f,7.093750f);
  glVertex2f(17.660938f,6.607812f);
  glVertex2f(17.578125f,0.062500f);
  glVertex2f(22.937500f,0.000000f);
  glVertex2f(18.495625f,2.279375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(22.937500f,0.000000f);
  glVertex2f(22.937500f,2.671875f);
  glVertex2f(22.705626f,2.683125f);
  glVertex2f(22.472500f,2.691875f);
  glVertex2f(22.238125f,2.698125f);
  glVertex2f(22.002501f,2.701875f);
  glVertex2f(21.765625f,2.703125f);
  glVertex2f(21.370625f,2.694375f);
  glVertex2f(20.935625f,2.668125f);
  glVertex2f(20.460625f,2.624375f);
  glVertex2f(19.945625f,2.563125f);
  glVertex2f(19.390625f,2.484375f);
  glVertex2f(19.283125f,2.466875f);
  glVertex2f(19.098125f,2.426875f);
  glVertex2f(18.835625f,2.364375f);
  glVertex2f(18.495625f,2.279375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.578125f,0.062500f);
  glVertex2f(17.660938f,6.607812f);
  glVertex2f(17.484375f,6.125000f);
  glVertex2f(17.285938f,5.658438f);
  glVertex2f(17.065624f,5.221250f);
  glVertex2f(16.823437f,4.813437f);
  glVertex2f(16.559376f,4.435000f);
  glVertex2f(16.273438f,4.085938f);
  glVertex2f(15.958750f,3.764688f);
  glVertex2f(15.875000f,-0.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.958750f,3.764688f);
  glVertex2f(15.608438f,3.469687f);
  glVertex2f(15.621250f,-0.031250f);
  glVertex2f(15.640625f,-0.031250f);
  glVertex2f(15.664375f,-0.031250f);
  glVertex2f(15.685625f,-0.031250f);
  glVertex2f(15.704375f,-0.031250f);
  glVertex2f(15.720625f,-0.031250f);
  glVertex2f(15.734375f,-0.031250f);
  glVertex2f(15.765625f,-0.031250f);
  glVertex2f(15.776875f,-0.031250f);
  glVertex2f(15.785625f,-0.031250f);
  glVertex2f(15.791875f,-0.031250f);
  glVertex2f(15.795625f,-0.031250f);
  glVertex2f(15.796875f,-0.031250f);
  glVertex2f(15.815000f,-0.031250f);
  glVertex2f(15.831875f,-0.031250f);
  glVertex2f(15.847500f,-0.031250f);
  glVertex2f(15.861875f,-0.031250f);
  glVertex2f(15.875000f,-0.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.608438f,3.469687f);
  glVertex2f(15.222500f,3.200938f);
  glVertex2f(15.289375f,-0.035000f);
  glVertex2f(15.531250f,-0.031250f);
  glVertex2f(15.555625f,-0.031250f);
  glVertex2f(15.578750f,-0.031250f);
  glVertex2f(15.600625f,-0.031250f);
  glVertex2f(15.621250f,-0.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.511250f,-0.091250f);
  glVertex2f(14.779375f,-0.065000f);
  glVertex2f(14.800938f,2.958437f);
  glVertex2f(15.038750f,-0.046250f);
  glVertex2f(15.222500f,3.200938f);
  glVertex2f(15.289375f,-0.035000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.343750f,2.742188f);
  glVertex2f(13.855312f,2.559375f);
  glVertex2f(13.917500f,-0.166250f);
  glVertex2f(14.039375f,-0.147500f);
  glVertex2f(14.145000f,-0.133750f);
  glVertex2f(14.234375f,-0.125000f);
  glVertex2f(14.511250f,-0.091250f);
  glVertex2f(14.800938f,2.958437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.855312f,2.559375f);
  glVertex2f(13.340000f,2.417187f);
  glVertex2f(13.469375f,-0.248125f);
  glVertex2f(13.625000f,-0.218750f);
  glVertex2f(13.779375f,-0.190000f);
  glVertex2f(13.917500f,-0.166250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.340000f,2.417187f);
  glVertex2f(12.797812f,2.315625f);
  glVertex2f(12.984375f,-0.328125f);
  glVertex2f(13.085000f,-0.313750f);
  glVertex2f(13.199375f,-0.295625f);
  glVertex2f(13.327500f,-0.273750f);
  glVertex2f(13.469375f,-0.248125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.939375f,-0.403125f);
  glVertex2f(12.195000f,-0.393750f);
  glVertex2f(12.228750f,2.254688f);
  glVertex2f(12.454375f,-0.378125f);
  glVertex2f(12.797812f,2.315625f);
  glVertex2f(12.717500f,-0.356250f);
  glVertex2f(12.984375f,-0.328125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.588125f,-0.406250f);
  glVertex2f(11.622500f,-0.406250f);
  glVertex2f(11.632813f,2.234375f);
  glVertex2f(11.655625f,-0.406250f);
  glVertex2f(12.228750f,2.254688f);
  glVertex2f(11.687500f,-0.406250f);
  glVertex2f(11.939375f,-0.403125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.632813f,2.234375f);
  glVertex2f(11.036875f,2.254688f);
  glVertex2f(11.515625f,-0.406250f);
  glVertex2f(11.552500f,-0.406250f);
  glVertex2f(11.588125f,-0.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.467813f,2.315625f);
  glVertex2f(9.925625f,2.417187f);
  glVertex2f(10.349375f,-0.344375f);
  glVertex2f(11.515625f,-0.406250f);
  glVertex2f(11.036875f,2.254688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.410313f,2.559375f);
  glVertex2f(8.921875f,2.742188f);
  glVertex2f(9.238125f,-0.158750f);
  glVertex2f(10.349375f,-0.344375f);
  glVertex2f(9.925625f,2.417187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.464375f,2.958437f);
  glVertex2f(8.041875f,3.200938f);
  glVertex2f(8.181875f,0.150625f);
  glVertex2f(9.238125f,-0.158750f);
  glVertex2f(8.921875f,2.742188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.041875f,3.200938f);
  glVertex2f(7.654375f,3.469687f);
  glVertex2f(8.181875f,0.150625f);
  glVertex2f(7.301875f,3.764688f);
  glVertex2f(7.180625f,0.583750f);
  glVertex2f(6.984375f,4.085938f);
  glVertex2f(6.695313f,4.434375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.428125f,4.810937f);
  glVertex2f(6.182813f,5.215625f);
  glVertex2f(6.234375f,1.140625f);
  glVertex2f(7.180625f,0.583750f);
  glVertex2f(6.695313f,4.434375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.234375f,1.140625f);
  glVertex2f(6.182813f,5.215625f);
  glVertex2f(5.959375f,5.648438f);
  glVertex2f(5.757813f,6.109375f);
  glVertex2f(5.578437f,6.587187f);
  glVertex2f(5.421563f,7.070625f);
  glVertex2f(5.412500f,1.798125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.412500f,1.798125f);
  glVertex2f(5.421563f,7.070625f);
  glVertex2f(5.287188f,7.559688f);
  glVertex2f(5.175313f,8.054375f);
  glVertex2f(5.085938f,8.554688f);
  glVertex2f(5.015625f,9.065000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.781250f,11.312500f);
  glVertex2f(1.827500f,10.003125f);
  glVertex2f(1.828125f,12.590938f);
  glVertex2f(1.966250f,8.750000f);
  glVertex2f(1.968750f,13.801250f);
  glVertex2f(2.197500f,7.553125f);
  glVertex2f(2.203125f,14.943438f);
  glVertex2f(2.521250f,6.412500f);
  glVertex2f(2.531250f,16.017500f);
  glVertex2f(2.937500f,5.328125f);
  glVertex2f(2.953125f,17.023438f);
  glVertex2f(3.434375f,4.310625f);
  glVertex2f(3.463125f,17.950624f);
  glVertex2f(4.012500f,3.383125f);
  glVertex2f(4.055625f,18.788437f);
  glVertex2f(4.671875f,2.545625f);
  glVertex2f(4.730625f,19.536875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.769375f,18.021875f);
  glVertex2f(16.383438f,18.929688f);
  glVertex2f(16.428125f,13.695625f);
  glVertex2f(15.843125f,19.690624f);
  glVertex2f(15.615624f,12.758125f);
  glVertex2f(15.148438f,20.304688f);
  glVertex2f(14.478125f,11.885625f);
  glVertex2f(14.295625f,20.791250f);
  glVertex2f(14.031250f,15.765625f);
  glVertex2f(13.981563f,16.447500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.789063f,18.312500f);
  glVertex2f(13.236250f,17.975624f);
  glVertex2f(13.280937f,21.169687f);
  glVertex2f(13.584063f,17.552500f);
  glVertex2f(14.295625f,20.791250f);
  glVertex2f(13.832500f,17.043125f);
  glVertex2f(13.981563f,16.447500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.890625f,18.929375f);
  glVertex2f(11.614062f,18.782499f);
  glVertex2f(12.104375f,21.440001f);
  glVertex2f(12.246875f,18.576876f);
  glVertex2f(13.280937f,21.169687f);
  glVertex2f(12.789063f,18.312500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(9.171875f,19.046875f);
  glVertex2f(9.265625f,21.656250f);
  glVertex2f(10.076563f,19.017500f);
  glVertex2f(10.765938f,21.602188f);
  glVertex2f(10.890625f,18.929375f);
  glVertex2f(12.104375f,21.440001f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(5.421875f,9.843750f);
  glVertex2f(5.421875f,12.453125f);
  glVertex2f(8.062500f,9.843750f);
  glVertex2f(9.171875f,12.453125f);
  glVertex2f(8.507813f,9.842500f);
  glVertex2f(8.906250f,9.838750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.915625f,14.698125f);
  glVertex2f(17.078125f,15.765625f);
  glVertex2f(17.000938f,16.967188f);
  glVertex2f(16.769375f,18.021875f);
  glVertex2f(16.428125f,13.695625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.478125f,11.885625f);
  glVertex2f(14.031250f,15.765625f);
  glVertex2f(13.981563f,15.088437f);
  glVertex2f(13.832500f,14.494375f);
  glVertex2f(13.584063f,13.983438f);
  glVertex2f(13.236250f,13.555625f);
  glVertex2f(13.015625f,11.078125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.015625f,11.078125f);
  glVertex2f(13.236250f,13.555625f);
  glVertex2f(12.789063f,13.210938f);
  glVertex2f(12.830937f,7.920938f);
  glVertex2f(12.935625f,7.666250f);
  glVertex2f(13.028438f,7.400938f);
  glVertex2f(13.113438f,11.063437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.789063f,13.210938f);
  glVertex2f(12.246875f,12.938125f);
  glVertex2f(12.328438f,8.803437f);
  glVertex2f(12.454375f,8.613750f);
  glVertex2f(12.585938f,8.398438f);
  glVertex2f(12.714375f,8.165000f);
  glVertex2f(12.830937f,7.920938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.246875f,12.938125f);
  glVertex2f(11.614062f,12.725938f);
  glVertex2f(11.709375f,9.403750f);
  glVertex2f(11.862500f,9.315000f);
  glVertex2f(11.984375f,9.218750f);
  glVertex2f(12.093437f,9.105938f);
  glVertex2f(12.208125f,8.967500f);
  glVertex2f(12.328438f,8.803437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.614062f,12.725938f);
  glVertex2f(10.890625f,12.574375f);
  glVertex2f(11.062500f,9.625000f);
  glVertex2f(11.309375f,9.558750f);
  glVertex2f(11.525000f,9.485000f);
  glVertex2f(11.709375f,9.403750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.890625f,12.574375f);
  glVertex2f(10.076563f,12.483438f);
  glVertex2f(10.300312f,9.767500f);
  glVertex2f(10.548750f,9.730000f);
  glVertex2f(10.802813f,9.682500f);
  glVertex2f(11.062500f,9.625000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.076563f,12.483438f);
  glVertex2f(9.171875f,12.453125f);
  glVertex2f(9.257813f,9.832500f);
  glVertex2f(9.562500f,9.823750f);
  glVertex2f(9.820313f,9.812500f);
  glVertex2f(10.057500f,9.795000f);
  glVertex2f(10.300312f,9.767500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.323126f,6.195625f);
  glVertex2f(16.181562f,7.123125f);
  glVertex2f(16.476563f,5.078125f);
  glVertex2f(16.051874f,7.860625f);
  glVertex2f(16.649376f,3.905000f);
  glVertex2f(15.934063f,8.408125f);
  glVertex2f(15.828125f,8.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.657187f,9.126562f);
  glVertex2f(15.456875f,9.459375f);
  glVertex2f(16.849062f,2.810625f);
  glVertex2f(16.649376f,3.905000f);
  glVertex2f(15.828125f,8.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.227187f,9.764063f);
  glVertex2f(14.968125f,10.040625f);
  glVertex2f(17.075624f,1.795000f);
  glVertex2f(16.849062f,2.810625f);
  glVertex2f(15.456875f,9.459375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.679688f,10.289063f);
  glVertex2f(14.393437f,10.503437f);
  glVertex2f(14.418125f,0.670000f);
  glVertex2f(14.562500f,0.000000f);
  glVertex2f(17.329063f,0.858125f);
  glVertex2f(17.075624f,1.795000f);
  glVertex2f(14.968125f,10.040625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.953125f,3.125000f);
  glVertex2f(14.052500f,2.545000f);
  glVertex2f(14.140938f,10.677813f);
  glVertex2f(14.163125f,1.942500f);
  glVertex2f(14.393437f,10.503437f);
  glVertex2f(14.285000f,1.317500f);
  glVertex2f(14.418125f,0.670000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.922188f,10.812187f);
  glVertex2f(13.737187f,10.906563f);
  glVertex2f(13.778125f,4.142500f);
  glVertex2f(13.862500f,3.663750f);
  glVertex2f(13.953125f,3.125000f);
  glVertex2f(14.140938f,10.677813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.459375f,5.680000f);
  glVertex2f(13.562500f,5.218750f);
  glVertex2f(13.585938f,10.960938f);
  glVertex2f(13.628125f,4.920000f);
  glVertex2f(13.737187f,10.906563f);
  glVertex2f(13.700000f,4.561250f);
  glVertex2f(13.778125f,4.142500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.028438f,7.400938f);
  glVertex2f(13.109375f,7.125000f);
  glVertex2f(13.113438f,11.063437f);
  glVertex2f(13.187500f,6.823750f);
  glVertex2f(13.219375f,11.044375f);
  glVertex2f(13.271875f,6.482500f);
  glVertex2f(13.333438f,11.020938f);
  glVertex2f(13.362500f,6.101250f);
  glVertex2f(13.455625f,10.993125f);
  glVertex2f(13.459375f,5.680000f);
  glVertex2f(13.585938f,10.960938f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(17.329063f,0.858125f);
  glVertex2f(14.562500f,0.000000f);
  glVertex2f(17.609375f,0.000000f);
  glVertex2f(9.171875f,12.453125f);
  glVertex2f(8.906250f,9.838750f);
  glVertex2f(9.257813f,9.832500f);
  glVertex2f(5.421875f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,0.000000f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(5.421875f,19.046875f);
  glVertex2f(9.265625f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(18.046875f,6.031250f);
  glVertex2f(18.018126f,6.727812f);
  glVertex2f(18.014687f,5.325937f);
  glVertex2f(17.931875f,7.380000f);
  glVertex2f(17.918125f,4.660000f);
  glVertex2f(17.788124f,7.987813f);
  glVertex2f(17.757187f,4.033437f);
  glVertex2f(17.586876f,8.551250f);
  glVertex2f(17.531876f,3.446250f);
  glVertex2f(17.328125f,9.070313f);
  glVertex2f(17.242188f,2.898438f);
  glVertex2f(17.024376f,9.541562f);
  glVertex2f(16.897499f,2.395625f);
  glVertex2f(16.688126f,9.961562f);
  glVertex2f(16.507187f,1.943437f);
  glVertex2f(16.319374f,10.330313f);
  glVertex2f(16.071249f,1.541875f);
  glVertex2f(15.918125f,10.647813f);
  glVertex2f(15.589687f,1.190938f);
  glVertex2f(15.484375f,10.914063f);
  glVertex2f(15.062500f,0.890625f);
  glVertex2f(15.031250f,5.796875f);
  glVertex2f(15.020625f,5.490938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.024375f,11.146563f);
  glVertex2f(14.544375f,11.362812f);
  glVertex2f(14.571250f,7.661875f);
  glVertex2f(14.772500f,7.258438f);
  glVertex2f(14.916250f,6.813125f);
  glVertex2f(15.002500f,6.325937f);
  glVertex2f(15.031250f,5.796875f);
  glVertex2f(15.484375f,10.914063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.672500f,8.627188f);
  glVertex2f(14.008750f,8.344687f);
  glVertex2f(14.044375f,11.562813f);
  glVertex2f(14.312500f,8.023438f);
  glVertex2f(14.544375f,11.362812f);
  glVertex2f(14.571250f,7.661875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.468750f,9.242188f);
  glVertex2f(12.902500f,9.075937f);
  glVertex2f(12.984375f,11.914063f);
  glVertex2f(13.303750f,8.870937f);
  glVertex2f(13.524375f,11.746563f);
  glVertex2f(13.672500f,8.627188f);
  glVertex2f(14.044375f,11.562813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.687500f,13.148438f);
  glVertex2f(7.733125f,10.243125f);
  glVertex2f(8.148438f,13.012188f);
  glVertex2f(8.287188f,10.127188f);
  glVertex2f(8.631250f,12.884687f);
  glVertex2f(8.841875f,10.019375f);
  glVertex2f(9.135938f,12.765938f);
  glVertex2f(9.397187f,9.919687f);
  glVertex2f(9.662500f,12.655937f);
  glVertex2f(9.953125f,9.828125f);
  glVertex2f(10.210938f,12.554688f);
  glVertex2f(10.498750f,9.734688f);
  glVertex2f(10.769375f,12.451563f);
  glVertex2f(11.023125f,9.629375f);
  glVertex2f(11.325937f,12.335938f);
  glVertex2f(11.526250f,9.512188f);
  glVertex2f(11.880625f,12.207812f);
  glVertex2f(12.008125f,9.383125f);
  glVertex2f(12.433437f,12.067187f);
  glVertex2f(12.468750f,9.242188f);
  glVertex2f(12.984375f,11.914063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.483750f,13.702500f);
  glVertex2f(6.636875f,10.505000f);
  glVertex2f(6.852500f,13.488438f);
  glVertex2f(7.179688f,10.367188f);
  glVertex2f(7.253750f,13.303750f);
  glVertex2f(7.733125f,10.243125f);
  glVertex2f(7.687500f,13.148438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.585000f,14.522500f);
  glVertex2f(5.613125f,10.838750f);
  glVertex2f(5.843750f,14.218750f);
  glVertex2f(6.114687f,10.662188f);
  glVertex2f(6.147500f,13.945937f);
  glVertex2f(6.636875f,10.505000f);
  glVertex2f(6.483750f,13.702500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.613125f,10.838750f);
  glVertex2f(5.585000f,14.522500f);
  glVertex2f(5.383750f,14.858750f);
  glVertex2f(5.240000f,15.227500f);
  glVertex2f(5.153750f,15.628750f);
  glVertex2f(5.132187f,11.034687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.836875f,11.806250f);
  glVertex2f(4.238125f,11.501562f);
  glVertex2f(4.270625f,20.354063f);
  glVertex2f(4.671875f,11.250000f);
  glVertex2f(4.833125f,20.768126f);
  glVertex2f(5.132187f,11.034687f);
  glVertex2f(5.125000f,16.062500f);
  glVertex2f(5.153750f,15.628750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.569375f,13.555625f);
  glVertex2f(2.828125f,13.039063f);
  glVertex2f(2.849375f,18.775625f);
  glVertex2f(3.131875f,12.575000f);
  glVertex2f(3.265625f,19.351563f);
  glVertex2f(3.468125f,12.164063f);
  glVertex2f(3.748125f,19.881874f);
  glVertex2f(3.836875f,11.806250f);
  glVertex2f(4.270625f,20.354063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.109375f,16.140625f);
  glVertex2f(2.138125f,15.416562f);
  glVertex2f(2.155625f,16.849062f);
  glVertex2f(2.224375f,14.744375f);
  glVertex2f(2.294375f,17.524376f);
  glVertex2f(2.368125f,14.124063f);
  glVertex2f(2.525625f,18.166563f);
  glVertex2f(2.569375f,13.555625f);
  glVertex2f(2.849375f,18.775625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.062500f,0.890625f);
  glVertex2f(15.020625f,5.490938f);
  glVertex2f(14.988750f,5.198125f);
  glVertex2f(14.935625f,4.918437f);
  glVertex2f(14.861250f,4.651875f);
  glVertex2f(14.765625f,4.398438f);
  glVertex2f(14.649688f,4.160937f);
  glVertex2f(14.514375f,3.942188f);
  glVertex2f(14.507500f,0.630938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.507500f,0.630938f);
  glVertex2f(14.514375f,3.942188f);
  glVertex2f(14.359688f,3.742188f);
  glVertex2f(14.185625f,3.560937f);
  glVertex2f(13.992188f,3.398438f);
  glVertex2f(13.942500f,0.401875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.992188f,3.398438f);
  glVertex2f(13.786250f,3.250625f);
  glVertex2f(13.942500f,0.401875f);
  glVertex2f(13.574688f,3.113437f);
  glVertex2f(13.367500f,0.203437f);
  glVertex2f(13.357500f,2.986875f);
  glVertex2f(13.134687f,2.870938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.906250f,2.765625f);
  glVertex2f(12.667812f,2.671562f);
  glVertex2f(12.782500f,0.035625f);
  glVertex2f(13.367500f,0.203437f);
  glVertex2f(13.134687f,2.870938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.415000f,2.589375f);
  glVertex2f(12.147813f,2.519063f);
  glVertex2f(12.187500f,-0.101563f);
  glVertex2f(12.782500f,0.035625f);
  glVertex2f(12.667812f,2.671562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.866250f,2.460625f);
  glVertex2f(11.570313f,2.414063f);
  glVertex2f(11.578750f,-0.211250f);
  glVertex2f(12.187500f,-0.101563f);
  glVertex2f(12.147813f,2.519063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.570313f,2.414063f);
  glVertex2f(11.273438f,2.375937f);
  glVertex2f(11.578750f,-0.211250f);
  glVertex2f(10.989062f,2.342813f);
  glVertex2f(10.952500f,-0.296562f);
  glVertex2f(10.717188f,2.314687f);
  glVertex2f(10.457812f,2.291563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.308750f,-0.357500f);
  glVertex2f(10.952500f,-0.296562f);
  glVertex2f(10.457812f,2.291563f);
  glVertex2f(10.210938f,2.273438f);
  glVertex2f(9.965000f,2.259375f);
  glVertex2f(9.708438f,2.248437f);
  glVertex2f(9.647500f,-0.394062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.708438f,2.248437f);
  glVertex2f(9.441250f,2.240625f);
  glVertex2f(9.647500f,-0.394062f);
  glVertex2f(9.163438f,2.235938f);
  glVertex2f(8.968750f,-0.406250f);
  glVertex2f(8.875000f,2.234375f);
  glVertex2f(8.199688f,2.283437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.746562f,-0.331250f);
  glVertex2f(8.968750f,-0.406250f);
  glVertex2f(8.199688f,2.283437f);
  glVertex2f(7.573750f,2.430625f);
  glVertex2f(6.997188f,2.675937f);
  glVertex2f(6.617500f,-0.106250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.617500f,-0.106250f);
  glVertex2f(6.997188f,2.675937f);
  glVertex2f(6.470000f,3.019375f);
  glVertex2f(5.992188f,3.460938f);
  glVertex2f(5.584375f,3.973125f);
  glVertex2f(5.581563f,0.268750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.581563f,0.268750f);
  glVertex2f(5.584375f,3.973125f);
  glVertex2f(5.267188f,4.528438f);
  glVertex2f(5.040625f,5.126875f);
  glVertex2f(4.904687f,5.768437f);
  glVertex2f(4.638750f,0.793750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.859375f,6.453125f);
  glVertex2f(1.781250f,6.453125f);
  glVertex2f(1.861562f,5.258750f);
  glVertex2f(2.102500f,4.163125f);
  glVertex2f(2.504062f,3.166250f);
  glVertex2f(3.066250f,2.268125f);
  glVertex2f(3.789063f,1.468750f);
  glVertex2f(4.638750f,0.793750f);
  glVertex2f(4.904687f,5.768437f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(17.203125f,16.203125f);
  glVertex2f(17.185312f,16.705626f);
  glVertex2f(17.131874f,17.188126f);
  glVertex2f(17.042812f,17.650625f);
  glVertex2f(16.918125f,18.093124f);
  glVertex2f(16.757813f,18.515625f);
  glVertex2f(16.568438f,18.913124f);
  glVertex2f(16.356562f,19.280624f);
  glVertex2f(16.122187f,19.618126f);
  glVertex2f(15.865313f,19.925625f);
  glVertex2f(15.585938f,20.203125f);
  glVertex2f(15.284375f,20.456875f);
  glVertex2f(14.960938f,20.693125f);
  glVertex2f(14.615625f,20.911875f);
  glVertex2f(14.248438f,21.113125f);
  glVertex2f(14.156250f,16.203125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.248438f,21.113125f);
  glVertex2f(13.859375f,21.296875f);
  glVertex2f(13.901250f,17.653126f);
  glVertex2f(14.012813f,17.332813f);
  glVertex2f(14.092500f,16.984375f);
  glVertex2f(14.140312f,16.607813f);
  glVertex2f(14.156250f,16.203125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.150312f,18.644688f);
  glVertex2f(13.381562f,18.441563f);
  glVertex2f(13.455937f,21.461563f);
  glVertex2f(13.584063f,18.208437f);
  glVertex2f(13.859375f,21.296875f);
  glVertex2f(13.757813f,17.945313f);
  glVertex2f(13.901250f,17.653126f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.298125f,19.080313f);
  glVertex2f(12.601563f,18.960938f);
  glVertex2f(12.628437f,21.729063f);
  glVertex2f(12.890312f,18.817812f);
  glVertex2f(13.045625f,21.605625f);
  glVertex2f(13.150312f,18.644688f);
  glVertex2f(13.455937f,21.461563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.384063f,19.333437f);
  glVertex2f(11.689375f,19.266563f);
  glVertex2f(11.773438f,21.914063f);
  glVertex2f(11.994062f,19.182188f);
  glVertex2f(12.204375f,21.831875f);
  glVertex2f(12.298125f,19.080313f);
  glVertex2f(12.628437f,21.729063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.063750f,19.468124f);
  glVertex2f(10.423125f,19.447813f);
  glVertex2f(10.433750f,22.065001f);
  glVertex2f(10.761250f,19.419374f);
  glVertex2f(10.888437f,22.029062f);
  glVertex2f(11.078125f,19.382813f);
  glVertex2f(11.335000f,21.978750f);
  glVertex2f(11.384063f,19.333437f);
  glVertex2f(11.773438f,21.914063f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.798125f,22.066875f);
  glVertex2f(9.281250f,19.484375f);
  glVertex2f(9.500000f,22.093750f);
  glVertex2f(9.683125f,19.480312f);
  glVertex2f(9.970938f,22.086563f);
  glVertex2f(10.063750f,19.468124f);
  glVertex2f(10.433750f,22.065001f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.105000f,21.986250f);
  glVertex2f(7.420625f,21.851875f);
  glVertex2f(7.785000f,19.347500f);
  glVertex2f(9.281250f,19.484375f);
  glVertex2f(8.798125f,22.066875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.125000f,16.062500f);
  glVertex2f(5.291250f,17.294374f);
  glVertex2f(5.435625f,21.124062f);
  glVertex2f(5.790000f,18.252501f);
  glVertex2f(6.078125f,21.421875f);
  glVertex2f(6.621250f,18.936874f);
  glVertex2f(6.745000f,21.663750f);
  glVertex2f(7.785000f,19.347500f);
  glVertex2f(7.420625f,21.851875f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(5.125000f,16.062500f);
  glVertex2f(5.435625f,21.124062f);
  glVertex2f(4.833125f,20.768126f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.671875f,0.000000f);
  glVertex2f(10.718750f,0.000000f);
  glVertex2f(7.671875f,19.046875f);
  glVertex2f(10.718750f,19.046875f);
  glVertex2f(17.781250f,21.656250f);
  glVertex2f(17.781250f,19.046875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(0.593750f,21.656250f);
  glVertex2f(0.593750f,19.046875f);
  glVertex2f(7.671875f,19.046875f);
  glVertex2f(17.781250f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.421875f,21.656250f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.487500f,7.626875f);
  glVertex2f(2.731250f,5.829375f);
  glVertex2f(3.137500f,4.279375f);
  glVertex2f(3.706250f,2.976875f);
  glVertex2f(4.437500f,1.921875f);
  glVertex2f(5.351563f,1.083750f);
  glVertex2f(5.421875f,9.671875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(19.718750f,21.656250f);
  glVertex2f(16.671875f,21.656250f);
  glVertex2f(16.741562f,1.093750f);
  glVertex2f(17.664063f,1.937500f);
  glVertex2f(18.403749f,2.996875f);
  glVertex2f(18.979063f,4.300000f);
  glVertex2f(19.389999f,5.846875f);
  glVertex2f(19.636562f,7.637500f);
  glVertex2f(19.718750f,9.671875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.741562f,1.093750f);
  glVertex2f(16.671875f,21.656250f);
  glVertex2f(16.671875f,9.671875f);
  glVertex2f(16.659687f,8.930625f);
  glVertex2f(16.623125f,8.231875f);
  glVertex2f(16.562187f,7.575625f);
  glVertex2f(16.476875f,6.961875f);
  glVertex2f(16.367188f,6.390625f);
  glVertex2f(16.237499f,5.863750f);
  glVertex2f(16.092188f,5.383125f);
  glVertex2f(15.931250f,4.948750f);
  glVertex2f(15.754687f,4.560625f);
  glVertex2f(15.617812f,0.437500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.617812f,0.437500f);
  glVertex2f(15.754687f,4.560625f);
  glVertex2f(15.562500f,4.218750f);
  glVertex2f(15.351250f,3.913125f);
  glVertex2f(15.117500f,3.633750f);
  glVertex2f(14.861250f,3.380625f);
  glVertex2f(14.582500f,3.153750f);
  glVertex2f(14.292812f,-0.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.292812f,-0.031250f);
  glVertex2f(14.582500f,3.153750f);
  glVertex2f(14.281250f,2.953125f);
  glVertex2f(13.970938f,2.779375f);
  glVertex2f(13.665000f,2.633125f);
  glVertex2f(13.363438f,2.514375f);
  glVertex2f(13.066250f,2.423125f);
  glVertex2f(12.773438f,2.359375f);
  glVertex2f(12.766562f,-0.312500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.766562f,-0.312500f);
  glVertex2f(12.773438f,2.359375f);
  glVertex2f(12.471875f,2.314375f);
  glVertex2f(12.148438f,2.279375f);
  glVertex2f(11.803125f,2.254375f);
  glVertex2f(11.435938f,2.239375f);
  glVertex2f(11.046875f,2.234375f);
  glVertex2f(11.039063f,-0.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.039063f,-0.406250f);
  glVertex2f(11.046875f,2.234375f);
  glVertex2f(10.555000f,2.244688f);
  glVertex2f(10.091875f,2.275625f);
  glVertex2f(9.657500f,2.327188f);
  glVertex2f(9.312500f,-0.313125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.312500f,-0.313125f);
  glVertex2f(9.657500f,2.327188f);
  glVertex2f(9.251875f,2.399375f);
  glVertex2f(8.875000f,2.492188f);
  glVertex2f(8.515312f,2.614375f);
  glVertex2f(8.161250f,2.774688f);
  glVertex2f(7.812812f,2.973125f);
  glVertex2f(7.789063f,-0.033750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.789063f,-0.033750f);
  glVertex2f(7.812812f,2.973125f);
  glVertex2f(7.470000f,3.209687f);
  glVertex2f(7.132813f,3.484375f);
  glVertex2f(6.814375f,3.810937f);
  glVertex2f(6.527812f,4.203125f);
  glVertex2f(6.468750f,0.431875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.468750f,0.431875f);
  glVertex2f(6.527812f,4.203125f);
  glVertex2f(6.273125f,4.660937f);
  glVertex2f(6.050313f,5.184375f);
  glVertex2f(5.859375f,5.773438f);
  glVertex2f(5.701875f,6.426875f);
  glVertex2f(5.579375f,7.143437f);
  glVertex2f(5.351563f,1.083750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.351563f,1.083750f);
  glVertex2f(5.579375f,7.143437f);
  glVertex2f(5.491875f,7.923125f);
  glVertex2f(5.439375f,8.765938f);
  glVertex2f(5.421875f,9.671875f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(2.487500f,7.626875f);
  glVertex2f(2.406250f,21.656250f);
  glVertex2f(2.406250f,9.671875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(19.156250f,21.656250f);
  glVertex2f(15.796875f,21.656250f);
  glVertex2f(11.453125f,0.000000f);
  glVertex2f(9.812500f,3.890625f);
  glVertex2f(8.171875f,0.000000f);
  glVertex2f(3.843750f,21.656250f);
  glVertex2f(0.437500f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(28.718750f,21.656250f);
  glVertex2f(25.515625f,21.656250f);
  glVertex2f(22.296875f,0.000000f);
  glVertex2f(20.953125f,4.515625f);
  glVertex2f(19.593750f,0.000000f);
  glVertex2f(16.375000f,21.656250f);
  glVertex2f(14.593750f,18.046875f);
  glVertex2f(12.781250f,21.656250f);
  glVertex2f(9.578125f,0.000000f);
  glVertex2f(8.234375f,4.515625f);
  glVertex2f(6.859375f,0.000000f);
  glVertex2f(3.640625f,21.656250f);
  glVertex2f(0.437500f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(0.765625f,0.000000f);
  glVertex2f(4.281250f,0.000000f);
  glVertex2f(8.703125f,11.546875f);
  glVertex2f(10.343750f,9.437500f);
  glVertex2f(10.781250f,13.687500f);
  glVertex2f(16.531250f,0.000000f);
  glVertex2f(12.390625f,11.546875f);
  glVertex2f(20.359375f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.593750f,21.656250f);
  glVertex2f(1.765625f,21.656250f);
  glVertex2f(8.703125f,11.546875f);
  glVertex2f(10.781250f,13.687500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.796875f,21.656250f);
  glVertex2f(10.781250f,13.687500f);
  glVertex2f(12.390625f,11.546875f);
  glVertex2f(19.312500f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.468750f,8.609375f);
  glVertex2f(8.468750f,0.000000f);
  glVertex2f(11.484375f,0.000000f);
  glVertex2f(10.171875f,11.250000f);
  glVertex2f(4.125000f,21.656250f);
  glVertex2f(0.437500f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.484375f,8.609375f);
  glVertex2f(19.546875f,21.656250f);
  glVertex2f(16.109375f,21.656250f);
  glVertex2f(10.171875f,11.250000f);
  glVertex2f(11.484375f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.656250f,2.609375f);
  glVertex2f(16.812500f,18.375000f);
  glVertex2f(13.531250f,19.046875f);
  glVertex2f(1.343750f,3.312500f);
  glVertex2f(1.343750f,0.000000f);
  glVertex2f(17.140625f,0.000000f);
  glVertex2f(17.140625f,2.609375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.531250f,19.046875f);
  glVertex2f(16.812500f,18.375000f);
  glVertex2f(16.812500f,21.656250f);
  glVertex2f(1.968750f,21.656250f);
  glVertex2f(1.968750f,19.046875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.765625f,-4.421875f);
  glVertex2f(5.765625f,20.125000f);
  glVertex2f(3.187500f,21.656250f);
  glVertex2f(3.187500f,-5.953125f);
  glVertex2f(8.765625f,-5.953125f);
  glVertex2f(8.765625f,-4.421875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.765625f,21.656250f);
  glVertex2f(3.187500f,21.656250f);
  glVertex2f(5.765625f,20.125000f);
  glVertex2f(8.765625f,20.125000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.515625f,-1.546875f);
  glVertex2f(3.453125f,22.093750f);
  glVertex2f(1.375000f,22.093750f);
  glVertex2f(8.468750f,-1.546875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.156250f,20.125000f);
  glVertex2f(6.156250f,-4.421875f);
  glVertex2f(8.765625f,-5.953125f);
  glVertex2f(8.765625f,21.656250f);
  glVertex2f(3.187500f,21.656250f);
  glVertex2f(3.187500f,20.125000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.187500f,-4.421875f);
  glVertex2f(3.187500f,-5.953125f);
  glVertex2f(8.765625f,-5.953125f);
  glVertex2f(6.156250f,-4.421875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.171875f,0.296875f);
  glVertex2f(9.031250f,0.296875f);
  glVertex2f(14.062500f,18.312500f);
  glVertex2f(15.000000f,16.375000f);
  glVertex2f(15.937500f,18.312500f);
  glVertex2f(20.984375f,0.296875f);
  glVertex2f(22.828125f,0.296875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.000000f,-3.875000f);
  glVertex2f(15.000000f,-2.234375f);
  glVertex2f(0.000000f,-2.234375f);
  glVertex2f(0.000000f,-3.875000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.281250f,17.984375f);
  glVertex2f(2.281250f,23.140625f);
  glVertex2f(-0.765625f,23.140625f);
  glVertex2f(3.453125f,17.984375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.625000f,7.390625f);
  glVertex2f(11.588750f,6.334688f);
  glVertex2f(11.781250f,2.203125f);
  glVertex2f(11.656250f,9.437500f);
  glVertex2f(11.505625f,9.438750f);
  glVertex2f(11.328750f,9.442500f);
  glVertex2f(11.125625f,9.448750f);
  glVertex2f(11.088125f,7.418750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.896250f,9.457500f);
  glVertex2f(10.640625f,9.468750f);
  glVertex2f(10.665000f,7.440625f);
  glVertex2f(11.088125f,7.418750f);
  glVertex2f(11.125625f,9.448750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.384375f,9.480000f);
  glVertex2f(10.153125f,9.488750f);
  glVertex2f(10.160000f,7.465625f);
  glVertex2f(10.355625f,7.456250f);
  glVertex2f(10.665000f,7.440625f);
  glVertex2f(10.640625f,9.468750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.078125f,7.468750f);
  glVertex2f(10.160000f,7.465625f);
  glVertex2f(10.153125f,9.488750f);
  glVertex2f(9.946875f,9.495000f);
  glVertex2f(9.765625f,9.498750f);
  glVertex2f(9.739062f,7.463438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.703125f,7.383750f);
  glVertex2f(9.051562f,7.420938f);
  glVertex2f(9.145312f,9.494687f);
  glVertex2f(9.396875f,7.447500f);
  glVertex2f(9.609375f,9.500000f);
  glVertex2f(9.739062f,7.463438f);
  glVertex2f(9.765625f,9.498750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.742813f,6.595938f);
  glVertex2f(6.094687f,6.761875f);
  glVertex2f(6.097500f,9.117812f);
  glVertex2f(6.476563f,6.898438f);
  glVertex2f(6.530313f,9.220938f);
  glVertex2f(6.869062f,7.013437f);
  glVertex2f(6.958750f,9.304063f);
  glVertex2f(7.252812f,7.114687f);
  glVertex2f(7.382813f,9.367188f);
  glVertex2f(7.627812f,7.202188f);
  glVertex2f(7.809375f,9.415000f);
  glVertex2f(7.994062f,7.275938f);
  glVertex2f(8.245313f,9.452188f);
  glVertex2f(8.351563f,7.335938f);
  glVertex2f(8.690625f,9.478750f);
  glVertex2f(8.703125f,7.383750f);
  glVertex2f(9.145312f,9.494687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.867188f,5.921875f);
  glVertex2f(5.129063f,6.175938f);
  glVertex2f(5.218750f,8.851563f);
  glVertex2f(5.420938f,6.400625f);
  glVertex2f(5.660313f,8.994687f);
  glVertex2f(5.742813f,6.595938f);
  glVertex2f(6.097500f,9.117812f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.786875f,8.689688f);
  glVertex2f(4.378750f,8.510312f);
  glVertex2f(4.472188f,5.341875f);
  glVertex2f(4.645000f,5.642500f);
  glVertex2f(4.867188f,5.921875f);
  glVertex2f(5.218750f,8.851563f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.378750f,8.510312f);
  glVertex2f(3.994375f,8.313437f);
  glVertex2f(3.998125f,0.365000f);
  glVertex2f(4.250000f,4.312500f);
  glVertex2f(4.274687f,4.676875f);
  glVertex2f(4.348750f,5.020000f);
  glVertex2f(4.472188f,5.341875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.994375f,8.313437f);
  glVertex2f(3.633750f,8.099063f);
  glVertex2f(3.998125f,0.365000f);
  glVertex2f(3.296875f,7.867188f);
  glVertex2f(3.265625f,0.781250f);
  glVertex2f(2.984062f,7.610938f);
  glVertex2f(2.695625f,7.323438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.618750f,1.278125f);
  glVertex2f(3.265625f,0.781250f);
  glVertex2f(2.695625f,7.323438f);
  glVertex2f(2.431562f,7.004687f);
  glVertex2f(2.191875f,6.654687f);
  glVertex2f(2.115625f,1.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.191875f,6.654687f);
  glVertex2f(1.976563f,6.273438f);
  glVertex2f(2.115625f,1.843750f);
  glVertex2f(1.793750f,5.863125f);
  glVertex2f(1.756250f,2.478125f);
  glVertex2f(1.651563f,5.425938f);
  glVertex2f(1.550000f,4.961875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.540625f,3.181250f);
  glVertex2f(1.756250f,2.478125f);
  glVertex2f(1.550000f,4.961875f);
  glVertex2f(1.489063f,4.470938f);
  glVertex2f(1.468750f,3.953125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.437500f,8.093750f);
  glVertex2f(14.423750f,9.538125f);
  glVertex2f(14.437500f,5.484375f);
  glVertex2f(14.382500f,10.733750f);
  glVertex2f(14.453125f,3.865000f);
  glVertex2f(14.313750f,11.680625f);
  glVertex2f(14.217500f,12.378750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.125000f,0.000000f);
  glVertex2f(14.687500f,0.574375f);
  glVertex2f(12.691250f,14.458125f);
  glVertex2f(14.578125f,1.410000f);
  glVertex2f(13.543125f,13.745000f);
  glVertex2f(14.500000f,2.506875f);
  glVertex2f(14.093750f,12.828125f);
  glVertex2f(14.453125f,3.865000f);
  glVertex2f(14.217500f,12.378750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.691250f,14.458125f);
  glVertex2f(11.538125f,14.967500f);
  glVertex2f(11.689062f,11.283438f);
  glVertex2f(11.775000f,10.716250f);
  glVertex2f(11.781250f,2.203125f);
  glVertex2f(11.805000f,1.955000f);
  glVertex2f(11.851250f,1.610625f);
  glVertex2f(11.920000f,1.170000f);
  glVertex2f(12.011250f,0.633125f);
  glVertex2f(12.125000f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.538125f,14.967500f);
  glVertex2f(10.083750f,15.273125f);
  glVertex2f(10.386562f,12.988438f);
  glVertex2f(10.852500f,12.675625f);
  glVertex2f(11.226563f,12.273438f);
  glVertex2f(11.506250f,11.802500f);
  glVertex2f(11.689062f,11.283438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.083750f,15.273125f);
  glVertex2f(8.328125f,15.375000f);
  glVertex2f(8.437500f,13.390625f);
  glVertex2f(9.179063f,13.345938f);
  glVertex2f(9.828750f,13.211875f);
  glVertex2f(10.386562f,12.988438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.328125f,15.375000f);
  glVertex2f(6.151250f,15.198125f);
  glVertex2f(6.477500f,13.015625f);
  glVertex2f(6.922500f,13.179688f);
  glVertex2f(7.397500f,13.296875f);
  glVertex2f(7.902500f,13.367188f);
  glVertex2f(8.437500f,13.390625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.151250f,15.198125f);
  glVertex2f(4.458125f,14.667500f);
  glVertex2f(5.102500f,11.432187f);
  glVertex2f(5.222500f,11.856875f);
  glVertex2f(5.422500f,12.227187f);
  glVertex2f(5.702500f,12.543125f);
  glVertex2f(6.062500f,12.804688f);
  glVertex2f(6.477500f,13.015625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.062500f,10.953125f);
  glVertex2f(5.102500f,11.432187f);
  glVertex2f(4.458125f,14.667500f);
  glVertex2f(3.248750f,13.783125f);
  glVertex2f(2.523125f,12.545000f);
  glVertex2f(2.281250f,10.953125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.764063f,10.100938f);
  glVertex2f(11.656250f,9.437500f);
  glVertex2f(11.781250f,2.203125f);
  glVertex2f(11.775000f,10.716250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.486875f,1.858438f);
  glVertex2f(11.781250f,2.203125f);
  glVertex2f(11.588750f,6.334688f);
  glVertex2f(11.480000f,5.379375f);
  glVertex2f(11.298750f,4.524687f);
  glVertex2f(11.216250f,1.549375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.045000f,3.770625f);
  glVertex2f(10.718750f,3.117188f);
  glVertex2f(10.746250f,1.038125f);
  glVertex2f(10.969375f,1.275937f);
  glVertex2f(11.216250f,1.549375f);
  glVertex2f(11.298750f,4.524687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.838125f,0.313750f);
  glVertex2f(10.106875f,0.480937f);
  glVertex2f(10.289375f,2.574375f);
  glVertex2f(10.343125f,0.655000f);
  glVertex2f(10.718750f,3.117188f);
  glVertex2f(10.546875f,0.835938f);
  glVertex2f(10.746250f,1.038125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.726250f,2.152188f);
  glVertex2f(9.029375f,1.850625f);
  glVertex2f(9.203125f,0.000000f);
  glVertex2f(9.536875f,0.153437f);
  glVertex2f(9.838125f,0.313750f);
  glVertex2f(10.289375f,2.574375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.643125f,-0.360000f);
  glVertex2f(8.063125f,-0.315000f);
  glVertex2f(8.198750f,1.669688f);
  glVertex2f(8.463125f,-0.240000f);
  glVertex2f(9.029375f,1.850625f);
  glVertex2f(8.843125f,-0.135000f);
  glVertex2f(9.203125f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.304375f,1.726875f);
  glVertex2f(6.360625f,-0.328750f);
  glVertex2f(6.755000f,1.638750f);
  glVertex2f(7.203125f,-0.375000f);
  glVertex2f(7.234375f,1.609375f);
  glVertex2f(7.643125f,-0.360000f);
  glVertex2f(8.198750f,1.669688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.882500f,1.873750f);
  glVertex2f(5.489375f,2.079375f);
  glVertex2f(5.545625f,-0.190000f);
  glVertex2f(6.360625f,-0.328750f);
  glVertex2f(6.304375f,1.726875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.489375f,2.079375f);
  glVertex2f(5.125000f,2.343750f);
  glVertex2f(5.545625f,-0.190000f);
  glVertex2f(4.810000f,2.657500f);
  glVertex2f(4.758125f,0.041250f);
  glVertex2f(4.565000f,3.011250f);
  glVertex2f(4.390000f,3.405000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.285000f,3.838750f);
  glVertex2f(4.250000f,4.312500f);
  glVertex2f(3.998125f,0.365000f);
  glVertex2f(4.758125f,0.041250f);
  glVertex2f(4.390000f,3.405000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(14.687500f,0.574375f);
  glVertex2f(12.125000f,0.000000f);
  glVertex2f(14.828125f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.109375f,21.656250f);
  glVertex2f(2.109375f,0.000000f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(4.750000f,7.859375f);
  glVertex2f(4.718750f,12.921875f);
  glVertex2f(4.718750f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.370000f,14.340625f);
  glVertex2f(12.867188f,14.648438f);
  glVertex2f(12.959687f,10.542500f);
  glVertex2f(13.164375f,9.714375f);
  glVertex2f(13.287188f,8.820000f);
  glVertex2f(13.328125f,7.859375f);
  glVertex2f(13.470000f,1.095000f);
  glVertex2f(13.822187f,13.998438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.849375f,12.596250f);
  glVertex2f(12.304688f,12.000000f);
  glVertex2f(12.321250f,14.910000f);
  glVertex2f(12.673125f,11.304375f);
  glVertex2f(12.867188f,14.648438f);
  glVertex2f(12.959687f,10.542500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.579375f,13.381250f);
  glVertex2f(8.305000f,13.587500f);
  glVertex2f(8.463750f,15.276875f);
  glVertex2f(9.109375f,13.656250f);
  glVertex2f(9.781250f,15.375000f);
  glVertex2f(9.932187f,13.590000f);
  glVertex2f(10.469687f,15.345938f);
  glVertex2f(10.663125f,13.391250f);
  glVertex2f(11.122500f,15.258750f);
  glVertex2f(11.302188f,13.060000f);
  glVertex2f(11.739688f,15.113438f);
  glVertex2f(11.849375f,12.596250f);
  glVertex2f(12.321250f,14.910000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.298750f,14.982500f);
  glVertex2f(6.286250f,14.491875f);
  glVertex2f(6.364375f,12.556250f);
  glVertex2f(6.932500f,13.037500f);
  glVertex2f(7.579375f,13.381250f);
  glVertex2f(8.463750f,15.276875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.930000f,9.644375f);
  glVertex2f(5.155000f,10.460000f);
  glVertex2f(5.426250f,13.805000f);
  glVertex2f(5.470000f,11.224375f);
  glVertex2f(6.286250f,14.491875f);
  glVertex2f(5.875000f,11.937500f);
  glVertex2f(6.364375f,12.556250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.795000f,8.777500f);
  glVertex2f(4.930000f,9.644375f);
  glVertex2f(5.426250f,13.805000f);
  glVertex2f(4.718750f,12.921875f);
  glVertex2f(4.750000f,7.859375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.151875f,9.056875f);
  glVertex2f(16.087812f,9.517813f);
  glVertex2f(16.125626f,6.636875f);
  glVertex2f(16.203125f,8.140625f);
  glVertex2f(16.190313f,8.597813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.998125f,9.980625f);
  glVertex2f(15.882813f,10.445313f);
  glVertex2f(15.893125f,5.263125f);
  glVertex2f(16.125626f,6.636875f);
  glVertex2f(16.087812f,9.517813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.882813f,10.445313f);
  glVertex2f(15.740000f,10.910625f);
  glVertex2f(15.893125f,5.263125f);
  glVertex2f(15.567813f,11.375313f);
  glVertex2f(15.505625f,4.019375f);
  glVertex2f(15.366250f,11.839375f);
  glVertex2f(15.135312f,12.302813f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.963125f,2.905625f);
  glVertex2f(15.505625f,4.019375f);
  glVertex2f(15.135312f,12.302813f);
  glVertex2f(14.875000f,12.765625f);
  glVertex2f(14.574688f,13.210938f);
  glVertex2f(14.265625f,1.921875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.265625f,1.921875f);
  glVertex2f(14.574688f,13.210938f);
  glVertex2f(14.223750f,13.621875f);
  glVertex2f(13.822187f,13.998438f);
  glVertex2f(13.470000f,1.095000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.470000f,1.095000f);
  glVertex2f(13.328125f,7.859375f);
  glVertex2f(13.279062f,6.767500f);
  glVertex2f(13.131875f,5.766875f);
  glVertex2f(12.886562f,4.857500f);
  glVertex2f(12.633125f,0.451875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.886562f,4.857500f);
  glVertex2f(12.543125f,4.039375f);
  glVertex2f(12.633125f,0.451875f);
  glVertex2f(12.101563f,3.312500f);
  glVertex2f(11.755000f,-0.007500f);
  glVertex2f(11.586250f,2.699375f);
  glVertex2f(11.021563f,2.222500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.235312f,-0.180937f);
  glVertex2f(8.771250f,-0.288750f);
  glVertex2f(9.031250f,1.609375f);
  glVertex2f(9.317813f,-0.353438f);
  glVertex2f(9.744062f,1.677500f);
  glVertex2f(9.875000f,-0.375000f);
  glVertex2f(10.407500f,1.881875f);
  glVertex2f(10.835625f,-0.283125f);
  glVertex2f(11.021563f,2.222500f);
  glVertex2f(11.755000f,-0.007500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.714375f,0.379375f);
  glVertex2f(7.195313f,0.164063f);
  glVertex2f(7.490000f,1.859375f);
  glVertex2f(7.710000f,-0.030000f);
  glVertex2f(9.031250f,1.609375f);
  glVertex2f(8.235312f,-0.180937f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.291250f,2.609375f);
  glVertex2f(5.435000f,3.859375f);
  glVertex2f(5.612813f,1.021562f);
  glVertex2f(5.923125f,0.808125f);
  glVertex2f(6.290312f,0.594063f);
  glVertex2f(6.714375f,0.379375f);
  glVertex2f(7.490000f,1.859375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.612813f,1.021562f);
  glVertex2f(5.435000f,3.859375f);
  glVertex2f(5.359375f,1.234375f);
  glVertex2f(4.921250f,5.609375f);
  glVertex2f(4.812500f,1.765625f);
  glVertex2f(4.750000f,7.859375f);
  glVertex2f(4.812500f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.999375f,14.485000f);
  glVertex2f(11.172500f,14.874375f);
  glVertex2f(11.289063f,11.471875f);
  glVertex2f(11.356250f,11.106250f);
  glVertex2f(11.364062f,10.709375f);
  glVertex2f(13.968750f,10.281250f);
  glVertex2f(12.687500f,13.984375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.172500f,14.874375f);
  glVertex2f(10.206875f,15.152500f);
  glVertex2f(10.217188f,12.808750f);
  glVertex2f(10.495313f,12.611875f);
  glVertex2f(10.748438f,12.378750f);
  glVertex2f(10.976563f,12.109375f);
  glVertex2f(11.162500f,11.806250f);
  glVertex2f(11.289063f,11.471875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.206875f,15.152500f);
  glVertex2f(9.102500f,15.319375f);
  glVertex2f(9.235625f,13.189375f);
  glVertex2f(9.585938f,13.093750f);
  glVertex2f(9.914063f,12.969375f);
  glVertex2f(10.217188f,12.808750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.102500f,15.319375f);
  glVertex2f(7.859375f,15.375000f);
  glVertex2f(8.068438f,13.348750f);
  glVertex2f(8.476875f,13.316875f);
  glVertex2f(8.865937f,13.263750f);
  glVertex2f(9.235625f,13.189375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.977500f,12.853125f);
  glVertex2f(6.480625f,13.134375f);
  glVertex2f(6.605937f,15.297188f);
  glVertex2f(7.035000f,13.303125f);
  glVertex2f(7.859375f,15.375000f);
  glVertex2f(7.640625f,13.359375f);
  glVertex2f(8.068438f,13.348750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.787500f,11.325000f);
  glVertex2f(5.125000f,11.953125f);
  glVertex2f(5.495625f,15.063750f);
  glVertex2f(5.525625f,12.459375f);
  glVertex2f(6.605937f,15.297188f);
  glVertex2f(5.977500f,12.853125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.528438f,14.674687f);
  glVertex2f(3.704375f,14.130000f);
  glVertex2f(4.225000f,8.653125f);
  glVertex2f(4.337500f,9.675000f);
  glVertex2f(4.525000f,10.565625f);
  glVertex2f(4.787500f,11.325000f);
  glVertex2f(5.495625f,15.063750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.890625f,0.885000f);
  glVertex2f(5.750000f,-0.060000f);
  glVertex2f(4.547500f,4.393125f);
  glVertex2f(4.347500f,5.290000f);
  glVertex2f(4.227500f,6.325625f);
  glVertex2f(4.187500f,7.500000f);
  glVertex2f(4.225000f,8.653125f);
  glVertex2f(3.704375f,14.130000f);
  glVertex2f(3.023438f,13.429688f);
  glVertex2f(2.562500f,2.460000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.023438f,13.429688f);
  glVertex2f(2.475000f,12.570000f);
  glVertex2f(2.562500f,2.460000f);
  glVertex2f(2.048438f,11.547188f);
  glVertex2f(1.765625f,4.665000f);
  glVertex2f(1.743750f,10.361250f);
  glVertex2f(1.560938f,9.012188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.968750f,10.281250f);
  glVertex2f(14.002500f,11.169375f);
  glVertex2f(13.891250f,11.983750f);
  glVertex2f(13.635000f,12.724375f);
  glVertex2f(13.233750f,13.391250f);
  glVertex2f(12.687500f,13.984375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.125000f,5.062500f);
  glVertex2f(11.453125f,5.062500f);
  glVertex2f(12.045625f,0.615000f);
  glVertex2f(12.687500f,1.171875f);
  glVertex2f(13.205000f,1.822500f);
  glVertex2f(13.607500f,2.536875f);
  glVertex2f(13.895000f,3.315000f);
  glVertex2f(14.067500f,4.156875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.453125f,5.062500f);
  glVertex2f(11.422188f,4.558437f);
  glVertex2f(12.045625f,0.615000f);
  glVertex2f(11.329375f,4.071250f);
  glVertex2f(11.270000f,0.181875f);
  glVertex2f(11.174687f,3.600938f);
  glVertex2f(10.958125f,3.147500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.679688f,2.710938f);
  glVertex2f(10.331875f,2.325625f);
  glVertex2f(10.360625f,-0.127500f);
  glVertex2f(11.270000f,0.181875f);
  glVertex2f(10.958125f,3.147500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.331875f,2.325625f);
  glVertex2f(9.907187f,2.025938f);
  glVertex2f(10.360625f,-0.127500f);
  glVertex2f(9.405625f,1.811875f);
  glVertex2f(9.317500f,-0.313125f);
  glVertex2f(8.827188f,1.683437f);
  glVertex2f(8.171875f,1.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.140625f,-0.375000f);
  glVertex2f(9.317500f,-0.313125f);
  glVertex2f(8.171875f,1.640625f);
  glVertex2f(7.417500f,1.695625f);
  glVertex2f(6.741875f,1.860625f);
  glVertex2f(6.145000f,2.135625f);
  glVertex2f(5.750000f,-0.060000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.750000f,-0.060000f);
  glVertex2f(6.145000f,2.135625f);
  glVertex2f(5.626875f,2.520625f);
  glVertex2f(5.187500f,3.015625f);
  glVertex2f(4.827500f,3.635000f);
  glVertex2f(4.547500f,4.393125f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(13.968750f,10.281250f);
  glVertex2f(11.364062f,10.709375f);
  glVertex2f(11.312500f,10.281250f);
  glVertex2f(1.765625f,4.665000f);
  glVertex2f(1.560938f,9.012188f);
  glVertex2f(1.500000f,7.500000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.921875f,13.031250f);
  glVertex2f(12.656250f,13.421875f);
  glVertex2f(12.775937f,8.380625f);
  glVertex2f(12.828125f,7.390625f);
  glVertex2f(12.833438f,1.604687f);
  glVertex2f(12.921875f,1.703125f);
  glVertex2f(15.640625f,0.000000f);
  glVertex2f(12.921875f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.619375f,9.313125f);
  glVertex2f(12.775937f,8.380625f);
  glVertex2f(12.656250f,13.421875f);
  glVertex2f(12.528438f,13.563437f);
  glVertex2f(12.382500f,13.713125f);
  glVertex2f(12.358438f,10.188125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.382500f,13.713125f);
  glVertex2f(12.218437f,13.870937f);
  glVertex2f(12.358438f,10.188125f);
  glVertex2f(12.036250f,14.036875f);
  glVertex2f(11.993125f,11.005625f);
  glVertex2f(11.835938f,14.210938f);
  glVertex2f(11.602813f,14.385625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.523438f,11.765625f);
  glVertex2f(11.993125f,11.005625f);
  glVertex2f(11.602813f,14.385625f);
  glVertex2f(11.322187f,14.553437f);
  glVertex2f(10.994062f,14.714375f);
  glVertex2f(10.974375f,12.423750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.618438f,14.868438f);
  glVertex2f(10.195313f,15.015625f);
  glVertex2f(10.370937f,12.935625f);
  glVertex2f(10.974375f,12.423750f);
  glVertex2f(10.994062f,14.714375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.761875f,15.317500f);
  glVertex2f(9.000937f,13.520625f);
  glVertex2f(9.260313f,15.245625f);
  glVertex2f(9.713125f,13.301250f);
  glVertex2f(9.738125f,15.145000f);
  glVertex2f(10.370937f,12.935625f);
  glVertex2f(10.195313f,15.015625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.204375f,13.438750f);
  glVertex2f(7.701875f,13.555000f);
  glVertex2f(7.703125f,15.375000f);
  glVertex2f(8.234375f,13.593750f);
  glVertex2f(8.242812f,15.360625f);
  glVertex2f(9.000937f,13.520625f);
  glVertex2f(8.761875f,15.317500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.921875f,12.625000f);
  glVertex2f(6.314375f,12.973750f);
  glVertex2f(6.451875f,15.256250f);
  glVertex2f(6.741875f,13.245000f);
  glVertex2f(7.062188f,15.345312f);
  glVertex2f(7.204375f,13.438750f);
  glVertex2f(7.703125f,15.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.002187f,11.341562f);
  glVertex2f(5.263125f,11.796250f);
  glVertex2f(5.323125f,14.900000f);
  glVertex2f(5.569687f,12.224063f);
  glVertex2f(5.872188f,15.107813f);
  glVertex2f(5.921875f,12.625000f);
  glVertex2f(6.451875f,15.256250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.804688f,14.632813f);
  glVertex2f(4.324375f,14.316250f);
  glVertex2f(4.382187f,9.279062f);
  glVertex2f(4.485000f,9.822500f);
  glVertex2f(4.617188f,10.351563f);
  glVertex2f(4.786875f,10.860000f);
  glVertex2f(5.002187f,11.341562f);
  glVertex2f(5.323125f,14.900000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.324375f,14.316250f);
  glVertex2f(3.889688f,13.960313f);
  glVertex2f(4.250000f,7.562500f);
  glVertex2f(4.264688f,8.149062f);
  glVertex2f(4.308750f,8.721250f);
  glVertex2f(4.382187f,9.279062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.828125f,7.390625f);
  glVertex2f(12.811250f,6.840938f);
  glVertex2f(12.833438f,1.604687f);
  glVertex2f(12.760625f,6.304375f);
  glVertex2f(12.730625f,1.496875f);
  glVertex2f(12.676250f,5.780938f);
  glVertex2f(12.613438f,1.379687f);
  glVertex2f(12.558125f,5.270625f);
  glVertex2f(12.481875f,1.253125f);
  glVertex2f(12.406250f,4.773438f);
  glVertex2f(12.335938f,1.117188f);
  glVertex2f(12.214375f,4.296250f);
  glVertex2f(12.151875f,0.967812f);
  glVertex2f(11.976250f,3.845937f);
  glVertex2f(11.905937f,0.800937f);
  glVertex2f(11.691875f,3.422500f);
  glVertex2f(11.598125f,0.616562f);
  glVertex2f(11.361250f,3.025938f);
  glVertex2f(11.228437f,0.414687f);
  glVertex2f(10.984375f,2.656250f);
  glVertex2f(10.796875f,0.195313f);
  glVertex2f(10.568125f,2.335625f);
  glVertex2f(10.333750f,-0.010000f);
  glVertex2f(10.119375f,2.086250f);
  glVertex2f(9.869375f,-0.169688f);
  glVertex2f(9.638125f,1.908125f);
  glVertex2f(9.403750f,-0.283750f);
  glVertex2f(9.124375f,1.801250f);
  glVertex2f(8.936875f,-0.352188f);
  glVertex2f(8.578125f,1.765625f);
  glVertex2f(8.468750f,-0.375000f);
  glVertex2f(7.838125f,1.833437f);
  glVertex2f(7.410313f,-0.286563f);
  glVertex2f(7.155625f,2.036875f);
  glVertex2f(6.530625f,2.375937f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.397500f,-0.021250f);
  glVertex2f(7.410313f,-0.286563f);
  glVertex2f(6.530625f,2.375937f);
  glVertex2f(5.963125f,2.850625f);
  glVertex2f(5.453125f,3.460938f);
  glVertex2f(5.430312f,0.420938f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.453125f,3.460938f);
  glVertex2f(5.020000f,4.167500f);
  glVertex2f(5.430312f,0.420938f);
  glVertex2f(4.683125f,4.930937f);
  glVertex2f(4.508750f,1.040000f);
  glVertex2f(4.442500f,5.751250f);
  glVertex2f(4.298125f,6.628438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.298125f,6.628438f);
  glVertex2f(4.250000f,7.562500f);
  glVertex2f(4.508750f,1.040000f);
  glVertex2f(3.889688f,13.960313f);
  glVertex2f(3.632813f,1.835938f);
  glVertex2f(3.500625f,13.565000f);
  glVertex2f(3.157187f,13.130313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.865000f,2.758125f);
  glVertex2f(3.632813f,1.835938f);
  glVertex2f(3.157187f,13.130313f);
  glVertex2f(2.859375f,12.656250f);
  glVertex2f(2.598438f,12.156875f);
  glVertex2f(2.365625f,11.646250f);
  glVertex2f(2.267812f,3.755938f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.365625f,11.646250f);
  glVertex2f(2.160938f,11.124375f);
  glVertex2f(2.267812f,3.755938f);
  glVertex2f(1.984375f,10.591250f);
  glVertex2f(1.841250f,4.829375f);
  glVertex2f(1.835938f,10.046875f);
  glVertex2f(1.715000f,9.493125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.620937f,8.931875f);
  glVertex2f(1.553750f,8.363125f);
  glVertex2f(1.585312f,5.978437f);
  glVertex2f(1.841250f,4.829375f);
  glVertex2f(1.715000f,9.493125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.513438f,7.786875f);
  glVertex2f(1.500000f,7.203125f);
  glVertex2f(1.585312f,5.978437f);
  glVertex2f(1.553750f,8.363125f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(15.640625f,0.000000f);
  glVertex2f(12.921875f,1.703125f);
  glVertex2f(12.921875f,0.000000f);
  glVertex2f(12.921875f,21.656250f);
  glVertex2f(15.640625f,0.000000f);
  glVertex2f(15.640625f,21.656250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.125000f,4.781250f);
  glVertex2f(12.218750f,4.781250f);
  glVertex2f(12.224375f,0.517500f);
  glVertex2f(12.560000f,0.720000f);
  glVertex2f(12.859375f,0.937500f);
  glVertex2f(13.132500f,1.170313f);
  glVertex2f(13.389375f,1.418750f);
  glVertex2f(13.630000f,1.682812f);
  glVertex2f(13.854375f,1.962500f);
  glVertex2f(14.062500f,2.257813f);
  glVertex2f(14.251250f,2.553437f);
  glVertex2f(14.417500f,2.834063f);
  glVertex2f(14.561250f,3.099688f);
  glVertex2f(14.682500f,3.350312f);
  glVertex2f(14.781250f,3.585938f);
  glVertex2f(14.865000f,3.816250f);
  glVertex2f(14.941250f,4.050938f);
  glVertex2f(15.010000f,4.290000f);
  glVertex2f(15.071250f,4.533438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.218750f,4.781250f);
  glVertex2f(12.131562f,4.296875f);
  glVertex2f(12.224375f,0.517500f);
  glVertex2f(11.982500f,3.831250f);
  glVertex2f(11.852500f,0.330000f);
  glVertex2f(11.771563f,3.384375f);
  glVertex2f(11.498750f,2.956250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.678125f,-0.345937f);
  glVertex2f(8.375000f,-0.375000f);
  glVertex2f(8.406250f,1.546875f);
  glVertex2f(8.950000f,-0.360000f);
  glVertex2f(9.106563f,1.586875f);
  glVertex2f(9.500000f,-0.315000f);
  glVertex2f(9.732500f,1.706875f);
  glVertex2f(10.025000f,-0.240000f);
  glVertex2f(10.284062f,1.906875f);
  glVertex2f(10.525000f,-0.135000f);
  glVertex2f(10.761250f,2.186875f);
  glVertex2f(11.000000f,0.000000f);
  glVertex2f(11.164063f,2.546875f);
  glVertex2f(11.444375f,0.157500f);
  glVertex2f(11.498750f,2.956250f);
  glVertex2f(11.852500f,0.330000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.338125f,2.095313f);
  glVertex2f(6.378125f,-0.113437f);
  glVertex2f(6.941250f,1.790625f);
  glVertex2f(7.012500f,-0.258750f);
  glVertex2f(7.630625f,1.607813f);
  glVertex2f(7.678125f,-0.345937f);
  glVertex2f(8.406250f,1.546875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.041875f,3.718750f);
  glVertex2f(5.203125f,0.351563f);
  glVertex2f(5.390625f,3.070313f);
  glVertex2f(5.775000f,0.090000f);
  glVertex2f(5.821250f,2.521875f);
  glVertex2f(6.378125f,-0.113437f);
  glVertex2f(6.338125f,2.095313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.770625f,4.445313f);
  glVertex2f(4.576875f,5.250000f);
  glVertex2f(4.671250f,0.660625f);
  glVertex2f(5.203125f,0.351563f);
  glVertex2f(5.041875f,3.718750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.576875f,5.250000f);
  glVertex2f(4.460625f,6.132813f);
  glVertex2f(4.671250f,0.660625f);
  glVertex2f(4.421875f,7.093750f);
  glVertex2f(4.188125f,1.006562f);
  glVertex2f(4.198125f,14.060000f);
  glVertex2f(3.755938f,13.688125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.514688f,8.093125f);
  glVertex2f(1.515000f,6.951562f);
  glVertex2f(1.558750f,8.672500f);
  glVertex2f(1.560000f,6.406250f);
  glVertex2f(1.632187f,9.238125f);
  glVertex2f(1.635000f,5.864062f);
  glVertex2f(1.735000f,9.790000f);
  glVertex2f(1.740000f,5.325000f);
  glVertex2f(1.867188f,10.328125f);
  glVertex2f(1.875000f,4.789063f);
  glVertex2f(2.030937f,10.853125f);
  glVertex2f(2.041250f,4.260625f);
  glVertex2f(2.228437f,11.365625f);
  glVertex2f(2.240000f,3.744063f);
  glVertex2f(2.459687f,11.865625f);
  glVertex2f(2.471250f,3.239375f);
  glVertex2f(2.724688f,12.353125f);
  glVertex2f(2.735000f,2.746562f);
  glVertex2f(3.023438f,12.828125f);
  glVertex2f(3.031250f,2.265625f);
  glVertex2f(3.364375f,13.277500f);
  glVertex2f(3.368125f,1.809062f);
  glVertex2f(3.755938f,13.688125f);
  glVertex2f(3.753750f,1.389375f);
  glVertex2f(4.188125f,1.006562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.404375f,14.450313f);
  glVertex2f(11.967500f,14.676250f);
  glVertex2f(12.089375f,11.049687f);
  glVertex2f(12.223750f,10.420000f);
  glVertex2f(12.266875f,9.747188f);
  glVertex2f(15.125000f,7.093750f);
  glVertex2f(12.795000f,14.205000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.209375f,15.355312f);
  glVertex2f(9.266875f,13.432187f);
  glVertex2f(9.825000f,15.296250f);
  glVertex2f(9.992500f,13.275625f);
  glVertex2f(10.409375f,15.197812f);
  glVertex2f(10.614375f,13.014688f);
  glVertex2f(10.962500f,15.060000f);
  glVertex2f(11.132500f,12.649375f);
  glVertex2f(11.484375f,14.882813f);
  glVertex2f(11.546875f,12.179688f);
  glVertex2f(11.967500f,14.676250f);
  glVertex2f(11.863750f,11.636250f);
  glVertex2f(12.089375f,11.049687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.115000f,15.265000f);
  glVertex2f(7.181875f,13.306250f);
  glVertex2f(7.819375f,15.347500f);
  glVertex2f(8.437500f,13.484375f);
  glVertex2f(8.562500f,15.375000f);
  glVertex2f(9.266875f,13.432187f);
  glVertex2f(9.209375f,15.355312f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.198125f,14.060000f);
  glVertex2f(4.421875f,9.031250f);
  glVertex2f(4.690938f,14.393125f);
  glVertex2f(4.772500f,10.634375f);
  glVertex2f(5.234375f,14.687500f);
  glVertex2f(5.349375f,11.881249f);
  glVertex2f(5.822500f,14.935000f);
  glVertex2f(6.152500f,12.771875f);
  glVertex2f(6.449375f,15.127500f);
  glVertex2f(7.181875f,13.306250f);
  glVertex2f(7.115000f,15.265000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.266875f,9.747188f);
  glVertex2f(12.218750f,9.031250f);
  glVertex2f(15.125000f,7.093750f);
  glVertex2f(4.421875f,9.031250f);
  glVertex2f(4.421875f,7.093750f);
  glVertex2f(4.198125f,14.060000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.085938f,10.132813f);
  glVertex2f(15.125000f,7.093750f);
  glVertex2f(15.128125f,9.815000f);
  glVertex2f(15.153125f,7.600000f);
  glVertex2f(15.160937f,9.492812f);
  glVertex2f(15.175000f,7.993750f);
  glVertex2f(15.184375f,9.166250f);
  glVertex2f(15.190625f,8.275000f);
  glVertex2f(15.198438f,8.835313f);
  glVertex2f(15.200000f,8.443750f);
  glVertex2f(15.203125f,8.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.125000f,7.093750f);
  glVertex2f(15.085938f,10.132813f);
  glVertex2f(15.026875f,10.456875f);
  glVertex2f(14.943438f,10.797812f);
  glVertex2f(14.835625f,11.155625f);
  glVertex2f(14.703438f,11.530313f);
  glVertex2f(14.546875f,11.921875f);
  glVertex2f(14.367500f,12.311250f);
  glVertex2f(14.166875f,12.679375f);
  glVertex2f(13.945000f,13.026250f);
  glVertex2f(13.701875f,13.351875f);
  glVertex2f(13.437500f,13.656250f);
  glVertex2f(13.139375f,13.940312f);
  glVertex2f(12.795000f,14.205000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(1.515000f,6.951562f);
  glVertex2f(1.514688f,8.093125f);
  glVertex2f(1.500000f,7.500000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.358125f,18.274687f);
  glVertex2f(3.312500f,17.250000f);
  glVertex2f(6.000000f,0.000000f);
  glVertex2f(3.312500f,15.000000f);
  glVertex2f(3.312500f,13.031250f);
  glVertex2f(0.296875f,15.000000f);
  glVertex2f(0.296875f,13.031250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.437500f,19.812500f);
  glVertex2f(8.761250f,19.798124f);
  glVertex2f(8.762500f,21.918751f);
  glVertex2f(9.070000f,19.754999f);
  glVertex2f(9.156250f,21.856251f);
  glVertex2f(9.363750f,19.683125f);
  glVertex2f(9.537500f,21.768749f);
  glVertex2f(9.642500f,19.582500f);
  glVertex2f(9.906250f,21.656250f);
  glVertex2f(9.906250f,19.453125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.153125f,19.635313f);
  glVertex2f(7.525000f,19.746250f);
  glVertex2f(7.937500f,21.968750f);
  glVertex2f(7.953125f,19.805313f);
  glVertex2f(8.356250f,21.956249f);
  glVertex2f(8.437500f,19.812500f);
  glVertex2f(8.762500f,21.918751f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.048125f,21.939688f);
  glVertex2f(6.255000f,21.827499f);
  glVertex2f(6.370000f,18.983126f);
  glVertex2f(6.578125f,19.257813f);
  glVertex2f(6.837500f,19.472500f);
  glVertex2f(7.153125f,19.635313f);
  glVertex2f(7.937500f,21.968750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.255000f,21.827499f);
  glVertex2f(5.558125f,21.632187f);
  glVertex2f(6.023125f,17.750313f);
  glVertex2f(6.092500f,18.229376f);
  glVertex2f(6.208125f,18.640312f);
  glVertex2f(6.370000f,18.983126f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.558125f,21.632187f);
  glVertex2f(6.000000f,0.000000f);
  glVertex2f(6.000000f,17.203125f);
  glVertex2f(6.000000f,13.031250f);
  glVertex2f(6.000000f,15.000000f);
  glVertex2f(9.609375f,13.031250f);
  glVertex2f(9.609375f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.000000f,0.000000f);
  glVertex2f(5.558125f,21.632187f);
  glVertex2f(4.957500f,21.353750f);
  glVertex2f(4.453125f,20.992188f);
  glVertex2f(4.042500f,20.520000f);
  glVertex2f(3.723125f,19.909687f);
  glVertex2f(3.495000f,19.161249f);
  glVertex2f(3.358125f,18.274687f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(6.000000f,0.000000f);
  glVertex2f(3.312500f,13.031250f);
  glVertex2f(3.312500f,0.000000f);
  glVertex2f(5.558125f,21.632187f);
  glVertex2f(6.000000f,17.203125f);
  glVertex2f(6.023125f,17.750313f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.480000f,2.297500f);
  glVertex2f(12.608125f,2.441250f);
  glVertex2f(12.659375f,6.142500f);
  glVertex2f(12.745000f,2.602500f);
  glVertex2f(12.785937f,7.007500f);
  glVertex2f(12.890625f,2.781250f);
  glVertex2f(12.828125f,7.937500f);
  glVertex2f(12.890625f,13.359375f);
  glVertex2f(12.784375f,8.914375f);
  glVertex2f(12.764375f,13.542188f);
  glVertex2f(12.660625f,13.690625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.653125f,9.807500f);
  glVertex2f(12.784375f,8.914375f);
  glVertex2f(12.660625f,13.690625f);
  glVertex2f(12.579375f,13.804688f);
  glVertex2f(12.520625f,13.884375f);
  glVertex2f(12.484375f,13.929688f);
  glVertex2f(12.443125f,13.971562f);
  glVertex2f(12.434375f,10.616875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.443125f,13.971562f);
  glVertex2f(12.369375f,14.040937f);
  glVertex2f(12.434375f,10.616875f);
  glVertex2f(12.263125f,14.137813f);
  glVertex2f(12.128125f,11.342500f);
  glVertex2f(12.124375f,14.262188f);
  glVertex2f(11.953125f,14.414063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.767500f,14.568438f);
  glVertex2f(11.585625f,14.700313f);
  glVertex2f(11.734375f,11.984375f);
  glVertex2f(12.128125f,11.342500f);
  glVertex2f(11.953125f,14.414063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.407500f,14.809688f);
  glVertex2f(11.233125f,14.896563f);
  glVertex2f(11.248750f,12.524375f);
  glVertex2f(11.734375f,11.984375f);
  glVertex2f(11.585625f,14.700313f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.233125f,14.896563f);
  glVertex2f(11.062500f,14.960938f);
  glVertex2f(11.248750f,12.524375f);
  glVertex2f(10.876562f,15.014375f);
  glVertex2f(10.666875f,12.944375f);
  glVertex2f(10.656250f,15.068438f);
  glVertex2f(10.401563f,15.123125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.112500f,15.178437f);
  glVertex2f(9.789063f,15.234375f);
  glVertex2f(9.988750f,13.244375f);
  glVertex2f(10.666875f,12.944375f);
  glVertex2f(10.401563f,15.123125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.439375f,15.285000f);
  glVertex2f(9.071563f,15.324375f);
  glVertex2f(9.214375f,13.424375f);
  glVertex2f(9.988750f,13.244375f);
  glVertex2f(9.789063f,15.234375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.685625f,15.352500f);
  glVertex2f(8.281563f,15.369375f);
  glVertex2f(8.343750f,13.484375f);
  glVertex2f(9.214375f,13.424375f);
  glVertex2f(9.071563f,15.324375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.859375f,15.375000f);
  glVertex2f(6.781250f,15.291250f);
  glVertex2f(6.881250f,13.265000f);
  glVertex2f(8.343750f,13.484375f);
  glVertex2f(8.281563f,15.369375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.784375f,15.040000f);
  glVertex2f(4.868750f,14.621250f);
  glVertex2f(4.931250f,11.510000f);
  glVertex2f(5.743750f,12.606875f);
  glVertex2f(6.881250f,13.265000f);
  glVertex2f(6.781250f,15.291250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.672187f,5.259687f);
  glVertex2f(4.455000f,6.086250f);
  glVertex2f(4.765625f,1.109375f);
  glVertex2f(4.324687f,6.999688f);
  glVertex2f(4.237813f,1.410625f);
  glVertex2f(4.281250f,8.000000f);
  glVertex2f(4.034375f,14.035000f);
  glVertex2f(4.443750f,9.974375f);
  glVertex2f(4.868750f,14.621250f);
  glVertex2f(4.931250f,11.510000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.695313f,3.015625f);
  glVertex2f(2.995625f,2.554375f);
  glVertex2f(3.281250f,13.281250f);
  glVertex2f(3.352813f,2.133125f);
  glVertex2f(4.034375f,14.035000f);
  glVertex2f(3.766875f,1.751875f);
  glVertex2f(4.237813f,1.410625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.640000f,12.400000f);
  glVertex2f(2.141250f,11.431251f);
  glVertex2f(2.219063f,3.975625f);
  glVertex2f(2.440312f,3.496250f);
  glVertex2f(2.695313f,3.015625f);
  glVertex2f(3.281250f,13.281250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.665000f,5.890000f);
  glVertex2f(1.757813f,5.406250f);
  glVertex2f(1.785000f,10.375000f);
  glVertex2f(1.877813f,4.930625f);
  glVertex2f(2.141250f,11.431251f);
  glVertex2f(2.031563f,4.453750f);
  glVertex2f(2.219063f,3.975625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.510313f,7.446250f);
  glVertex2f(1.541250f,6.910000f);
  glVertex2f(1.571250f,9.231250f);
  glVertex2f(1.592813f,6.391250f);
  glVertex2f(1.785000f,10.375000f);
  glVertex2f(1.665000f,5.890000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.593750f,15.000000f);
  glVertex2f(12.890625f,15.000000f);
  glVertex2f(13.687500f,-4.031250f);
  glVertex2f(14.373750f,-3.218750f);
  glVertex2f(14.907500f,-2.318750f);
  glVertex2f(15.288750f,-1.331250f);
  glVertex2f(15.517500f,-0.256250f);
  glVertex2f(15.593750f,0.906250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.890625f,15.000000f);
  glVertex2f(12.890625f,13.359375f);
  glVertex2f(13.687500f,-4.031250f);
  glVertex2f(12.890625f,2.781250f);
  glVertex2f(12.861875f,-4.723125f);
  glVertex2f(12.851875f,1.347813f);
  glVertex2f(12.735625f,0.097500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.861875f,-4.723125f);
  glVertex2f(12.735625f,0.097500f);
  glVertex2f(12.541875f,-0.969687f);
  glVertex2f(12.270625f,-1.853750f);
  glVertex2f(11.921875f,-2.554688f);
  glVertex2f(11.910000f,-5.261250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.921875f,-2.554688f);
  glVertex2f(11.486875f,-3.103125f);
  glVertex2f(11.910000f,-5.261250f);
  glVertex2f(10.956875f,-3.529687f);
  glVertex2f(10.831875f,-5.645625f);
  glVertex2f(10.331875f,-3.834375f);
  glVertex2f(9.627500f,-5.876250f);
  glVertex2f(9.611875f,-4.017188f);
  glVertex2f(8.796875f,-4.078125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.296875f,-5.953125f);
  glVertex2f(9.627500f,-5.876250f);
  glVertex2f(8.796875f,-4.078125f);
  glVertex2f(8.212188f,-4.048750f);
  glVertex2f(7.658125f,-3.960625f);
  glVertex2f(7.621562f,-5.931875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.777500f,-3.023125f);
  glVertex2f(5.816875f,-5.613125f);
  glVertex2f(6.179688f,-3.343750f);
  glVertex2f(6.381562f,-5.761875f);
  glVertex2f(6.641875f,-3.608125f);
  glVertex2f(6.983125f,-5.868125f);
  glVertex2f(7.134687f,-3.813750f);
  glVertex2f(7.621562f,-5.931875f);
  glVertex2f(7.658125f,-3.960625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.464687f,-2.648750f);
  glVertex2f(5.241250f,-2.220625f);
  glVertex2f(5.289063f,-5.421875f);
  glVertex2f(5.816875f,-5.613125f);
  glVertex2f(5.777500f,-3.023125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.375312f,-4.953125f);
  glVertex2f(4.805937f,-5.198438f);
  glVertex2f(5.062500f,-1.203125f);
  glVertex2f(5.289063f,-5.421875f);
  glVertex2f(5.107187f,-1.738750f);
  glVertex2f(5.241250f,-2.220625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.062500f,-1.203125f);
  glVertex2f(2.250000f,-1.203125f);
  glVertex2f(2.260625f,-1.462500f);
  glVertex2f(2.292500f,-1.728125f);
  glVertex2f(2.345625f,-2.000000f);
  glVertex2f(2.420000f,-2.278125f);
  glVertex2f(2.515625f,-2.562500f);
  glVertex2f(2.635937f,-2.853437f);
  glVertex2f(2.784375f,-3.151250f);
  glVertex2f(2.960938f,-3.455937f);
  glVertex2f(3.165625f,-3.767500f);
  glVertex2f(3.398438f,-4.085938f);
  glVertex2f(3.671562f,-4.396875f);
  glVertex2f(3.997187f,-4.685937f);
  glVertex2f(4.375312f,-4.953125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.448438f,5.342500f);
  glVertex2f(12.153125f,4.607500f);
  glVertex2f(12.250000f,2.062500f);
  glVertex2f(12.360625f,2.171250f);
  glVertex2f(12.480000f,2.297500f);
  glVertex2f(12.659375f,6.142500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.153125f,4.607500f);
  glVertex2f(11.773438f,3.937500f);
  glVertex2f(11.804688f,1.683750f);
  glVertex2f(11.981250f,1.827500f);
  glVertex2f(12.129687f,1.953750f);
  glVertex2f(12.250000f,2.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.843437f,1.006250f);
  glVertex2f(11.112812f,1.165625f);
  glVertex2f(11.305000f,3.363750f);
  glVertex2f(11.367188f,1.343750f);
  glVertex2f(11.773438f,3.937500f);
  glVertex2f(11.600000f,1.522500f);
  glVertex2f(11.804688f,1.683750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.743438f,2.917500f);
  glVertex2f(10.088750f,2.598750f);
  glVertex2f(10.259687f,0.743750f);
  glVertex2f(10.559062f,0.865625f);
  glVertex2f(10.843437f,1.006250f);
  glVertex2f(11.305000f,3.363750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.909375f,0.443750f);
  glVertex2f(9.270312f,0.490625f);
  glVertex2f(9.340938f,2.407500f);
  glVertex2f(9.615625f,0.556250f);
  glVertex2f(10.088750f,2.598750f);
  glVertex2f(9.945313f,0.640625f);
  glVertex2f(10.259687f,0.743750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.909375f,0.443750f);
  glVertex2f(9.340938f,2.407500f);
  glVertex2f(8.532812f,0.415625f);
  glVertex2f(8.500000f,2.343750f);
  glVertex2f(8.140625f,0.406250f);
  glVertex2f(7.719687f,2.404687f);
  glVertex2f(7.370625f,0.434375f);
  glVertex2f(7.016250f,2.587500f);
  glVertex2f(6.648125f,0.518750f);
  glVertex2f(6.389688f,2.892188f);
  glVertex2f(5.973125f,0.659375f);
  glVertex2f(5.840000f,3.318750f);
  glVertex2f(5.367188f,3.867188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.672187f,5.259687f);
  glVertex2f(4.765625f,1.109375f);
  glVertex2f(4.976250f,4.520000f);
  glVertex2f(5.345625f,0.856250f);
  glVertex2f(5.367188f,3.867188f);
  glVertex2f(5.973125f,0.659375f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(1.510313f,7.446250f);
  glVertex2f(1.571250f,9.231250f);
  glVertex2f(1.500000f,8.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.873750f,13.231250f);
  glVertex2f(4.837187f,13.159375f);
  glVertex2f(4.860938f,10.676562f);
  glVertex2f(4.812500f,13.093750f);
  glVertex2f(4.812500f,10.218750f);
  glVertex2f(4.812500f,21.656250f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(2.109375f,21.656250f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.479063f,14.854688f);
  glVertex2f(11.624375f,15.143750f);
  glVertex2f(11.780625f,11.993750f);
  glVertex2f(12.047500f,11.475000f);
  glVertex2f(12.238125f,10.881250f);
  glVertex2f(12.352500f,10.212500f);
  glVertex2f(12.390625f,9.468750f);
  glVertex2f(15.093750f,0.000000f);
  glVertex2f(13.200625f,14.450000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.186875f,13.290625f);
  glVertex2f(10.627500f,13.087500f);
  glVertex2f(10.636562f,15.317187f);
  glVertex2f(11.044375f,12.803125f);
  glVertex2f(11.624375f,15.143750f);
  glVertex2f(11.437500f,12.437500f);
  glVertex2f(11.780625f,11.993750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.186875f,13.290625f);
  glVertex2f(10.636562f,15.317187f);
  glVertex2f(9.722500f,13.412500f);
  glVertex2f(9.515625f,15.375000f);
  glVertex2f(9.234375f,13.453125f);
  glVertex2f(9.036875f,15.361563f);
  glVertex2f(8.575625f,15.321250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.234375f,13.453125f);
  glVertex2f(8.575625f,15.321250f);
  glVertex2f(8.465938f,13.411563f);
  glVertex2f(8.131875f,15.254063f);
  glVertex2f(7.760625f,13.286875f);
  glVertex2f(7.705625f,15.160000f);
  glVertex2f(7.296875f,15.039063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.118437f,13.079062f);
  glVertex2f(7.760625f,13.286875f);
  glVertex2f(7.296875f,15.039063f);
  glVertex2f(6.915937f,14.898438f);
  glVertex2f(6.573125f,14.745313f);
  glVertex2f(6.539375f,12.788125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.268437f,14.579687f);
  glVertex2f(6.001875f,14.401563f);
  glVertex2f(6.023438f,12.414063f);
  glVertex2f(6.539375f,12.788125f);
  glVertex2f(6.573125f,14.745313f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.773438f,14.210938f);
  glVertex2f(5.577188f,14.024375f);
  glVertex2f(5.587500f,11.993750f);
  glVertex2f(6.023438f,12.414063f);
  glVertex2f(6.001875f,14.401563f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.577188f,14.024375f);
  glVertex2f(5.407187f,13.858438f);
  glVertex2f(5.587500f,11.993750f);
  glVertex2f(5.263437f,13.713125f);
  glVertex2f(5.248437f,11.564062f);
  glVertex2f(5.145937f,13.588437f);
  glVertex2f(5.054688f,13.484375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.006250f,11.125000f);
  glVertex2f(5.248437f,11.564062f);
  glVertex2f(5.054688f,13.484375f);
  glVertex2f(4.982500f,13.393750f);
  glVertex2f(4.922187f,13.309375f);
  glVertex2f(4.873750f,13.231250f);
  glVertex2f(4.860938f,10.676562f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.093750f,0.000000f);
  glVertex2f(15.093750f,9.312500f);
  glVertex2f(15.041562f,10.512187f);
  glVertex2f(14.885000f,11.573750f);
  glVertex2f(14.624063f,12.497188f);
  glVertex2f(14.258750f,13.282500f);
  glVertex2f(13.789063f,13.929688f);
  glVertex2f(13.200625f,14.450000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(15.093750f,0.000000f);
  glVertex2f(12.390625f,9.468750f);
  glVertex2f(12.390625f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.843750f,21.656250f);
  glVertex2f(1.843750f,18.890625f);
  glVertex2f(5.046875f,18.890625f);
  glVertex2f(5.046875f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,0.000000f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(4.812500f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.578125f,21.656250f);
  glVertex2f(3.578125f,18.890625f);
  glVertex2f(6.734375f,18.890625f);
  glVertex2f(6.734375f,21.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.500000f,15.000000f);
  glVertex2f(3.812500f,15.000000f);
  glVertex2f(3.906250f,-6.046875f);
  glVertex2f(4.176875f,-5.965938f);
  glVertex2f(4.438750f,-5.873125f);
  glVertex2f(4.691875f,-5.768437f);
  glVertex2f(4.936250f,-5.651875f);
  glVertex2f(5.171875f,-5.523438f);
  glVertex2f(5.395000f,-5.370313f);
  glVertex2f(5.601875f,-5.179688f);
  glVertex2f(5.792500f,-4.951562f);
  glVertex2f(5.966875f,-4.685937f);
  glVertex2f(6.125000f,-4.382813f);
  glVertex2f(6.260000f,-4.046250f);
  glVertex2f(6.365000f,-3.680313f);
  glVertex2f(6.440000f,-3.285000f);
  glVertex2f(6.485000f,-2.860312f);
  glVertex2f(6.500000f,-2.406250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.906250f,-6.046875f);
  glVertex2f(3.812500f,15.000000f);
  glVertex2f(3.812500f,-1.500000f);
  glVertex2f(3.803750f,-2.090312f);
  glVertex2f(3.777500f,-2.598750f);
  glVertex2f(3.733750f,-3.025312f);
  glVertex2f(3.672500f,-3.370000f);
  glVertex2f(3.633750f,-6.112187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.633750f,-6.112187f);
  glVertex2f(3.672500f,-3.370000f);
  glVertex2f(3.593750f,-3.632813f);
  glVertex2f(3.494375f,-3.832500f);
  glVertex2f(3.371250f,-3.987813f);
  glVertex2f(3.366250f,-6.158125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.224375f,-4.098750f);
  glVertex2f(3.053750f,-4.165312f);
  glVertex2f(3.103750f,-6.184688f);
  glVertex2f(3.366250f,-6.158125f);
  glVertex2f(3.371250f,-3.987813f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.900000f,-6.145000f);
  glVertex2f(2.118750f,-6.149687f);
  glVertex2f(2.122500f,-4.198750f);
  glVertex2f(2.350000f,-6.161250f);
  glVertex2f(2.394375f,-4.192500f);
  glVertex2f(2.593750f,-6.179688f);
  glVertex2f(2.640000f,-4.188750f);
  glVertex2f(2.846250f,-6.191875f);
  glVertex2f(2.859375f,-4.187500f);
  glVertex2f(3.103750f,-6.184688f);
  glVertex2f(3.053750f,-4.165312f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(1.824375f,-4.207500f);
  glVertex2f(1.500000f,-4.218750f);
  glVertex2f(1.693750f,-6.147188f);
  glVertex2f(1.900000f,-6.145000f);
  glVertex2f(2.122500f,-4.198750f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(1.693750f,-6.147188f);
  glVertex2f(1.500000f,-4.218750f);
  glVertex2f(1.500000f,-6.156250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(14.359375f,0.000000f);
  glVertex2f(7.875000f,8.468750f);
  glVertex2f(10.812500f,0.000000f);
  glVertex2f(4.812500f,8.765625f);
  glVertex2f(4.812500f,8.000000f);
  glVertex2f(4.812500f,21.656250f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(2.109375f,21.656250f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.484375f,15.000000f);
  glVertex2f(4.812500f,8.765625f);
  glVertex2f(7.875000f,8.468750f);
  glVertex2f(13.890625f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(4.812500f,21.656250f);
  glVertex2f(2.109375f,21.656250f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(4.812500f,9.703125f);
  glVertex2f(4.812500f,12.921875f);
  glVertex2f(4.859687f,10.214375f);
  glVertex2f(5.560625f,13.805000f);
  glVertex2f(5.001250f,10.723125f);
  glVertex2f(5.237187f,11.229375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.421875f,14.765625f);
  glVertex2f(11.950625f,14.985000f);
  glVertex2f(12.008750f,10.854375f);
  glVertex2f(12.119375f,10.294063f);
  glVertex2f(12.156250f,9.703125f);
  glVertex2f(14.859375f,0.000000f);
  glVertex2f(12.844375f,14.488750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.842500f,12.759375f);
  glVertex2f(11.234375f,12.351563f);
  glVertex2f(11.399375f,15.155625f);
  glVertex2f(11.566250f,11.883125f);
  glVertex2f(11.950625f,14.985000f);
  glVertex2f(11.824375f,11.384063f);
  glVertex2f(12.008750f,10.854375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.389375f,13.439062f);
  glVertex2f(9.920000f,13.303125f);
  glVertex2f(10.056875f,15.350625f);
  glVertex2f(10.404375f,13.076563f);
  glVertex2f(10.768125f,15.277500f);
  glVertex2f(10.842500f,12.759375f);
  glVertex2f(11.399375f,15.155625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.573750f,13.284375f);
  glVertex2f(8.174687f,13.434375f);
  glVertex2f(8.232500f,15.276875f);
  glVertex2f(8.812500f,13.484375f);
  glVertex2f(9.265625f,15.375000f);
  glVertex2f(9.389375f,13.439062f);
  glVertex2f(10.056875f,15.350625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.270625f,14.982500f);
  glVertex2f(6.380000f,14.491875f);
  glVertex2f(6.482500f,12.684375f);
  glVertex2f(7.009687f,13.034375f);
  glVertex2f(7.573750f,13.284375f);
  glVertex2f(8.232500f,15.276875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.380000f,14.491875f);
  glVertex2f(5.560625f,13.805000f);
  glVertex2f(5.567500f,11.733125f);
  glVertex2f(5.992188f,12.234375f);
  glVertex2f(6.482500f,12.684375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(22.778749f,14.467500f);
  glVertex2f(21.221251f,15.148125f);
  glVertex2f(21.242188f,12.484375f);
  glVertex2f(21.548750f,12.053125f);
  glVertex2f(21.787188f,11.559375f);
  glVertex2f(21.957500f,11.003125f);
  glVertex2f(22.059687f,10.384375f);
  glVertex2f(22.093750f,9.703125f);
  glVertex2f(24.781250f,0.000000f);
  glVertex2f(23.891251f,13.333125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(21.221251f,15.148125f);
  glVertex2f(19.218750f,15.375000f);
  glVertex2f(19.334688f,13.444375f);
  glVertex2f(19.913750f,13.324375f);
  glVertex2f(20.424688f,13.124375f);
  glVertex2f(20.867500f,12.844375f);
  glVertex2f(21.242188f,12.484375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.472500f,12.694375f);
  glVertex2f(16.977499f,13.040000f);
  glVertex2f(17.023750f,14.950000f);
  glVertex2f(17.514999f,13.286875f);
  glVertex2f(18.079374f,15.268750f);
  glVertex2f(18.084999f,13.435000f);
  glVertex2f(19.218750f,15.375000f);
  glVertex2f(18.687500f,13.484375f);
  glVertex2f(19.334688f,13.444375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.051874f,14.418750f);
  glVertex2f(15.163750f,13.675000f);
  glVertex2f(15.270000f,11.250000f);
  glVertex2f(15.589375f,11.753125f);
  glVertex2f(16.000000f,12.250000f);
  glVertex2f(16.472500f,12.694375f);
  glVertex2f(17.023750f,14.950000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(15.163750f,13.675000f);
  glVertex2f(14.359375f,12.718750f);
  glVertex2f(14.859375f,9.703125f);
  glVertex2f(14.905000f,10.225000f);
  glVertex2f(15.041875f,10.740625f);
  glVertex2f(15.270000f,11.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.859375f,0.000000f);
  glVertex2f(14.859375f,9.703125f);
  glVertex2f(14.359375f,12.718750f);
  glVertex2f(14.006875f,13.260625f);
  glVertex2f(13.636875f,13.736250f);
  glVertex2f(13.249375f,14.145625f);
  glVertex2f(12.844375f,14.488750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(24.558750f,11.745000f);
  glVertex2f(23.891251f,13.333125f);
  glVertex2f(24.781250f,0.000000f);
  glVertex2f(24.781250f,9.703125f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(24.781250f,0.000000f);
  glVertex2f(22.093750f,9.703125f);
  glVertex2f(22.093750f,0.000000f);
  glVertex2f(14.859375f,0.000000f);
  glVertex2f(12.156250f,9.703125f);
  glVertex2f(12.156250f,0.000000f);
  glVertex2f(5.560625f,13.805000f);
  glVertex2f(5.237187f,11.229375f);
  glVertex2f(5.567500f,11.733125f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.068438f,13.336250f);
  glVertex2f(4.963750f,13.217500f);
  glVertex2f(4.997500f,10.959375f);
  glVertex2f(4.878438f,13.126250f);
  glVertex2f(4.858750f,10.354688f);
  glVertex2f(4.812500f,13.062500f);
  glVertex2f(4.812500f,9.703125f);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.043750f,14.495000f);
  glVertex2f(11.425000f,15.155000f);
  glVertex2f(11.748125f,12.077500f);
  glVertex2f(12.056562f,11.595938f);
  glVertex2f(12.276875f,11.078750f);
  glVertex2f(12.409062f,10.525937f);
  glVertex2f(12.453125f,9.937500f);
  glVertex2f(15.125000f,0.000000f);
  glVertex2f(14.200000f,13.395000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.425000f,15.155000f);
  glVertex2f(9.343750f,15.375000f);
  glVertex2f(9.344063f,13.550938f);
  glVertex2f(9.891875f,13.422500f);
  glVertex2f(10.409062f,13.208438f);
  glVertex2f(10.895625f,12.908750f);
  glVertex2f(11.351563f,12.523438f);
  glVertex2f(11.748125f,12.077500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.050000f,15.270938f);
  glVertex2f(8.128750f,13.549687f);
  glVertex2f(8.456250f,15.328750f);
  glVertex2f(8.765625f,13.593750f);
  glVertex2f(8.887500f,15.363438f);
  glVertex2f(9.344063f,13.550938f);
  glVertex2f(9.343750f,15.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.668750f,15.190000f);
  glVertex2f(7.312500f,15.085938f);
  glVertex2f(7.530625f,13.417500f);
  glVertex2f(8.128750f,13.549687f);
  glVertex2f(8.050000f,15.270938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.988438f,14.968437f);
  glVertex2f(6.703750f,14.847187f);
  glVertex2f(6.971250f,13.197187f);
  glVertex2f(7.530625f,13.417500f);
  glVertex2f(7.312500f,15.085938f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.458437f,14.722187f);
  glVertex2f(6.252500f,14.593437f);
  glVertex2f(6.450625f,12.888750f);
  glVertex2f(6.971250f,13.197187f);
  glVertex2f(6.703750f,14.847187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.085938f,14.460938f);
  glVertex2f(5.938437f,14.321250f);
  glVertex2f(5.968750f,12.492188f);
  glVertex2f(6.450625f,12.888750f);
  glVertex2f(6.252500f,14.593437f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.938437f,14.321250f);
  glVertex2f(5.789688f,14.170938f);
  glVertex2f(5.968750f,12.492188f);
  glVertex2f(5.639688f,14.010000f);
  glVertex2f(5.552500f,12.028125f);
  glVertex2f(5.488438f,13.838437f);
  glVertex2f(5.335938f,13.656250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.228750f,11.517187f);
  glVertex2f(5.552500f,12.028125f);
  glVertex2f(5.335938f,13.656250f);
  glVertex2f(5.192500f,13.482500f);
  glVertex2f(5.068438f,13.336250f);
  glVertex2f(4.997500f,10.959375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.893750f,11.855000f);
  glVertex2f(14.200000f,13.395000f);
  glVertex2f(15.125000f,0.000000f);
  glVertex2f(15.125000f,9.875000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(15.125000f,0.000000f);
  glVertex2f(12.453125f,9.937500f);
  glVertex2f(12.453125f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.265625f,7.500000f);
  glVertex2f(16.182188f,8.964375f);
  glVertex2f(16.182188f,6.035625f);
  glVertex2f(15.931875f,10.282500f);
  glVertex2f(15.931875f,4.717500f);
  glVertex2f(15.514688f,11.454375f);
  glVertex2f(15.514688f,3.545625f);
  glVertex2f(14.930625f,12.480000f);
  glVertex2f(14.930625f,2.520000f);
  glVertex2f(14.179688f,13.359375f);
  glVertex2f(14.179688f,1.640625f);
  glVertex2f(13.453125f,7.500000f);
  glVertex2f(13.406250f,6.573438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.031250f,10.144688f);
  glVertex2f(13.265625f,9.308750f);
  glVertex2f(13.300000f,14.085000f);
  glVertex2f(13.406250f,8.427188f);
  glVertex2f(14.179688f,13.359375f);
  glVertex2f(13.453125f,7.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.770312f,12.329375f);
  glVertex2f(12.281250f,11.679688f);
  glVertex2f(12.329688f,14.649375f);
  glVertex2f(12.703125f,10.935000f);
  glVertex2f(13.300000f,14.085000f);
  glVertex2f(13.031250f,10.144688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.268750f,15.052500f);
  glVertex2f(10.117188f,15.294375f);
  glVertex2f(10.495313f,13.195625f);
  glVertex2f(11.175000f,12.834687f);
  glVertex2f(11.770312f,12.329375f);
  glVertex2f(12.329688f,14.649375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.590625f,12.834687f);
  glVertex2f(7.270312f,13.195625f);
  glVertex2f(7.633125f,15.294375f);
  glVertex2f(8.034375f,13.412188f);
  glVertex2f(8.875000f,15.375000f);
  glVertex2f(8.882813f,13.484375f);
  glVertex2f(10.117188f,15.294375f);
  glVertex2f(9.731250f,13.412188f);
  glVertex2f(10.495313f,13.195625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.482500f,15.052500f);
  glVertex2f(5.423125f,14.649375f);
  glVertex2f(5.484375f,11.679688f);
  glVertex2f(5.995313f,12.329375f);
  glVertex2f(6.590625f,12.834687f);
  glVertex2f(7.633125f,15.294375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.423125f,14.649375f);
  glVertex2f(4.455000f,14.085000f);
  glVertex2f(4.500000f,9.308750f);
  glVertex2f(4.734375f,10.144688f);
  glVertex2f(5.062500f,10.935000f);
  glVertex2f(5.484375f,11.679688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.578125f,1.640625f);
  glVertex2f(4.455000f,0.915000f);
  glVertex2f(3.578125f,13.359375f);
  glVertex2f(4.312500f,7.500000f);
  glVertex2f(4.455000f,14.085000f);
  glVertex2f(4.359375f,8.427188f);
  glVertex2f(4.500000f,9.308750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.300000f,0.915000f);
  glVertex2f(14.179688f,1.640625f);
  glVertex2f(13.406250f,6.573438f);
  glVertex2f(13.265625f,5.693750f);
  glVertex2f(13.031250f,4.860938f);
  glVertex2f(12.703125f,4.075000f);
  glVertex2f(12.329687f,0.350625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.703125f,4.075000f);
  glVertex2f(12.281250f,3.335938f);
  glVertex2f(12.329687f,0.350625f);
  glVertex2f(11.770312f,2.691875f);
  glVertex2f(11.268750f,-0.052500f);
  glVertex2f(11.175000f,2.190938f);
  glVertex2f(10.495313f,1.833125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.117188f,-0.294375f);
  glVertex2f(11.268750f,-0.052500f);
  glVertex2f(10.495313f,1.833125f);
  glVertex2f(9.731250f,1.618438f);
  glVertex2f(8.882813f,1.546875f);
  glVertex2f(8.875000f,-0.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.034375f,1.618438f);
  glVertex2f(7.270313f,1.833125f);
  glVertex2f(7.633125f,-0.294375f);
  glVertex2f(8.875000f,-0.375000f);
  glVertex2f(8.882813f,1.546875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.590625f,2.190938f);
  glVertex2f(5.995313f,2.691875f);
  glVertex2f(6.482500f,-0.052500f);
  glVertex2f(7.633125f,-0.294375f);
  glVertex2f(7.270313f,1.833125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.484375f,3.335938f);
  glVertex2f(5.062500f,4.075000f);
  glVertex2f(5.423125f,0.350625f);
  glVertex2f(6.482500f,-0.052500f);
  glVertex2f(5.995313f,2.691875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.062500f,4.075000f);
  glVertex2f(4.734375f,4.860938f);
  glVertex2f(5.423125f,0.350625f);
  glVertex2f(4.500000f,5.693750f);
  glVertex2f(4.455000f,0.915000f);
  glVertex2f(4.359375f,6.573438f);
  glVertex2f(4.312500f,7.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.500000f,7.500000f);
  glVertex2f(1.583125f,6.035625f);
  glVertex2f(1.583125f,8.964375f);
  glVertex2f(1.832500f,4.717500f);
  glVertex2f(1.832500f,10.282500f);
  glVertex2f(2.248125f,3.545625f);
  glVertex2f(2.248125f,11.454375f);
  glVertex2f(2.830000f,2.520000f);
  glVertex2f(2.830000f,12.480000f);
  glVertex2f(3.578125f,1.640625f);
  glVertex2f(3.578125f,13.359375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.781250f,7.500000f);
  glVertex2f(4.825000f,8.485625f);
  glVertex2f(4.812500f,13.093750f);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(4.812500f,-5.953125f);
  glVertex2f(4.812500f,1.546875f);
  glVertex2f(4.825000f,6.514688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(16.468750f,7.500000f);
  glVertex2f(16.402500f,8.884687f);
  glVertex2f(16.402500f,6.125312f);
  glVertex2f(16.203751f,10.151250f);
  glVertex2f(16.203751f,4.863750f);
  glVertex2f(15.872500f,11.299687f);
  glVertex2f(15.872500f,3.715312f);
  glVertex2f(15.408750f,12.330000f);
  glVertex2f(15.408750f,2.680000f);
  glVertex2f(14.812500f,13.242188f);
  glVertex2f(14.812500f,1.757813f);
  glVertex2f(14.071875f,14.010000f);
  glVertex2f(14.071875f,0.978750f);
  glVertex2f(13.593750f,7.500000f);
  glVertex2f(13.549687f,6.514688f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(14.071875f,14.010000f);
  glVertex2f(13.175000f,14.607187f);
  glVertex2f(13.197187f,10.258125f);
  glVertex2f(13.417500f,9.405000f);
  glVertex2f(13.549687f,8.485625f);
  glVertex2f(13.593750f,7.500000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.432187f,12.865625f);
  glVertex2f(12.006875f,12.384375f);
  glVertex2f(12.121875f,15.033750f);
  glVertex2f(12.492188f,11.765625f);
  glVertex2f(13.175000f,14.607187f);
  glVertex2f(12.888750f,11.045000f);
  glVertex2f(13.197187f,10.258125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.912500f,15.289687f);
  glVertex2f(9.546875f,15.375000f);
  glVertex2f(10.014688f,13.415625f);
  glVertex2f(10.768125f,13.209375f);
  glVertex2f(11.432187f,12.865625f);
  glVertex2f(12.121875f,15.033750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.171875f,13.484375f);
  glVertex2f(10.014688f,13.415625f);
  glVertex2f(9.546875f,15.375000f);
  glVertex2f(8.998438f,15.352187f);
  glVertex2f(8.478125f,15.283750f);
  glVertex2f(8.335000f,13.415625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.985938f,15.169687f);
  glVertex2f(7.521875f,15.010000f);
  glVertex2f(7.586875f,13.209375f);
  glVertex2f(8.335000f,13.415625f);
  glVertex2f(8.478125f,15.283750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.956250f,9.405000f);
  glVertex2f(5.175000f,10.258125f);
  glVertex2f(5.293437f,13.527187f);
  glVertex2f(5.481250f,11.045000f);
  glVertex2f(5.761250f,13.915000f);
  glVertex2f(5.875000f,11.765625f);
  glVertex2f(6.215938f,14.257188f);
  glVertex2f(6.356875f,12.384375f);
  glVertex2f(6.657500f,14.553750f);
  glVertex2f(6.927500f,12.865625f);
  glVertex2f(7.085938f,14.804688f);
  glVertex2f(7.586875f,13.209375f);
  glVertex2f(7.521875f,15.010000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.293437f,13.527187f);
  glVertex2f(4.812500f,13.093750f);
  glVertex2f(4.825000f,8.485625f);
  glVertex2f(4.956250f,9.405000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.549687f,6.514688f);
  glVertex2f(13.417500f,5.596250f);
  glVertex2f(14.071875f,0.978750f);
  glVertex2f(13.197187f,4.744688f);
  glVertex2f(13.175000f,0.372812f);
  glVertex2f(12.888750f,3.960000f);
  glVertex2f(12.492188f,3.242188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.121875f,-0.060000f);
  glVertex2f(13.175000f,0.372812f);
  glVertex2f(12.492188f,3.242188f);
  glVertex2f(12.006875f,2.626250f);
  glVertex2f(11.432188f,2.147187f);
  glVertex2f(10.912500f,-0.319688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.432188f,2.147187f);
  glVertex2f(10.768125f,1.805000f);
  glVertex2f(10.912500f,-0.319688f);
  glVertex2f(10.014688f,1.599687f);
  glVertex2f(9.546875f,-0.406250f);
  glVertex2f(9.171875f,1.531250f);
  glVertex2f(8.637500f,-0.328125f);
  glVertex2f(8.335000f,1.599687f);
  glVertex2f(7.709375f,-0.093750f);
  glVertex2f(7.586875f,1.805000f);
  glVertex2f(6.927500f,2.147187f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.762500f,0.296875f);
  glVertex2f(7.709375f,-0.093750f);
  glVertex2f(6.927500f,2.147187f);
  glVertex2f(6.356875f,2.626250f);
  glVertex2f(5.875000f,3.242188f);
  glVertex2f(5.796875f,0.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.796875f,0.843750f);
  glVertex2f(5.875000f,3.242188f);
  glVertex2f(5.481250f,3.960000f);
  glVertex2f(5.175000f,4.744688f);
  glVertex2f(4.956250f,5.596250f);
  glVertex2f(4.812500f,1.546875f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.812500f,-5.953125f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,-5.953125f);
  glVertex2f(4.825000f,6.514688f);
  glVertex2f(4.812500f,1.546875f);
  glVertex2f(4.956250f,5.596250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.187500f,1.546875f);
  glVertex2f(13.187500f,-5.953125f);
  glVertex2f(15.875000f,-5.953125f);
  glVertex2f(13.218750f,7.500000f);
  glVertex2f(13.174687f,6.514688f);
  glVertex2f(13.042500f,5.596250f);
  glVertex2f(12.822187f,4.744688f);
  glVertex2f(12.513750f,3.960000f);
  glVertex2f(12.197500f,0.843750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.513750f,3.960000f);
  glVertex2f(12.117188f,3.242188f);
  glVertex2f(12.197500f,0.843750f);
  glVertex2f(11.631875f,2.626250f);
  glVertex2f(11.227500f,0.296875f);
  glVertex2f(11.057188f,2.147187f);
  glVertex2f(10.393125f,1.805000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.227500f,0.296875f);
  glVertex2f(10.393125f,1.805000f);
  glVertex2f(10.277500f,-0.093750f);
  glVertex2f(9.639688f,1.599687f);
  glVertex2f(9.347500f,-0.328125f);
  glVertex2f(8.796875f,1.531250f);
  glVertex2f(8.437500f,-0.406250f);
  glVertex2f(7.959688f,1.599687f);
  glVertex2f(7.210625f,1.805000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.071562f,-0.319687f);
  glVertex2f(8.437500f,-0.406250f);
  glVertex2f(7.210625f,1.805000f);
  glVertex2f(6.549687f,2.147187f);
  glVertex2f(5.976875f,2.626250f);
  glVertex2f(5.861250f,-0.060000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.976875f,2.626250f);
  glVertex2f(5.492188f,3.242188f);
  glVertex2f(5.861250f,-0.060000f);
  glVertex2f(5.095625f,3.960000f);
  glVertex2f(4.806562f,0.372813f);
  glVertex2f(4.787188f,4.744688f);
  glVertex2f(4.566875f,5.596250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.500000f,7.500000f);
  glVertex2f(1.566563f,6.125313f);
  glVertex2f(1.566563f,8.874063f);
  glVertex2f(1.766250f,4.863750f);
  glVertex2f(1.766250f,10.133750f);
  glVertex2f(2.099062f,3.715312f);
  glVertex2f(2.099062f,11.279062f);
  glVertex2f(2.565000f,2.680000f);
  glVertex2f(2.565000f,12.310000f);
  glVertex2f(3.164063f,1.757813f);
  glVertex2f(3.164063f,13.226563f);
  glVertex2f(3.907500f,0.978750f);
  glVertex2f(3.907500f,14.000000f);
  glVertex2f(4.806562f,0.372813f);
  glVertex2f(4.434688f,6.514688f);
  glVertex2f(4.566875f,5.596250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.434688f,6.514688f);
  glVertex2f(4.390625f,7.500000f);
  glVertex2f(3.907500f,14.000000f);
  glVertex2f(4.434688f,8.485625f);
  glVertex2f(4.806562f,14.601563f);
  glVertex2f(4.566875f,9.405000f);
  glVertex2f(4.787188f,10.258125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.218750f,7.500000f);
  glVertex2f(15.875000f,-5.953125f);
  glVertex2f(15.875000f,15.000000f);
  glVertex2f(13.187500f,15.000000f);
  glVertex2f(13.187500f,13.093750f);
  glVertex2f(13.174687f,8.485625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.867188f,14.804688f);
  glVertex2f(11.057187f,12.865625f);
  glVertex2f(11.297500f,14.553750f);
  glVertex2f(11.631875f,12.384375f);
  glVertex2f(11.744687f,14.257188f);
  glVertex2f(12.117188f,11.765625f);
  glVertex2f(12.208750f,13.915000f);
  glVertex2f(12.513750f,11.045000f);
  glVertex2f(12.689688f,13.527187f);
  glVertex2f(12.822187f,10.258125f);
  glVertex2f(13.187500f,13.093750f);
  glVertex2f(13.042500f,9.405000f);
  glVertex2f(13.174687f,8.485625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.486250f,15.283750f);
  glVertex2f(9.639688f,13.415625f);
  glVertex2f(9.972188f,15.169687f);
  glVertex2f(10.393125f,13.209375f);
  glVertex2f(10.432500f,15.010000f);
  glVertex2f(11.057187f,12.865625f);
  glVertex2f(10.867188f,14.804688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.210625f,13.209375f);
  glVertex2f(7.959688f,13.415625f);
  glVertex2f(8.437500f,15.375000f);
  glVertex2f(8.796875f,13.484375f);
  glVertex2f(8.974688f,15.352187f);
  glVertex2f(9.639688f,13.415625f);
  glVertex2f(9.486250f,15.283750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.071563f,15.289063f);
  glVertex2f(5.861250f,15.031250f);
  glVertex2f(5.976875f,12.384375f);
  glVertex2f(6.549687f,12.865625f);
  glVertex2f(7.210625f,13.209375f);
  glVertex2f(8.437500f,15.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.861250f,15.031250f);
  glVertex2f(4.806562f,14.601563f);
  glVertex2f(5.095625f,11.045000f);
  glVertex2f(5.492188f,11.765625f);
  glVertex2f(5.976875f,12.384375f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.806562f,14.601563f);
  glVertex2f(4.787188f,10.258125f);
  glVertex2f(5.095625f,11.045000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.720938f,14.033125f);
  glVertex2f(5.378750f,13.720625f);
  glVertex2f(5.687500f,11.086250f);
  glVertex2f(5.075937f,13.360625f);
  glVertex2f(5.031250f,9.913750f);
  glVertex2f(4.812500f,12.953125f);
  glVertex2f(4.812500f,8.406250f);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(4.812500f,0.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.281250f,15.000000f);
  glVertex2f(9.280937f,14.980625f);
  glVertex2f(10.281250f,12.593750f);
  glVertex2f(8.405000f,14.922500f);
  glVertex2f(8.312500f,12.426250f);
  glVertex2f(7.653438f,14.825625f);
  glVertex2f(7.026250f,14.690000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.781250f,11.923750f);
  glVertex2f(8.312500f,12.426250f);
  glVertex2f(7.026250f,14.690000f);
  glVertex2f(6.523438f,14.515625f);
  glVertex2f(6.102500f,14.298125f);
  glVertex2f(5.720938f,14.033125f);
  glVertex2f(5.687500f,11.086250f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.593750f,4.421875f);
  glVertex2f(13.556875f,5.050625f);
  glVertex2f(13.518125f,3.470625f);
  glVertex2f(13.446250f,5.624375f);
  glVertex2f(13.291250f,2.629375f);
  glVertex2f(13.261875f,6.143125f);
  glVertex2f(13.003750f,6.606875f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.291250f,2.629375f);
  glVertex2f(13.003750f,6.606875f);
  glVertex2f(12.913125f,1.898125f);
  glVertex2f(12.671875f,7.015625f);
  glVertex2f(12.383750f,1.276875f);
  glVertex2f(12.287188f,7.372188f);
  glVertex2f(11.870625f,7.679375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.703125f,0.765625f);
  glVertex2f(12.383750f,1.276875f);
  glVertex2f(11.870625f,7.679375f);
  glVertex2f(11.422188f,7.937188f);
  glVertex2f(10.941875f,8.145625f);
  glVertex2f(10.912500f,0.355000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.912500f,0.355000f);
  glVertex2f(10.941875f,8.145625f);
  glVertex2f(10.843750f,4.187500f);
  glVertex2f(10.802188f,3.709687f);
  glVertex2f(10.677500f,3.276250f);
  glVertex2f(10.469687f,2.887187f);
  glVertex2f(10.178750f,2.542500f);
  glVertex2f(10.053125f,0.035625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.941875f,8.145625f);
  glVertex2f(10.429688f,8.304688f);
  glVertex2f(10.511875f,5.242188f);
  glVertex2f(10.696250f,4.931250f);
  glVertex2f(10.806875f,4.579688f);
  glVertex2f(10.843750f,4.187500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.931562f,9.450000f);
  glVertex2f(6.066563f,6.791875f);
  glVertex2f(6.348125f,9.268750f);
  glVertex2f(6.597813f,6.679375f);
  glVertex2f(6.796563f,9.112500f);
  glVertex2f(7.130312f,6.576875f);
  glVertex2f(7.276875f,8.981250f);
  glVertex2f(7.664063f,6.484375f);
  glVertex2f(7.789063f,8.875000f);
  glVertex2f(8.181875f,6.384687f);
  glVertex2f(8.317187f,8.777187f);
  glVertex2f(8.666562f,6.260625f);
  glVertex2f(8.845312f,8.671250f);
  glVertex2f(9.118125f,6.112187f);
  glVertex2f(9.373438f,8.557187f);
  glVertex2f(9.536563f,5.939375f);
  glVertex2f(9.901563f,8.435000f);
  glVertex2f(9.921875f,5.742188f);
  glVertex2f(10.429688f,8.304688f);
  glVertex2f(10.253750f,5.512500f);
  glVertex2f(10.511875f,5.242188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.956875f,10.173750f);
  glVertex2f(5.007813f,7.046875f);
  glVertex2f(5.215000f,9.895000f);
  glVertex2f(5.536562f,6.914375f);
  glVertex2f(5.546875f,9.656250f);
  glVertex2f(6.066563f,6.791875f);
  glVertex2f(5.931562f,9.450000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.007813f,7.046875f);
  glVertex2f(4.956875f,10.173750f);
  glVertex2f(4.772500f,10.492500f);
  glVertex2f(4.661875f,10.851250f);
  glVertex2f(4.625000f,11.250000f);
  glVertex2f(4.495625f,7.212187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.765625f,8.429688f);
  glVertex2f(3.150312f,8.041875f);
  glVertex2f(3.195313f,14.179688f);
  glVertex2f(3.566875f,7.709688f);
  glVertex2f(3.800000f,14.610000f);
  glVertex2f(4.015313f,7.433125f);
  glVertex2f(4.532813f,14.944688f);
  glVertex2f(4.495625f,7.212187f);
  glVertex2f(4.625000f,11.250000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(1.843750f,11.250000f);
  glVertex2f(1.880625f,10.567187f);
  glVertex2f(1.897812f,11.922188f);
  glVertex2f(1.991250f,9.943750f);
  glVertex2f(2.060000f,12.551250f);
  glVertex2f(2.175625f,9.379687f);
  glVertex2f(2.330312f,13.137188f);
  glVertex2f(2.433750f,8.875000f);
  glVertex2f(2.708750f,13.680000f);
  glVertex2f(2.765625f,8.429688f);
  glVertex2f(3.195313f,14.179688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.178750f,2.542500f);
  glVertex2f(9.804688f,2.242188f);
  glVertex2f(10.053125f,0.035625f);
  glVertex2f(9.375625f,1.991875f);
  glVertex2f(9.125000f,-0.192500f);
  glVertex2f(8.919687f,1.797188f);
  glVertex2f(8.436875f,1.658125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.128125f,-0.329375f);
  glVertex2f(9.125000f,-0.192500f);
  glVertex2f(8.436875f,1.658125f);
  glVertex2f(7.927187f,1.574687f);
  glVertex2f(7.390625f,1.546875f);
  glVertex2f(7.062500f,-0.375000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.385625f,3.336875f);
  glVertex2f(4.400938f,0.035625f);
  glVertex2f(4.767500f,2.553750f);
  glVertex2f(5.208750f,-0.192500f);
  glVertex2f(5.395625f,1.994375f);
  glVertex2f(6.095937f,-0.329375f);
  glVertex2f(6.270000f,1.658750f);
  glVertex2f(7.062500f,-0.375000f);
  glVertex2f(7.390625f,1.546875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.250000f,4.343750f);
  glVertex2f(1.500000f,4.343750f);
  glVertex2f(1.560938f,3.420625f);
  glVertex2f(1.743750f,2.601250f);
  glVertex2f(2.048438f,1.885625f);
  glVertex2f(2.475000f,1.273750f);
  glVertex2f(3.023438f,0.765625f);
  glVertex2f(3.672500f,0.355000f);
  glVertex2f(4.400938f,0.035625f);
  glVertex2f(4.385625f,3.336875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(13.187500f,10.984375f);
  glVertex2f(13.127812f,11.927500f);
  glVertex2f(12.948750f,12.744375f);
  glVertex2f(12.650312f,13.435000f);
  glVertex2f(12.232500f,13.999375f);
  glVertex2f(11.695313f,14.437500f);
  glVertex2f(11.050000f,14.775000f);
  glVertex2f(10.406250f,10.984375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.307813f,15.037500f);
  glVertex2f(9.468750f,15.225000f);
  glVertex2f(9.931250f,12.584375f);
  glVertex2f(10.287500f,11.884375f);
  glVertex2f(10.406250f,10.984375f);
  glVertex2f(11.050000f,14.775000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.982812f,13.459687f);
  glVertex2f(7.437500f,13.484375f);
  glVertex2f(7.500000f,15.375000f);
  glVertex2f(8.506250f,13.384375f);
  glVertex2f(8.532812f,15.337500f);
  glVertex2f(9.337500f,13.084375f);
  glVertex2f(9.468750f,15.225000f);
  glVertex2f(9.931250f,12.584375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.787500f,13.089375f);
  glVertex2f(6.157813f,13.262188f);
  glVertex2f(6.382813f,15.327188f);
  glVertex2f(6.556250f,13.385625f);
  glVertex2f(7.500000f,15.375000f);
  glVertex2f(6.982812f,13.459687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.920312f,12.312187f);
  glVertex2f(5.150000f,12.605000f);
  glVertex2f(5.393750f,15.183750f);
  glVertex2f(5.445313f,12.867188f);
  glVertex2f(6.382813f,15.327188f);
  glVertex2f(5.787500f,13.089375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.393750f,15.183750f);
  glVertex2f(4.532813f,14.944688f);
  glVertex2f(4.657813f,11.634687f);
  glVertex2f(4.756250f,11.988750f);
  glVertex2f(4.920312f,12.312187f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(4.657813f,11.634687f);
  glVertex2f(4.532813f,14.944688f);
  glVertex2f(4.625000f,11.250000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.296875f,19.078125f);
  glVertex2f(3.609375f,17.953125f);
  glVertex2f(3.645000f,3.000000f);
  glVertex2f(3.609375f,15.000000f);
  glVertex2f(3.609375f,13.062500f);
  glVertex2f(0.906250f,15.000000f);
  glVertex2f(0.906250f,13.062500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.296875f,19.078125f);
  glVertex2f(3.645000f,3.000000f);
  glVertex2f(3.751875f,2.196875f);
  glVertex2f(3.930000f,1.512500f);
  glVertex2f(4.179375f,0.946875f);
  glVertex2f(4.500000f,0.500000f);
  glVertex2f(4.899375f,0.155000f);
  glVertex2f(5.385000f,-0.105000f);
  glVertex2f(5.956875f,-0.280000f);
  glVertex2f(6.296875f,3.921875f);
  glVertex2f(6.296875f,13.062500f);
  glVertex2f(6.296875f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.296875f,15.000000f);
  glVertex2f(6.296875f,13.062500f);
  glVertex2f(9.609375f,13.062500f);
  glVertex2f(9.609375f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.304375f,1.692500f);
  glVertex2f(8.334375f,-0.292500f);
  glVertex2f(8.655000f,1.729375f);
  glVertex2f(8.784375f,-0.217500f);
  glVertex2f(8.989375f,1.782500f);
  glVertex2f(9.209375f,-0.120000f);
  glVertex2f(9.307500f,1.851875f);
  glVertex2f(9.609375f,0.000000f);
  glVertex2f(9.609375f,1.937500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.937500f,1.671875f);
  glVertex2f(7.639062f,1.670000f);
  glVertex2f(7.859375f,-0.345000f);
  glVertex2f(8.334375f,-0.292500f);
  glVertex2f(8.304375f,1.692500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.368750f,1.714375f);
  glVertex2f(7.126563f,1.805000f);
  glVertex2f(7.359375f,-0.375000f);
  glVertex2f(7.859375f,-0.345000f);
  glVertex2f(7.639062f,1.670000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.126563f,1.805000f);
  glVertex2f(6.912500f,1.941875f);
  glVertex2f(7.359375f,-0.375000f);
  glVertex2f(6.726563f,2.125000f);
  glVertex2f(6.615000f,-0.370000f);
  glVertex2f(6.571875f,2.361875f);
  glVertex2f(6.451562f,2.660000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.296875f,3.921875f);
  glVertex2f(5.956875f,-0.280000f);
  glVertex2f(6.314063f,3.440000f);
  glVertex2f(6.615000f,-0.370000f);
  glVertex2f(6.365625f,3.019375f);
  glVertex2f(6.451562f,2.660000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(3.645000f,3.000000f);
  glVertex2f(3.609375f,13.062500f);
  glVertex2f(3.609375f,3.921875f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.200625f,3.409688f);
  glVertex2f(4.985000f,3.923750f);
  glVertex2f(5.690625f,-0.150000f);
  glVertex2f(4.855625f,4.474688f);
  glVertex2f(4.818750f,0.131250f);
  glVertex2f(4.812500f,5.062500f);
  glVertex2f(4.078125f,0.525000f);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(3.468750f,1.031250f);
  glVertex2f(2.979375f,1.645000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.812500f,15.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.163750f,4.101250f);
  glVertex2f(2.326875f,3.180000f);
  glVertex2f(2.598750f,2.361250f);
  glVertex2f(2.979375f,1.645000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.390625f,1.937500f);
  glVertex2f(12.390625f,0.000000f);
  glVertex2f(15.093750f,0.000000f);
  glVertex2f(12.390625f,5.328125f);
  glVertex2f(12.344375f,4.676562f);
  glVertex2f(12.205625f,4.071875f);
  glVertex2f(11.974375f,3.514062f);
  glVertex2f(11.738125f,1.105000f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.974375f,3.514062f);
  glVertex2f(11.650625f,3.003125f);
  glVertex2f(11.738125f,1.105000f);
  glVertex2f(11.234375f,2.539063f);
  glVertex2f(10.955625f,0.457500f);
  glVertex2f(10.752500f,2.142500f);
  glVertex2f(10.231875f,1.834063f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.043125f,-0.005000f);
  glVertex2f(10.955625f,0.457500f);
  glVertex2f(10.231875f,1.834063f);
  glVertex2f(9.672500f,1.613750f);
  glVertex2f(9.074375f,1.481562f);
  glVertex2f(9.000625f,-0.282500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.074375f,1.481562f);
  glVertex2f(8.437500f,1.437500f);
  glVertex2f(9.000625f,-0.282500f);
  glVertex2f(7.865625f,1.479687f);
  glVertex2f(7.828125f,-0.375000f);
  glVertex2f(7.325000f,1.606250f);
  glVertex2f(6.815625f,1.817188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.693750f,-0.318750f);
  glVertex2f(7.828125f,-0.375000f);
  glVertex2f(6.815625f,1.817188f);
  glVertex2f(6.337500f,2.112500f);
  glVertex2f(5.890625f,2.492188f);
  glVertex2f(5.690625f,-0.150000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.502500f,2.932500f);
  glVertex2f(5.200625f,3.409688f);
  glVertex2f(5.690625f,-0.150000f);
  glVertex2f(5.890625f,2.492188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.390625f,15.000000f);
  glVertex2f(12.390625f,5.328125f);
  glVertex2f(15.093750f,0.000000f);
  glVertex2f(15.093750f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(2.163750f,4.101250f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,5.125000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(15.593750f,15.000000f);
  glVertex2f(12.750000f,15.000000f);
  glVertex2f(9.437500f,0.000000f);
  glVertex2f(8.203125f,3.312500f);
  glVertex2f(6.656250f,0.000000f);
  glVertex2f(3.609375f,15.000000f);
  glVertex2f(0.437500f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(23.968750f,15.000000f);
  glVertex2f(21.093750f,15.000000f);
  glVertex2f(18.890625f,0.000000f);
  glVertex2f(17.546875f,3.312500f);
  glVertex2f(16.203125f,0.000000f);
  glVertex2f(14.000000f,15.000000f);
  glVertex2f(12.218750f,12.453125f);
  glVertex2f(10.406250f,15.000000f);
  glVertex2f(8.234375f,0.000000f);
  glVertex2f(6.859375f,3.312500f);
  glVertex2f(5.515625f,0.000000f);
  glVertex2f(3.343750f,15.000000f);
  glVertex2f(0.437500f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(0.593750f,0.000000f);
  glVertex2f(3.750000f,0.000000f);
  glVertex2f(6.562500f,7.765625f);
  glVertex2f(8.000000f,5.921875f);
  glVertex2f(8.437500f,9.640625f);
  glVertex2f(12.390625f,0.000000f);
  glVertex2f(9.843750f,7.765625f);
  glVertex2f(15.828125f,0.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.484375f,15.000000f);
  glVertex2f(1.062500f,15.000000f);
  glVertex2f(6.562500f,7.765625f);
  glVertex2f(8.437500f,9.640625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(12.281250f,15.000000f);
  glVertex2f(8.437500f,9.640625f);
  glVertex2f(9.843750f,7.765625f);
  glVertex2f(15.406250f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.077500f,-4.283125f);
  glVertex2f(8.277500f,-3.761250f);
  glVertex2f(8.328125f,3.687500f);
  glVertex2f(8.397500f,-3.448125f);
  glVertex2f(12.687500f,15.000000f);
  glVertex2f(8.437500f,-3.343750f);
  glVertex2f(15.593750f,15.000000f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.328125f,3.687500f);
  glVertex2f(3.609375f,15.000000f);
  glVertex2f(6.859375f,0.000000f);
  glVertex2f(7.437500f,-5.953125f);
  glVertex2f(7.797500f,-5.013750f);
  glVertex2f(8.077500f,-4.283125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(7.437500f,-5.953125f);
  glVertex2f(6.859375f,0.000000f);
  glVertex2f(6.234375f,-1.671875f);
  glVertex2f(5.677500f,-3.213125f);
  glVertex2f(5.244375f,-4.411875f);
  glVertex2f(4.935000f,-5.268125f);
  glVertex2f(4.749375f,-5.781875f);
  glVertex2f(4.687500f,-5.953125f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(6.859375f,0.000000f);
  glVertex2f(3.609375f,15.000000f);
  glVertex2f(0.437500f,15.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.515625f,2.109375f);
  glVertex2f(12.546875f,12.515625f);
  glVertex2f(9.500000f,12.890625f);
  glVertex2f(1.500000f,2.484375f);
  glVertex2f(12.546875f,0.000000f);
  glVertex2f(12.546875f,2.109375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.500000f,12.890625f);
  glVertex2f(12.546875f,12.515625f);
  glVertex2f(12.546875f,15.000000f);
  glVertex2f(2.109375f,15.000000f);
  glVertex2f(2.109375f,12.890625f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(12.546875f,0.000000f);
  glVertex2f(1.500000f,2.484375f);
  glVertex2f(1.500000f,0.000000f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(11.722813f,-4.965625f);
  glVertex2f(11.241250f,-4.909375f);
  glVertex2f(11.414687f,-7.185625f);
  glVertex2f(12.250000f,-7.203125f);
  glVertex2f(12.250000f,-4.984375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.805312f,-4.815625f);
  glVertex2f(10.415000f,-4.684375f);
  glVertex2f(10.646250f,-7.133125f);
  glVertex2f(11.414687f,-7.185625f);
  glVertex2f(11.241250f,-4.909375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.070313f,-4.515625f);
  glVertex2f(9.770625f,-4.316875f);
  glVertex2f(9.944688f,-7.045625f);
  glVertex2f(10.646250f,-7.133125f);
  glVertex2f(10.415000f,-4.684375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.515312f,-4.095625f);
  glVertex2f(9.304375f,-3.851875f);
  glVertex2f(9.310000f,-6.923125f);
  glVertex2f(9.944688f,-7.045625f);
  glVertex2f(9.770625f,-4.316875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.310000f,-6.923125f);
  glVertex2f(9.304375f,-3.851875f);
  glVertex2f(9.137813f,-3.585625f);
  glVertex2f(9.015625f,-3.296875f);
  glVertex2f(8.922500f,-2.988125f);
  glVertex2f(8.843125f,-2.661875f);
  glVertex2f(8.777500f,-2.318125f);
  glVertex2f(8.742188f,-6.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.742188f,-6.765625f);
  glVertex2f(8.777500f,-2.318125f);
  glVertex2f(8.725625f,-1.956875f);
  glVertex2f(8.687500f,-1.578125f);
  glVertex2f(8.663438f,-1.190313f);
  glVertex2f(8.653750f,-0.801875f);
  glVertex2f(8.485625f,3.808750f);
  glVertex2f(8.335625f,4.454062f);
  glVertex2f(8.233125f,-6.546250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.485625f,3.808750f);
  glVertex2f(8.653750f,-0.801875f);
  glVertex2f(8.608125f,3.074062f);
  glVertex2f(8.658438f,-0.412813f);
  glVertex2f(8.703125f,2.250000f);
  glVertex2f(8.677500f,-0.023125f);
  glVertex2f(8.710938f,0.367188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.335625f,4.454062f);
  glVertex2f(8.158125f,5.010000f);
  glVertex2f(8.233125f,-6.546250f);
  glVertex2f(7.953125f,5.476563f);
  glVertex2f(7.774687f,-6.238125f);
  glVertex2f(7.706250f,5.905625f);
  glVertex2f(7.403125f,6.349062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.703125f,-4.781250f);
  glVertex2f(7.009687f,-5.355625f);
  glVertex2f(7.043750f,6.806875f);
  glVertex2f(7.366875f,-5.841250f);
  glVertex2f(7.403125f,6.349062f);
  glVertex2f(7.774687f,-6.238125f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.628125f,7.279062f);
  glVertex2f(6.156250f,7.765625f);
  glVertex2f(6.178125f,-2.731250f);
  glVertex2f(6.267188f,-3.300000f);
  glVertex2f(6.384375f,-3.831250f);
  glVertex2f(6.529687f,-4.325000f);
  glVertex2f(6.703125f,-4.781250f);
  glVertex2f(7.043750f,6.806875f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.156250f,7.765625f);
  glVertex2f(6.628125f,8.263437f);
  glVertex2f(6.233438f,18.899687f);
  glVertex2f(6.143125f,18.339375f);
  glVertex2f(6.117188f,-2.125000f);
  glVertex2f(6.178125f,-2.731250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.015625f,0.742188f);
  glVertex2f(6.024375f,-0.342812f);
  glVertex2f(6.024687f,16.548437f);
  glVertex2f(6.044687f,-0.916250f);
  glVertex2f(6.050313f,17.135937f);
  glVertex2f(6.075625f,-1.510312f);
  glVertex2f(6.085938f,17.742188f);
  glVertex2f(6.117188f,-2.125000f);
  glVertex2f(6.143125f,18.339375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.003438f,15.429688f);
  glVertex2f(6.007813f,14.898438f);
  glVertex2f(6.009062f,15.979688f);
  glVertex2f(6.010000f,14.378438f);
  glVertex2f(6.024687f,16.548437f);
  glVertex2f(6.014375f,1.262500f);
  glVertex2f(6.015625f,0.742188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.703125f,2.250000f);
  glVertex2f(8.710938f,0.367188f);
  glVertex2f(8.738438f,1.884688f);
  glVertex2f(8.743125f,0.755000f);
  glVertex2f(8.756875f,1.513750f);
  glVertex2f(8.758437f,1.137187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(10.805312f,20.393749f);
  glVertex2f(11.241250f,20.487499f);
  glVertex2f(11.437187f,22.779375f);
  glVertex2f(11.722813f,20.543751f);
  glVertex2f(12.250000f,22.796875f);
  glVertex2f(12.250000f,20.562500f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(10.686250f,22.726875f);
  glVertex2f(9.997188f,22.639376f);
  glVertex2f(10.070313f,20.093750f);
  glVertex2f(10.415000f,20.262501f);
  glVertex2f(10.805312f,20.393749f);
  glVertex2f(11.437187f,22.779375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(9.137813f,19.158751f);
  glVertex2f(9.304375f,19.427187f);
  glVertex2f(9.370000f,22.516874f);
  glVertex2f(9.515312f,19.672501f);
  glVertex2f(9.997188f,22.639376f);
  glVertex2f(9.770625f,19.894688f);
  glVertex2f(10.070313f,20.093750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(9.370000f,22.516874f);
  glVertex2f(8.804688f,22.359375f);
  glVertex2f(8.843125f,18.229687f);
  glVertex2f(8.922500f,18.556250f);
  glVertex2f(9.015625f,18.867188f);
  glVertex2f(9.137813f,19.158751f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.804688f,22.359375f);
  glVertex2f(8.293125f,22.139376f);
  glVertex2f(8.335625f,11.110937f);
  glVertex2f(8.485625f,11.759375f);
  glVertex2f(8.663438f,16.773750f);
  glVertex2f(8.687500f,17.156250f);
  glVertex2f(8.725625f,17.529688f);
  glVertex2f(8.777500f,17.887501f);
  glVertex2f(8.843125f,18.229687f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.663438f,16.773750f);
  glVertex2f(8.485625f,11.759375f);
  glVertex2f(8.653750f,16.388750f);
  glVertex2f(8.608125f,12.498438f);
  glVertex2f(8.658438f,16.001249f);
  glVertex2f(8.703125f,13.328125f);
  glVertex2f(8.677500f,15.611250f);
  glVertex2f(8.710938f,15.218750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.043750f,8.744375f);
  glVertex2f(7.403125f,9.208438f);
  glVertex2f(7.406875f,21.429375f);
  glVertex2f(7.706250f,9.655625f);
  glVertex2f(7.827188f,21.829374f);
  glVertex2f(7.953125f,10.085938f);
  glVertex2f(8.293125f,22.139376f);
  glVertex2f(8.158125f,10.553125f);
  glVertex2f(8.335625f,11.110937f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(7.406875f,21.429375f);
  glVertex2f(7.032187f,20.939375f);
  glVertex2f(7.043750f,8.744375f);
  glVertex2f(6.703125f,20.359375f);
  glVertex2f(6.628125f,8.263437f);
  glVertex2f(6.513438f,19.909687f);
  glVertex2f(6.356875f,19.423124f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.743125f,14.828125f);
  glVertex2f(8.710938f,15.218750f);
  glVertex2f(8.738438f,13.693750f);
  glVertex2f(8.756875f,14.065625f);
  glVertex2f(8.758437f,14.443750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.998125f,1.779688f);
  glVertex2f(6.014375f,1.262500f);
  glVertex2f(6.010000f,14.378438f);
  glVertex2f(5.997812f,13.862187f);
  glVertex2f(5.971250f,13.349688f);
  glVertex2f(5.966875f,2.293750f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.406250f,8.875000f);
  glVertex2f(3.019063f,6.533750f);
  glVertex2f(3.030313f,9.051875f);
  glVertex2f(3.570000f,6.335000f);
  glVertex2f(3.590000f,9.270000f);
  glVertex2f(4.059062f,6.091250f);
  glVertex2f(4.085312f,9.529375f);
  glVertex2f(4.486250f,5.802500f);
  glVertex2f(4.516250f,9.830000f);
  glVertex2f(4.851563f,5.468750f);
  glVertex2f(4.882813f,10.171875f);
  glVertex2f(5.159375f,5.097500f);
  glVertex2f(5.190000f,10.548437f);
  glVertex2f(5.414063f,4.696250f);
  glVertex2f(5.442812f,10.953125f);
  glVertex2f(5.615625f,4.265000f);
  glVertex2f(5.641250f,11.385938f);
  glVertex2f(5.764062f,3.803750f);
  glVertex2f(5.785313f,11.846875f);
  glVertex2f(5.859375f,3.312500f);
  glVertex2f(5.875000f,12.335938f);
  glVertex2f(5.920625f,2.804688f);
  glVertex2f(5.930313f,12.840938f);
  glVertex2f(5.966875f,2.293750f);
  glVertex2f(5.971250f,13.349688f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(3.019063f,6.533750f);
  glVertex2f(2.406250f,8.875000f);
  glVertex2f(2.406250f,6.687500f);
  glVertex2f(6.024375f,-0.342812f);
  glVertex2f(6.015625f,0.742188f);
  glVertex2f(6.014688f,0.210000f);
  glVertex2f(8.710938f,15.218750f);
  glVertex2f(8.703125f,13.328125f);
  glVertex2f(8.738438f,13.693750f);
  glVertex2f(6.233438f,18.899687f);
  glVertex2f(6.628125f,8.263437f);
  glVertex2f(6.356875f,19.423124f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.953125f,-7.734375f);
  glVertex2f(5.953125f,23.875000f);
  glVertex2f(4.421875f,23.875000f);
  glVertex2f(4.421875f,-7.734375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.889375f,1.542500f);
  glVertex2f(5.898125f,0.776250f);
  glVertex2f(5.912188f,1.915313f);
  glVertex2f(5.929688f,0.382813f);
  glVertex2f(5.953125f,2.281250f);
  glVertex2f(5.963438f,-0.012500f);
  glVertex2f(6.047812f,3.105313f);
  glVertex2f(5.983438f,-0.404687f);
  glVertex2f(5.989687f,-0.793750f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.500000f,7.828125f);
  glVertex2f(8.022813f,7.330313f);
  glVertex2f(8.102187f,-4.325938f);
  glVertex2f(8.265000f,-3.835000f);
  glVertex2f(8.394688f,-3.308438f);
  glVertex2f(8.491250f,-2.746250f);
  glVertex2f(8.554688f,-2.148438f);
  glVertex2f(8.523438f,17.710938f);
  glVertex2f(8.461250f,18.319374f);
  glVertex2f(8.368438f,18.888437f);
  glVertex2f(8.245000f,19.418125f);
  glVertex2f(8.090938f,19.908438f);
  glVertex2f(8.022813f,8.309688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.940000f,9.683125f);
  glVertex2f(7.242813f,9.237187f);
  glVertex2f(7.263750f,21.429375f);
  glVertex2f(7.603750f,8.779375f);
  glVertex2f(7.611250f,20.939375f);
  glVertex2f(8.022813f,8.309688f);
  glVertex2f(7.906250f,20.359375f);
  glVertex2f(8.090938f,19.908438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.863750f,21.829374f);
  glVertex2f(6.411250f,22.139376f);
  glVertex2f(6.493125f,10.589375f);
  glVertex2f(6.695313f,10.117188f);
  glVertex2f(6.940000f,9.683125f);
  glVertex2f(7.263750f,21.429375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.411250f,22.139376f);
  glVertex2f(5.906250f,22.359375f);
  glVertex2f(5.925625f,17.560312f);
  glVertex2f(5.960938f,17.187500f);
  glVertex2f(5.982187f,16.805000f);
  glVertex2f(5.989687f,16.420000f);
  glVertex2f(6.047812f,12.534688f);
  glVertex2f(6.169375f,11.798125f);
  glVertex2f(6.317812f,11.149688f);
  glVertex2f(6.493125f,10.589375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.906250f,22.359375f);
  glVertex2f(5.341250f,22.516874f);
  glVertex2f(5.351875f,19.432812f);
  glVertex2f(5.518437f,19.168751f);
  glVertex2f(5.640625f,18.882813f);
  glVertex2f(5.733438f,18.577499f);
  glVertex2f(5.811875f,18.255312f);
  glVertex2f(5.875937f,17.916250f);
  glVertex2f(5.925625f,17.560312f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.241250f,20.262501f);
  glVertex2f(4.585938f,20.093750f);
  glVertex2f(4.708750f,22.639376f);
  glVertex2f(4.885625f,19.895313f);
  glVertex2f(5.341250f,22.516874f);
  glVertex2f(5.140937f,19.674999f);
  glVertex2f(5.351875f,19.432812f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(4.008750f,22.726875f);
  glVertex2f(3.241250f,22.779375f);
  glVertex2f(3.415000f,20.487499f);
  glVertex2f(3.850938f,20.393749f);
  glVertex2f(4.241250f,20.262501f);
  glVertex2f(4.708750f,22.639376f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.933438f,20.543751f);
  glVertex2f(3.415000f,20.487499f);
  glVertex2f(3.241250f,22.779375f);
  glVertex2f(2.406250f,22.796875f);
  glVertex2f(2.406250f,20.562500f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.523438f,17.710938f);
  glVertex2f(8.554688f,-2.148438f);
  glVertex2f(8.564375f,17.093437f);
  glVertex2f(8.595625f,-1.542188f);
  glVertex2f(8.593437f,16.497187f);
  glVertex2f(8.605938f,14.315937f);
  glVertex2f(8.610625f,15.922188f);
  glVertex2f(8.609375f,14.835938f);
  glVertex2f(8.615937f,15.368438f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.102187f,-4.325938f);
  glVertex2f(8.022813f,7.330313f);
  glVertex2f(7.906250f,-4.781250f);
  glVertex2f(7.603750f,6.849375f);
  glVertex2f(7.583437f,-5.355625f);
  glVertex2f(7.242813f,6.385313f);
  glVertex2f(7.215000f,-5.841250f);
  glVertex2f(6.940000f,5.938125f);
  glVertex2f(6.800938f,-6.238125f);
  glVertex2f(6.695313f,5.507813f);
  glVertex2f(6.493125f,5.041250f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(6.341250f,-6.546250f);
  glVertex2f(6.800938f,-6.238125f);
  glVertex2f(6.493125f,5.041250f);
  glVertex2f(6.317812f,4.485312f);
  glVertex2f(6.169375f,3.840000f);
  glVertex2f(6.047812f,3.105313f);
  glVertex2f(5.989687f,-0.793750f);
  glVertex2f(5.982187f,-1.179688f);
  glVertex2f(5.960938f,-1.562500f);
  glVertex2f(5.925625f,-1.936250f);
  glVertex2f(5.875937f,-2.295000f);
  glVertex2f(5.835938f,-6.765625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(5.835938f,-6.765625f);
  glVertex2f(5.875937f,-2.295000f);
  glVertex2f(5.811875f,-2.638750f);
  glVertex2f(5.733438f,-2.967500f);
  glVertex2f(5.640625f,-3.281250f);
  glVertex2f(5.518437f,-3.575625f);
  glVertex2f(5.351875f,-3.846250f);
  glVertex2f(5.276250f,-6.923125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.351875f,-3.846250f);
  glVertex2f(5.140937f,-4.093125f);
  glVertex2f(5.276250f,-6.923125f);
  glVertex2f(4.885625f,-4.316250f);
  glVertex2f(4.653438f,-7.045625f);
  glVertex2f(4.585938f,-4.515625f);
  glVertex2f(4.241250f,-4.684375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.967500f,-7.133125f);
  glVertex2f(4.653438f,-7.045625f);
  glVertex2f(4.241250f,-4.684375f);
  glVertex2f(3.850938f,-4.815625f);
  glVertex2f(3.415000f,-4.909375f);
  glVertex2f(3.218437f,-7.185625f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(3.218437f,-7.185625f);
  glVertex2f(3.415000f,-4.909375f);
  glVertex2f(2.933438f,-4.965625f);
  glVertex2f(2.406250f,-4.984375f);
  glVertex2f(2.406250f,-7.203125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.715625f,2.752812f);
  glVertex2f(8.773438f,3.257813f);
  glVertex2f(8.773438f,12.273438f);
  glVertex2f(8.865937f,3.746875f);
  glVertex2f(8.877188f,11.785000f);
  glVertex2f(9.012187f,4.207812f);
  glVertex2f(9.032187f,11.325937f);
  glVertex2f(9.212188f,4.640625f);
  glVertex2f(9.238438f,10.896250f);
  glVertex2f(9.465938f,5.045312f);
  glVertex2f(9.495937f,10.495937f);
  glVertex2f(9.773438f,5.421875f);
  glVertex2f(9.804688f,10.125000f);
  glVertex2f(10.140000f,5.763125f);
  glVertex2f(10.170000f,9.791250f);
  glVertex2f(10.570937f,6.061875f);
  glVertex2f(10.597187f,9.502500f);
  glVertex2f(11.066250f,6.318125f);
  glVertex2f(11.086250f,9.258750f);
  glVertex2f(11.625937f,6.531875f);
  glVertex2f(11.637188f,9.060000f);
  glVertex2f(12.250000f,6.703125f);
  glVertex2f(12.250000f,8.906250f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(8.635938f,1.215312f);
  glVertex2f(8.646875f,1.731562f);
  glVertex2f(8.653438f,13.287188f);
  glVertex2f(8.673437f,2.244062f);
  glVertex2f(8.704375f,12.778438f);
  glVertex2f(8.715625f,2.752812f);
  glVertex2f(8.773438f,12.273438f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.624687f,-0.954688f);
  glVertex2f(8.641875f,-0.385938f);
  glVertex2f(8.635938f,1.215312f);
  glVertex2f(8.653438f,13.287188f);
  glVertex2f(8.620625f,13.799687f);
  glVertex2f(8.605938f,14.315937f);
  glVertex2f(8.595625f,-1.542188f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(8.640625f,0.695313f);
  glVertex2f(8.635938f,1.215312f);
  glVertex2f(8.641875f,-0.385938f);
  glVertex2f(8.647187f,0.164062f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(5.884687f,14.475000f);
  glVertex2f(5.889375f,14.096875f);
  glVertex2f(5.898125f,14.859375f);
  glVertex2f(5.912188f,13.725000f);
  glVertex2f(5.929688f,15.250000f);
  glVertex2f(5.953125f,13.359375f);
  glVertex2f(5.963438f,15.642500f);
  glVertex2f(6.047812f,12.534688f);
  glVertex2f(5.983438f,16.032499f);
  glVertex2f(5.989687f,16.420000f);
  glEnd();
  glBegin(GL_TRIANGLES);
  glVertex2f(5.898125f,0.776250f);
  glVertex2f(5.889375f,1.542500f);
  glVertex2f(5.884687f,1.162812f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(16.031250f,9.468750f);
  glVertex2f(13.296875f,9.468750f);
  glVertex2f(13.728750f,6.693125f);
  glVertex2f(14.328125f,7.109375f);
  glVertex2f(14.876250f,7.573750f);
  glVertex2f(15.320625f,8.041875f);
  glVertex2f(15.661250f,8.513750f);
  glVertex2f(15.898125f,8.989375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(13.728750f,6.693125f);
  glVertex2f(13.296875f,9.468750f);
  glVertex2f(13.130625f,6.369375f);
  glVertex2f(12.881875f,9.013125f);
  glVertex2f(12.533750f,6.138125f);
  glVertex2f(12.449375f,8.658750f);
  glVertex2f(11.999375f,8.405625f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(12.533750f,6.138125f);
  glVertex2f(11.999375f,8.405625f);
  glVertex2f(11.938125f,5.999375f);
  glVertex2f(11.531875f,8.253750f);
  glVertex2f(11.343750f,5.953125f);
  glVertex2f(11.046875f,8.203125f);
  glVertex2f(10.773750f,8.227187f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(11.343750f,5.953125f);
  glVertex2f(10.773750f,8.227187f);
  glVertex2f(10.626875f,5.977188f);
  glVertex2f(10.379375f,8.299375f);
  glVertex2f(9.888750f,6.049375f);
  glVertex2f(9.863750f,8.419687f);
  glVertex2f(9.226875f,8.588125f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(6.161875f,6.939688f);
  glVertex2f(6.794375f,6.771250f);
  glVertex2f(6.871250f,9.189688f);
  glVertex2f(7.546875f,6.554688f);
  glVertex2f(7.660000f,9.021250f);
  glVertex2f(8.348750f,6.338125f);
  glVertex2f(8.468750f,8.804688f);
  glVertex2f(9.129375f,6.169688f);
  glVertex2f(9.226875f,8.588125f);
  glVertex2f(9.888750f,6.049375f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(4.984375f,7.156250f);
  glVertex2f(5.256875f,7.132187f);
  glVertex2f(5.353750f,9.382188f);
  glVertex2f(5.649375f,7.060000f);
  glVertex2f(6.102500f,9.310000f);
  glVertex2f(6.161875f,6.939688f);
  glVertex2f(6.871250f,9.189688f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(3.591250f,6.689375f);
  glVertex2f(4.044375f,6.948750f);
  glVertex2f(4.047812f,9.359375f);
  glVertex2f(4.508750f,7.104375f);
  glVertex2f(4.625000f,9.406250f);
  glVertex2f(4.984375f,7.156250f);
  glVertex2f(5.353750f,9.382188f);
  glEnd();
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(2.290000f,8.656250f);
  glVertex2f(2.718750f,5.859375f);
  glVertex2f(2.880312f,8.984375f);
  glVertex2f(3.149375f,6.326250f);
  glVertex2f(3.466250f,9.218750f);
  glVertex2f(3.591250f,6.689375f);
  glVertex2f(4.047812f,9.359375f);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(2.718750f,5.859375f);
  glVertex2f(2.290000f,8.656250f);
  glVertex2f(1.695313f,8.234375f);
  glVertex2f(1.150000f,7.764375f);
  glVertex2f(0.707813f,7.291875f);
  glVertex2f(0.368750f,6.816875f);
  glVertex2f(0.132813f,6.339375f);
  glVertex2f(0.000000f,5.859375f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  glNewList(++c + charLists, GL_COMPILE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(0.f,  0.f);
  glVertex2f(0.f,  20.f);
  glVertex2f(20.f, 0.f);
  glVertex2f(20.f, 20.f);
  glEnd();
  glTranslatef(font_charwidths[c], 0.0f, 0.0f);
  glEndList();

  return charLists;
}
#ifdef _WIN32
#pragma optimize("", on)
#endif
